import{s as $m,n as Pm,o as wm}from"../chunks/scheduler.85c25b89.js";import{S as Cm,i as ym,g as n,s as o,r as s,A as km,h as r,f as l,c as a,j as u,u as d,x as i,k as h,y as t,a as v,v as c,d as m,t as p,w as g}from"../chunks/index.c142fe32.js";import{D as f}from"../chunks/Docstring.d3e0bcd1.js";import{H as F,E as Dm}from"../chunks/EditOnGithub.a592e7aa.js";function Nm(kd){let te,Yn,Qn,er,Xe,tr,Ye,Dd=`At TRL we support PPO (Proximal Policy Optimisation) with an implementation that largely follows  the structure introduced in the paper “Fine-Tuning Language Models from Human Preferences” by D. Ziegler et al. [<a href="https://huggingface.co/papers/1909.08593" rel="nofollow">paper</a>, <a href="https://github.com/openai/lm-human-preferences" rel="nofollow">code</a>].
The Trainer and model classes are largely inspired from <code>transformers.Trainer</code> and <code>transformers.AutoModel</code> classes and adapted for RL.
We also support a <code>RewardTrainer</code> that can be used to train a reward model.`,or,et,ar,R,tt,Nl,Uo,Nd='Configuration class for the <a href="/docs/trl/main/en/cpo_trainer#trl.CPOTrainer">CPOTrainer</a>.',Fl,Ho,Fd=`Using <a href="https://huggingface.co/docs/transformers/main/en/internal/trainer_utils#transformers.HfArgumentParser" rel="nofollow">HfArgumentParser</a> we can turn this class into
<a href="https://docs.python.org/3/library/argparse#module-argparse" rel="nofollow">argparse</a> arguments that can be specified on the
command line.`,nr,ot,rr,T,at,Ll,Ao,Ld="Initialize CPOTrainer.",zl,ne,nt,ql,Ko,zd=`Llama tokenizer does satisfy <code>enc(a + b) = enc(a) + enc(b)</code>.
It does ensure <code>enc(a + b) = enc(a) + enc(a + b)[len(enc(a)):]</code>.
Reference:
<a href="https://github.com/EleutherAI/lm-evaluation-harness/pull/531#issuecomment-1595586257" rel="nofollow">https://github.com/EleutherAI/lm-evaluation-harness/pull/531#issuecomment-1595586257</a>`,Ml,j,rt,Il,So,qd="Run the given model on the given batch of inputs, concatenating the chosen and rejected inputs together.",Rl,jo,Md="We do this to avoid doing two forward passes, because it’s faster for FSDP.",El,re,lt,Ul,Vo,Id="Concatenate the chosen and rejected inputs into a single tensor.",Hl,le,it,Al,Wo,Rd="Compute the CPO loss for a batch of policy and reference model log probabilities.",Kl,V,st,Sl,Bo,Ed=`Overriding built-in evaluation loop to store metrics for each batch.
Prediction/evaluation loop, shared by <code>Trainer.evaluate()</code> and <code>Trainer.predict()</code>.`,jl,Go,Ud="Works both with or without labels.",Vl,ie,dt,Wl,Jo,Hd="Compute the log probabilities of the given labels under the given logits.",Bl,se,ct,Gl,Zo,Ad="Compute the CPO loss and other metrics for the given batch of inputs for train or test.",Jl,de,mt,Zl,Qo,Kd="Generate samples from the model and reference model for the given batch of inputs.",Ql,ce,pt,Xl,Xo,Sd="Log <code>logs</code> on the various objects watching training, including stored metrics.",Yl,L,gt,ei,Yo,jd="Tokenize a single row from a CPO specific dataset.",ti,ea,Vd=`At this stage, we don’t convert to PyTorch tensors yet; we just handle the truncation
in case the prompt + chosen or prompt + rejected responses is/are too long. First
we truncate the prompt; if we’re still too long, we truncate the chosen/rejected.`,oi,ta,Wd=`We also create the labels for the chosen/rejected responses, which are of length equal to
the sum of the length of the prompt and the chosen/rejected response, with
label_pad_token_id  for the prompt tokens.`,lr,_t,ir,E,ut,ai,oa,Bd='Configuration class for the <a href="/docs/trl/main/en/trainer#trl.DDPOTrainer">DDPOTrainer</a>.',ni,aa,Gd=`Using <a href="https://huggingface.co/docs/transformers/main/en/internal/trainer_utils#transformers.HfArgumentParser" rel="nofollow">HfArgumentParser</a> we can turn this class into
<a href="https://docs.python.org/3/library/argparse#module-argparse" rel="nofollow">argparse</a> arguments that can be specified on the
command line.`,sr,ht,dr,D,ft,ri,na,Jd=`The DDPOTrainer uses Deep Diffusion Policy Optimization to optimise diffusion models.
Note, this trainer is heavily inspired by the work here: <a href="https://github.com/kvablack/ddpo-pytorch" rel="nofollow">https://github.com/kvablack/ddpo-pytorch</a>
As of now only Stable Diffusion based pipelines are supported`,li,me,vt,ii,ra,Zd="Calculate the loss for a batch of an unpacked sample",si,pe,bt,di,la,Qd="Creates and saves a model card for a TRL model.",ci,z,Ot,mi,ia,Xd="Perform a single step of training.",pi,sa,Yd="Side Effects:",gi,da,ec="<li>Model weights are updated</li> <li>Logs the statistics to the accelerator trackers.</li> <li>If <code>self.image_samples_callback</code> is not None, it will be called with the prompt_image_pairs, global_step, and the accelerator tracker.</li>",_i,ge,Tt,ui,ca,tc="Train the model for a given number of epochs",cr,xt,mr,b,$t,hi,ma,oc="Initialize DPOTrainer.",fi,_e,Pt,vi,pa,ac="Computes log probabilities of the reference model for a single padded batch of a DPO specific dataset.",bi,W,wt,Oi,ga,nc="Run the given model on the given batch of inputs, concatenating the chosen and rejected inputs together.",Ti,_a,rc="We do this to avoid doing two forward passes, because it’s faster for FSDP.",xi,ue,Ct,$i,ua,lc="Concatenate the chosen and rejected inputs into a single tensor.",Pi,he,yt,wi,ha,ic="Compute the DPO loss for a batch of policy and reference model log probabilities.",Ci,B,kt,yi,fa,sc=`Overriding built-in evaluation loop to store metrics for each batch.
Prediction/evaluation loop, shared by <code>Trainer.evaluate()</code> and <code>Trainer.predict()</code>.`,ki,va,dc="Works both with or without labels.",Di,fe,Dt,Ni,ba,cc="Compute the log probabilities of the given labels under the given logits.",Fi,ve,Nt,Li,Oa,mc="Compute the DPO loss and other metrics for the given batch of inputs for train or test.",zi,be,Ft,qi,Ta,pc="Generate samples from the model and reference model for the given batch of inputs.",Mi,G,Lt,Ii,xa,gc="Returns the evaluation <code>~torch.utils.data.DataLoader</code>.",Ri,$a,_c="Subclass of transformers.src.transformers.trainer.get_eval_dataloader to precompute <code>ref_log_probs</code>.",Ei,J,zt,Ui,Pa,uc="Returns the training <code>~torch.utils.data.DataLoader</code>.",Hi,wa,hc="Subclass of transformers.src.transformers.trainer.get_train_dataloader to precompute <code>ref_log_probs</code>.",Ai,Oe,qt,Ki,Ca,fc="Log <code>logs</code> on the various objects watching training, including stored metrics.",Si,Te,Mt,ji,ya,vc="Context manager for handling null reference model (that is, peft adapter manipulation).",pr,It,gr,U,Rt,Vi,ka,bc="The IterativeSFTTrainer can be used to finetune models with methods that requires some steps between optimization.",Wi,xe,Et,Bi,Da,Oc="Run an optimisation step given a list of input_ids, attention_mask, and labels or a list of text and text_labels.",_r,Ut,ur,H,Ht,Gi,Na,Tc='Configuration class for the <a href="/docs/trl/main/en/trainer#trl.KTOTrainer">KTOTrainer</a>.',Ji,Fa,xc=`Using <a href="https://huggingface.co/docs/transformers/main/en/internal/trainer_utils#transformers.HfArgumentParser" rel="nofollow">HfArgumentParser</a> we can turn this class into
<a href="https://docs.python.org/3/library/argparse#module-argparse" rel="nofollow">argparse</a> arguments that can be specified on the
command line.`,hr,At,fr,x,Kt,Zi,La,$c="Initialize KTOTrainer.",Qi,$e,St,Xi,za,Pc="Computes log probabilities of the reference model for a single padded batch of a KTO specific dataset.",Yi,Z,jt,es,qa,wc=`Overriding built-in evaluation loop to store metrics for each batch.
Prediction/evaluation loop, shared by <code>Trainer.evaluate()</code> and <code>Trainer.predict()</code>.`,ts,Ma,Cc="Works both with or without labels.",os,Pe,Vt,as,Ia,yc="Compute the log probabilities of the given labels under the given logits.",ns,we,Wt,rs,Ra,kc="Compute the KTO loss and other metrics for the given batch of inputs for train or test.",ls,Ce,Bt,is,Ea,Dc="Generate samples from the model and reference model for the given batch of inputs.",ss,Q,Gt,ds,Ua,Nc="Returns the evaluation <code>~torch.utils.data.DataLoader</code>.",cs,Ha,Fc="Subclass of transformers.src.transformers.trainer.get_eval_dataloader to precompute <code>ref_log_probs</code>.",ms,X,Jt,ps,Aa,Lc="Returns the training <code>~torch.utils.data.DataLoader</code>.",gs,Ka,zc="Subclass of transformers.src.transformers.trainer.get_train_dataloader to precompute <code>ref_log_probs</code>.",_s,ye,Zt,us,Sa,qc="Compute the KTO loss for a batch of policy and reference model log probabilities.",hs,ke,Qt,fs,ja,Mc="Log <code>logs</code> on the various objects watching training, including stored metrics.",vs,De,Xt,bs,Va,Ic="Context manager for handling null reference model (that is, peft adapter manipulation).",vr,Yt,br,A,eo,Os,Wa,Rc='Configuration class for the <a href="/docs/trl/main/en/trainer#trl.ORPOTrainer">ORPOTrainer</a>.',Ts,Ba,Ec=`Using <a href="https://huggingface.co/docs/transformers/main/en/internal/trainer_utils#transformers.HfArgumentParser" rel="nofollow">HfArgumentParser</a> we can turn this class into
<a href="https://docs.python.org/3/library/argparse#module-argparse" rel="nofollow">argparse</a> arguments that can be specified on the
command line.`,Or,to,Tr,$,oo,xs,Ga,Uc="Initialize ORPOTrainer.",$s,Ne,ao,Ps,Ja,Hc=`Llama tokenizer does satisfy <code>enc(a + b) = enc(a) + enc(b)</code>.
It does ensure <code>enc(a + b) = enc(a) + enc(a + b)[len(enc(a)):]</code>.
Reference:
<a href="https://github.com/EleutherAI/lm-evaluation-harness/pull/531#issuecomment-1595586257" rel="nofollow">https://github.com/EleutherAI/lm-evaluation-harness/pull/531#issuecomment-1595586257</a>`,ws,Y,no,Cs,Za,Ac="Run the given model on the given batch of inputs, concatenating the chosen and rejected inputs together.",ys,Qa,Kc="We do this to avoid doing two forward passes, because it’s faster for FSDP.",ks,Fe,ro,Ds,Xa,Sc="Concatenate the chosen and rejected inputs into a single tensor.",Ns,ee,lo,Fs,Ya,jc=`Overriding built-in evaluation loop to store metrics for each batch.
Prediction/evaluation loop, shared by <code>Trainer.evaluate()</code> and <code>Trainer.predict()</code>.`,Ls,en,Vc="Works both with or without labels.",zs,Le,io,qs,tn,Wc="Compute the log probabilities of the given labels under the given logits.",Ms,ze,so,Is,on,Bc="Compute the ORPO loss and other metrics for the given batch of inputs for train or test.",Rs,qe,co,Es,an,Gc="Generate samples from the model and reference model for the given batch of inputs.",Us,Me,mo,Hs,nn,Jc="Log <code>logs</code> on the various objects watching training, including stored metrics.",As,Ie,po,Ks,rn,Zc="Compute ORPO’s odds ratio (OR) loss for a batch of policy and reference model log probabilities.",Ss,q,go,js,ln,Qc="Tokenize a single row from a ORPO specific dataset.",Vs,sn,Xc=`At this stage, we don’t convert to PyTorch tensors yet; we just handle the truncation
in case the prompt + chosen or prompt + rejected responses is/are too long. First
we truncate the prompt; if we’re still too long, we truncate the chosen/rejected.`,Ws,dn,Yc=`We also create the labels for the chosen/rejected responses, which are of length equal to
the sum of the length of the prompt and the chosen/rejected response, with
label_pad_token_id  for the prompt tokens.`,xr,_o,$r,K,uo,Bs,cn,em='Configuration class for the <a href="/docs/trl/main/en/ppo_trainer#trl.PPOTrainer">PPOTrainer</a>.',Gs,mn,tm=`Using <a href="https://huggingface.co/docs/transformers/main/en/internal/trainer_utils#transformers.HfArgumentParser" rel="nofollow">HfArgumentParser</a> we can turn this class into
<a href="https://docs.python.org/3/library/argparse#module-argparse" rel="nofollow">argparse</a> arguments that can be specified on the
command line.`,Pr,ho,wr,O,fo,Js,pn,om=`The PPOTrainer uses Proximal Policy Optimization to optimise language models.
Note, this trainer is heavily inspired by the original OpenAI learning to summarize work here:
<a href="https://github.com/openai/summarize-from-feedback" rel="nofollow">https://github.com/openai/summarize-from-feedback</a>`,Zs,Re,vo,Qs,gn,am="Calculate model outputs in multiple batches.",Xs,Ee,bo,Ys,_n,nm="Compute per token rewards from scores and KL-penalty.",ed,Ue,Oo,td,un,rm="Creates and saves a model card for a TRL model.",od,He,To,ad,hn,lm="Gather stats from all processes. Useful in the context of distributed training.",nd,Ae,xo,rd,fn,im=`Generate response with the model given the query tensor.
call the <code>generate</code> method of the model.`,ld,Ke,$o,id,vn,sm="A function that logs all the training stats. Call it at the end of each epoch.",sd,Se,Po,dd,bn,dm="Calculate policy and value losses.",cd,je,wo,md,On,cm="Prepare the dataloader for training.",pd,Ve,Co,gd,Tn,mm="Record training step statistics.",_d,We,yo,ud,xn,pm="Run a PPO optimisation step given a list of queries, model responses, and rewards.",hd,Be,ko,fd,$n,gm="Train one PPO minibatch",Cr,Do,yr,S,No,vd,Pn,_m='Configuration class for the <a href="/docs/trl/main/en/reward_trainer#trl.RewardTrainer">RewardTrainer</a>.',bd,wn,um=`Using <a href="https://huggingface.co/docs/transformers/main/en/internal/trainer_utils#transformers.HfArgumentParser" rel="nofollow">HfArgumentParser</a> we can turn this class into
<a href="https://docs.python.org/3/library/argparse#module-argparse" rel="nofollow">argparse</a> arguments that can be specified on the
command line.`,kr,Fo,Dr,N,Lo,Od,Cn,hm=`The RewardTrainer can be used to train your custom Reward Model. It is a subclass of the
<code>transformers.Trainer</code> class and inherits all of its attributes and methods. It is recommended to use
an <code>AutoModelForSequenceClassification</code> as the reward model. The reward model should be trained on a dataset
of paired examples, where each example is a tuple of two sequences. The reward model should be trained to
predict which example in the pair is more relevant to the task at hand.`,Td,yn,fm=`The reward trainer expects a very specific format for the dataset. The dataset should contain two 4 entries at least
if you don’t use the default <code>RewardDataCollatorWithPadding</code> data collator. The entries should be named`,xd,kn,vm="<li><code>input_ids_chosen</code></li> <li><code>attention_mask_chosen</code></li> <li><code>input_ids_rejected</code></li> <li><code>attention_mask_rejected</code></li>",$d,Dn,bm=`Optionally, you can also pass a <code>margin</code> entry to the dataset. This entry should contain the margin used to modulate the
loss of the reward model as outlined in <a href="https://ai.meta.com/research/publications/llama-2-open-foundation-and-fine-tuned-chat-models/" rel="nofollow">https://ai.meta.com/research/publications/llama-2-open-foundation-and-fine-tuned-chat-models/</a>.
If you don’t pass a margin, no margin will be used.`,Pd,Ge,zo,wd,Nn,Om="Visualize the reward model logits prediction",Nr,qo,Fr,oe,Mo,Cd,Fn,Tm=`Class definition of the Supervised Finetuning Trainer (SFT Trainer).
This class is a wrapper around the <code>transformers.Trainer</code> class and inherits all of its attributes and methods.
The trainer takes care of properly initializing the PeftModel in case a user passes a <code>PeftConfig</code> object.`,Lr,Io,zr,ae,Ro,yd,Ln,xm="Helper function for reproducible behavior to set the seed in <code>random</code>, <code>numpy</code>, and <code>torch</code>.",qr,Eo,Mr,Xn,Ir;return Xe=new F({props:{title:"Trainer",local:"trainer",headingTag:"h1"}}),et=new F({props:{title:"CPOConfig",local:"trl.CPOConfig",headingTag:"h2"}}),tt=new f({props:{name:"class trl.CPOConfig",anchor:"trl.CPOConfig",parameters:[{name:"output_dir",val:": str"},{name:"overwrite_output_dir",val:": bool = False"},{name:"do_train",val:": bool = False"},{name:"do_eval",val:": bool = False"},{name:"do_predict",val:": bool = False"},{name:"eval_strategy",val:": Union = 'no'"},{name:"prediction_loss_only",val:": bool = False"},{name:"per_device_train_batch_size",val:": int = 8"},{name:"per_device_eval_batch_size",val:": int = 8"},{name:"per_gpu_train_batch_size",val:": Optional = None"},{name:"per_gpu_eval_batch_size",val:": Optional = None"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"eval_accumulation_steps",val:": Optional = None"},{name:"eval_delay",val:": Optional = 0"},{name:"torch_empty_cache_steps",val:": Optional = None"},{name:"learning_rate",val:": float = 5e-05"},{name:"weight_decay",val:": float = 0.0"},{name:"adam_beta1",val:": float = 0.9"},{name:"adam_beta2",val:": float = 0.999"},{name:"adam_epsilon",val:": float = 1e-08"},{name:"max_grad_norm",val:": float = 1.0"},{name:"num_train_epochs",val:": float = 3.0"},{name:"max_steps",val:": int = -1"},{name:"lr_scheduler_type",val:": Union = 'linear'"},{name:"lr_scheduler_kwargs",val:": Union = <factory>"},{name:"warmup_ratio",val:": float = 0.0"},{name:"warmup_steps",val:": int = 0"},{name:"log_level",val:": Optional = 'passive'"},{name:"log_level_replica",val:": Optional = 'warning'"},{name:"log_on_each_node",val:": bool = True"},{name:"logging_dir",val:": Optional = None"},{name:"logging_strategy",val:": Union = 'steps'"},{name:"logging_first_step",val:": bool = False"},{name:"logging_steps",val:": float = 500"},{name:"logging_nan_inf_filter",val:": bool = True"},{name:"save_strategy",val:": Union = 'steps'"},{name:"save_steps",val:": float = 500"},{name:"save_total_limit",val:": Optional = None"},{name:"save_safetensors",val:": Optional = True"},{name:"save_on_each_node",val:": bool = False"},{name:"save_only_model",val:": bool = False"},{name:"restore_callback_states_from_checkpoint",val:": bool = False"},{name:"no_cuda",val:": bool = False"},{name:"use_cpu",val:": bool = False"},{name:"use_mps_device",val:": bool = False"},{name:"seed",val:": int = 42"},{name:"data_seed",val:": Optional = None"},{name:"jit_mode_eval",val:": bool = False"},{name:"use_ipex",val:": bool = False"},{name:"bf16",val:": bool = False"},{name:"fp16",val:": bool = False"},{name:"fp16_opt_level",val:": str = 'O1'"},{name:"half_precision_backend",val:": str = 'auto'"},{name:"bf16_full_eval",val:": bool = False"},{name:"fp16_full_eval",val:": bool = False"},{name:"tf32",val:": Optional = None"},{name:"local_rank",val:": int = -1"},{name:"ddp_backend",val:": Optional = None"},{name:"tpu_num_cores",val:": Optional = None"},{name:"tpu_metrics_debug",val:": bool = False"},{name:"debug",val:": Union = ''"},{name:"dataloader_drop_last",val:": bool = False"},{name:"eval_steps",val:": Optional = None"},{name:"dataloader_num_workers",val:": int = 0"},{name:"dataloader_prefetch_factor",val:": Optional = None"},{name:"past_index",val:": int = -1"},{name:"run_name",val:": Optional = None"},{name:"disable_tqdm",val:": Optional = None"},{name:"remove_unused_columns",val:": Optional = True"},{name:"label_names",val:": Optional = None"},{name:"load_best_model_at_end",val:": Optional = False"},{name:"metric_for_best_model",val:": Optional = None"},{name:"greater_is_better",val:": Optional = None"},{name:"ignore_data_skip",val:": bool = False"},{name:"fsdp",val:": Union = ''"},{name:"fsdp_min_num_params",val:": int = 0"},{name:"fsdp_config",val:": Union = None"},{name:"fsdp_transformer_layer_cls_to_wrap",val:": Optional = None"},{name:"accelerator_config",val:": Union = None"},{name:"deepspeed",val:": Union = None"},{name:"label_smoothing_factor",val:": float = 0.0"},{name:"optim",val:": Union = 'adamw_torch'"},{name:"optim_args",val:": Optional = None"},{name:"adafactor",val:": bool = False"},{name:"group_by_length",val:": bool = False"},{name:"length_column_name",val:": Optional = 'length'"},{name:"report_to",val:": Union = None"},{name:"ddp_find_unused_parameters",val:": Optional = None"},{name:"ddp_bucket_cap_mb",val:": Optional = None"},{name:"ddp_broadcast_buffers",val:": Optional = None"},{name:"dataloader_pin_memory",val:": bool = True"},{name:"dataloader_persistent_workers",val:": bool = False"},{name:"skip_memory_metrics",val:": bool = True"},{name:"use_legacy_prediction_loop",val:": bool = False"},{name:"push_to_hub",val:": bool = False"},{name:"resume_from_checkpoint",val:": Optional = None"},{name:"hub_model_id",val:": Optional = None"},{name:"hub_strategy",val:": Union = 'every_save'"},{name:"hub_token",val:": Optional = None"},{name:"hub_private_repo",val:": bool = False"},{name:"hub_always_push",val:": bool = False"},{name:"gradient_checkpointing",val:": bool = False"},{name:"gradient_checkpointing_kwargs",val:": Union = None"},{name:"include_inputs_for_metrics",val:": bool = False"},{name:"eval_do_concat_batches",val:": bool = True"},{name:"fp16_backend",val:": str = 'auto'"},{name:"evaluation_strategy",val:": Union = None"},{name:"push_to_hub_model_id",val:": Optional = None"},{name:"push_to_hub_organization",val:": Optional = None"},{name:"push_to_hub_token",val:": Optional = None"},{name:"mp_parameters",val:": str = ''"},{name:"auto_find_batch_size",val:": bool = False"},{name:"full_determinism",val:": bool = False"},{name:"torchdynamo",val:": Optional = None"},{name:"ray_scope",val:": Optional = 'last'"},{name:"ddp_timeout",val:": Optional = 1800"},{name:"torch_compile",val:": bool = False"},{name:"torch_compile_backend",val:": Optional = None"},{name:"torch_compile_mode",val:": Optional = None"},{name:"dispatch_batches",val:": Optional = None"},{name:"split_batches",val:": Optional = None"},{name:"include_tokens_per_second",val:": Optional = False"},{name:"include_num_input_tokens_seen",val:": Optional = False"},{name:"neftune_noise_alpha",val:": Optional = None"},{name:"optim_target_modules",val:": Union = None"},{name:"batch_eval_metrics",val:": bool = False"},{name:"eval_on_start",val:": bool = False"},{name:"use_liger_kernel",val:": Optional = False"},{name:"eval_use_gather_object",val:": Optional = False"},{name:"max_length",val:": Optional = None"},{name:"max_prompt_length",val:": Optional = None"},{name:"max_completion_length",val:": Optional = None"},{name:"beta",val:": float = 0.1"},{name:"label_smoothing",val:": float = 0.0"},{name:"loss_type",val:": Literal = 'sigmoid'"},{name:"disable_dropout",val:": bool = True"},{name:"cpo_alpha",val:": float = 1.0"},{name:"simpo_gamma",val:": float = 0.5"},{name:"label_pad_token_id",val:": int = -100"},{name:"padding_value",val:": Optional = None"},{name:"truncation_mode",val:": str = 'keep_end'"},{name:"generate_during_eval",val:": bool = False"},{name:"is_encoder_decoder",val:": Optional = None"},{name:"model_init_kwargs",val:": Optional = None"},{name:"dataset_num_proc",val:": Optional = None"}],parametersDescription:[{anchor:"trl.CPOConfig.max_length",description:`<strong>max_length</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Maximum length of the sequences (prompt + completion) in the batch. This argument is required if you want
to use the default data collator.`,name:"max_length"},{anchor:"trl.CPOConfig.max_prompt_length",description:`<strong>max_prompt_length</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Maximum length of the prompt. This argument is required if you want to use the default data collator.`,name:"max_prompt_length"},{anchor:"trl.CPOConfig.max_completion_length",description:`<strong>max_completion_length</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Maximum length of the completion. This argument is required if you want to use the default data collator
and your model is an encoder-decoder.`,name:"max_completion_length"},{anchor:"trl.CPOConfig.beta",description:`<strong>beta</strong> (<code>float</code>, <em>optional</em>, defaults to <code>0.1</code>) &#x2014;
Parameter controlling the deviation from the reference model. Higher &#x3B2; means less deviation from the
reference model. For the IPO loss (<code>loss_type=&quot;ipo&quot;</code>), &#x3B2; is the regularization parameter denoted by &#x3C4; in
the <a href="https://huggingface.co/papers/2310.12036" rel="nofollow">paper</a>.`,name:"beta"},{anchor:"trl.CPOConfig.label_smoothing",description:`<strong>label_smoothing</strong> (<code>float</code>, <em>optional</em>, defaults to <code>0.0</code>) &#x2014;
Label smoothing factor. This argument is required if you want to use the default data collator.`,name:"label_smoothing"},{anchor:"trl.CPOConfig.loss_type",description:`<strong>loss_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;sigmoid&quot;</code>) &#x2014;
Type of loss to use. Possible values are:</p>
<ul>
<li><code>&quot;sigmoid&quot;</code>: sigmoid loss from the original <a href="https://huggingface.co/papers/2305.18290" rel="nofollow">DPO</a> paper.</li>
<li><code>&quot;hinge&quot;</code>: hinge loss on the normalized likelihood from the <a href="https://huggingface.co/papers/2305.10425" rel="nofollow">SLiC</a> paper.</li>
<li><code>&quot;ipo&quot;</code>: IPO loss from the <a href="https://huggingface.co/papers/2310.12036" rel="nofollow">IPO</a> paper.</li>
<li><code>&quot;simpo&quot;</code>: SimPO loss from the <a href="https://huggingface.co/papers/2405.14734" rel="nofollow">SimPO</a> paper.</li>
</ul>`,name:"loss_type"},{anchor:"trl.CPOConfig.disable_dropout",description:`<strong>disable_dropout</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to disable dropout in the model.`,name:"disable_dropout"},{anchor:"trl.CPOConfig.cpo_alpha",description:`<strong>cpo_alpha</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1.0</code>) &#x2014;
Weight of the BC regularizer in CPO training.`,name:"cpo_alpha"},{anchor:"trl.CPOConfig.simpo_gamma",description:`<strong>simpo_gamma</strong> (<code>float</code>, <em>optional</em>, defaults to <code>0.5</code>) &#x2014;
Target reward margin for the SimPO loss, used only when the <code>loss_type=&quot;simpo&quot;</code>.`,name:"simpo_gamma"},{anchor:"trl.CPOConfig.label_pad_token_id",description:`<strong>label_pad_token_id</strong> (<code>int</code>, <em>optional</em>, defaults to <code>-100</code>) &#x2014;
Label pad token id. This argument is required if you want to use the default data collator.`,name:"label_pad_token_id"},{anchor:"trl.CPOConfig.padding_value",description:`<strong>padding_value</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Padding value to use. If <code>None</code>, the padding value of the tokenizer is used.`,name:"padding_value"},{anchor:"trl.CPOConfig.truncation_mode",description:`<strong>truncation_mode</strong> (<code>str</code>,<em>optional</em>,  defaults to <code>&quot;keep_end&quot;</code>) &#x2014;
Truncation mode to use when the prompt is too long. Possible values are <code>&quot;keep_end&quot;</code> or <code>&quot;keep_start&quot;</code>.
This argument is required if you want to use the default data collator.`,name:"truncation_mode"},{anchor:"trl.CPOConfig.generate_during_eval",description:`<strong>generate_during_eval</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
If <code>True</code>, generates and logs completions from the model to W&amp;B during evaluation.`,name:"generate_during_eval"},{anchor:"trl.CPOConfig.is_encoder_decoder",description:`<strong>is_encoder_decoder</strong> (<code>Optional[bool]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
When using the <code>model_init</code> argument (callable) to instantiate the model instead of the <code>model</code> argument,
you need to specify if the model returned by the callable is an encoder-decoder model.`,name:"is_encoder_decoder"},{anchor:"trl.CPOConfig.model_init_kwargs",description:`<strong>model_init_kwargs</strong> (<code>Optional[Dict[str, Any]]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Keyword arguments to pass to <code>AutoModelForCausalLM.from_pretrained</code> when instantiating the model from a
string.`,name:"model_init_kwargs"},{anchor:"trl.CPOConfig.dataset_num_proc",description:`<strong>dataset_num_proc</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Number of processes to use for processing the dataset.`,name:"dataset_num_proc"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_config.py#L20"}}),ot=new F({props:{title:"CPOTrainer",local:"trl.CPOTrainer",headingTag:"h2"}}),at=new f({props:{name:"class trl.CPOTrainer",anchor:"trl.CPOTrainer",parameters:[{name:"model",val:": Union = None"},{name:"args",val:": Optional = None"},{name:"data_collator",val:": Optional = None"},{name:"train_dataset",val:": Optional = None"},{name:"eval_dataset",val:": Union = None"},{name:"tokenizer",val:": Optional = None"},{name:"model_init",val:": Optional = None"},{name:"callbacks",val:": Optional = None"},{name:"optimizers",val:": Tuple = (None, None)"},{name:"preprocess_logits_for_metrics",val:": Optional = None"},{name:"peft_config",val:": Optional = None"},{name:"compute_metrics",val:": Optional = None"}],parametersDescription:[{anchor:"trl.CPOTrainer.model",description:`<strong>model</strong> (<code>transformers.PreTrainedModel</code>) &#x2014;
The model to train, preferably an <code>AutoModelForSequenceClassification</code>.`,name:"model"},{anchor:"trl.CPOTrainer.args",description:`<strong>args</strong> (<code>CPOConfig</code>) &#x2014;
The CPO config arguments to use for training.`,name:"args"},{anchor:"trl.CPOTrainer.data_collator",description:`<strong>data_collator</strong> (<code>transformers.DataCollator</code>) &#x2014;
The data collator to use for training. If None is specified, the default data collator (<code>DPODataCollatorWithPadding</code>) will be used
which will pad the sequences to the maximum length of the sequences in the batch, given a dataset of paired sequences.`,name:"data_collator"},{anchor:"trl.CPOTrainer.train_dataset",description:`<strong>train_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for training.`,name:"train_dataset"},{anchor:"trl.CPOTrainer.eval_dataset",description:`<strong>eval_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for evaluation.`,name:"eval_dataset"},{anchor:"trl.CPOTrainer.tokenizer",description:`<strong>tokenizer</strong> (<code>transformers.PreTrainedTokenizerBase</code>) &#x2014;
The tokenizer to use for training. This argument is required if you want to use the default data collator.`,name:"tokenizer"},{anchor:"trl.CPOTrainer.model_init",description:`<strong>model_init</strong> (<code>Callable[[], transformers.PreTrainedModel]</code>) &#x2014;
The model initializer to use for training. If None is specified, the default model initializer will be used.`,name:"model_init"},{anchor:"trl.CPOTrainer.callbacks",description:`<strong>callbacks</strong> (<code>List[transformers.TrainerCallback]</code>) &#x2014;
The callbacks to use for training.`,name:"callbacks"},{anchor:"trl.CPOTrainer.optimizers",description:`<strong>optimizers</strong> (<code>Tuple[torch.optim.Optimizer, torch.optim.lr_scheduler.LambdaLR]</code>) &#x2014;
The optimizer and scheduler to use for training.`,name:"optimizers"},{anchor:"trl.CPOTrainer.preprocess_logits_for_metrics",description:`<strong>preprocess_logits_for_metrics</strong> (<code>Callable[[torch.Tensor, torch.Tensor], torch.Tensor]</code>) &#x2014;
The function to use to preprocess the logits before computing the metrics.`,name:"preprocess_logits_for_metrics"},{anchor:"trl.CPOTrainer.peft_config",description:`<strong>peft_config</strong> (<code>Dict</code>, defaults to <code>None</code>) &#x2014;
The PEFT configuration to use for training. If you pass a PEFT configuration, the model will be wrapped in a PEFT model.`,name:"peft_config"},{anchor:"trl.CPOTrainer.compute_metrics",description:`<strong>compute_metrics</strong> (<code>Callable[[EvalPrediction], Dict]</code>, <em>optional</em>) &#x2014;
The function to use to compute the metrics. Must take a <code>EvalPrediction</code> and return
a dictionary string to metric values.`,name:"compute_metrics"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L58"}}),nt=new f({props:{name:"build_tokenized_answer",anchor:"trl.CPOTrainer.build_tokenized_answer",parameters:[{name:"prompt",val:""},{name:"answer",val:""}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L326"}}),rt=new f({props:{name:"concatenated_forward",anchor:"trl.CPOTrainer.concatenated_forward",parameters:[{name:"model",val:": Module"},{name:"batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L673"}}),lt=new f({props:{name:"concatenated_inputs",anchor:"trl.CPOTrainer.concatenated_inputs",parameters:[{name:"batch",val:": Dict"},{name:"is_encoder_decoder",val:": bool = False"},{name:"label_pad_token_id",val:": int = -100"},{name:"padding_value",val:": int = 0"},{name:"device",val:": Optional = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L522",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A dictionary containing the concatenated inputs under the key ‘concatenated_input_ids’.</p>
`}}),it=new f({props:{name:"cpo_loss",anchor:"trl.CPOTrainer.cpo_loss",parameters:[{name:"policy_chosen_logps",val:": FloatTensor"},{name:"policy_rejected_logps",val:": FloatTensor"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L584",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>(losses, chosen_rewards, rejected_rewards).
The losses tensor contains the CPO loss for each example in the batch.
The chosen_rewards and rejected_rewards tensors contain the rewards for the chosen and rejected responses, respectively.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tuple of three tensors</p>
`}}),st=new f({props:{name:"evaluation_loop",anchor:"trl.CPOTrainer.evaluation_loop",parameters:[{name:"dataloader",val:": DataLoader"},{name:"description",val:": str"},{name:"prediction_loss_only",val:": Optional = None"},{name:"ignore_keys",val:": Optional = None"},{name:"metric_key_prefix",val:": str = 'eval'"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L881"}}),dt=new f({props:{name:"get_batch_logps",anchor:"trl.CPOTrainer.get_batch_logps",parameters:[{name:"logits",val:": FloatTensor"},{name:"labels",val:": LongTensor"},{name:"average_log_prob",val:": bool = False"},{name:"label_pad_token_id",val:": int = -100"},{name:"is_encoder_decoder",val:": bool = False"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L635",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tensor of shape (batch_size,) containing the average/sum log probabilities of the given labels under the given logits.</p>
`}}),ct=new f({props:{name:"get_batch_loss_metrics",anchor:"trl.CPOTrainer.get_batch_loss_metrics",parameters:[{name:"model",val:""},{name:"batch",val:": Dict"},{name:"train_eval",val:": Literal = 'train'"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L748"}}),mt=new f({props:{name:"get_batch_samples",anchor:"trl.CPOTrainer.get_batch_samples",parameters:[{name:"model",val:""},{name:"batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L816"}}),pt=new f({props:{name:"log",anchor:"trl.CPOTrainer.log",parameters:[{name:"logs",val:": Dict"}],parametersDescription:[{anchor:"trl.CPOTrainer.log.logs",description:`<strong>logs</strong> (<code>Dict[str, float]</code>) &#x2014;
The values to log.`,name:"logs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L929"}}),gt=new f({props:{name:"tokenize_row",anchor:"trl.CPOTrainer.tokenize_row",parameters:[{name:"feature",val:""},{name:"model",val:": Union = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/cpo_trainer.py#L376"}}),_t=new F({props:{title:"DDPOConfig",local:"trl.DDPOConfig",headingTag:"h2"}}),ut=new f({props:{name:"class trl.DDPOConfig",anchor:"trl.DDPOConfig",parameters:[{name:"exp_name",val:": str = 'doc-buil'"},{name:"run_name",val:": str = ''"},{name:"seed",val:": int = 0"},{name:"log_with",val:": Optional = None"},{name:"tracker_kwargs",val:": dict = <factory>"},{name:"accelerator_kwargs",val:": dict = <factory>"},{name:"project_kwargs",val:": dict = <factory>"},{name:"tracker_project_name",val:": str = 'trl'"},{name:"logdir",val:": str = 'logs'"},{name:"num_epochs",val:": int = 100"},{name:"save_freq",val:": int = 1"},{name:"num_checkpoint_limit",val:": int = 5"},{name:"mixed_precision",val:": str = 'fp16'"},{name:"allow_tf32",val:": bool = True"},{name:"resume_from",val:": str = ''"},{name:"sample_num_steps",val:": int = 50"},{name:"sample_eta",val:": float = 1.0"},{name:"sample_guidance_scale",val:": float = 5.0"},{name:"sample_batch_size",val:": int = 1"},{name:"sample_num_batches_per_epoch",val:": int = 2"},{name:"train_batch_size",val:": int = 1"},{name:"train_use_8bit_adam",val:": bool = False"},{name:"train_learning_rate",val:": float = 0.0003"},{name:"train_adam_beta1",val:": float = 0.9"},{name:"train_adam_beta2",val:": float = 0.999"},{name:"train_adam_weight_decay",val:": float = 0.0001"},{name:"train_adam_epsilon",val:": float = 1e-08"},{name:"train_gradient_accumulation_steps",val:": int = 1"},{name:"train_max_grad_norm",val:": float = 1.0"},{name:"train_num_inner_epochs",val:": int = 1"},{name:"train_cfg",val:": bool = True"},{name:"train_adv_clip_max",val:": float = 5.0"},{name:"train_clip_range",val:": float = 0.0001"},{name:"train_timestep_fraction",val:": float = 1.0"},{name:"per_prompt_stat_tracking",val:": bool = False"},{name:"per_prompt_stat_tracking_buffer_size",val:": int = 16"},{name:"per_prompt_stat_tracking_min_count",val:": int = 16"},{name:"async_reward_computation",val:": bool = False"},{name:"max_workers",val:": int = 2"},{name:"negative_prompts",val:": str = ''"}],parametersDescription:[{anchor:"trl.DDPOConfig.exp_name",description:`<strong>exp_name</strong> (<code>str</code>, <em>optional</em>, defaults to <code>os.path.basename(sys.argv[0])[ -- -len(&quot;.py&quot;)]</code>):
Name of this experiment (by default is the file name without the extension name).`,name:"exp_name"},{anchor:"trl.DDPOConfig.run_name",description:`<strong>run_name</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
Name of this run.`,name:"run_name"},{anchor:"trl.DDPOConfig.seed",description:`<strong>seed</strong> (<code>int</code>, <em>optional</em>, defaults to <code>0</code>) &#x2014;
Random seed.`,name:"seed"},{anchor:"trl.DDPOConfig.log_with",description:`<strong>log_with</strong> (<code>Optional[Literal[&quot;wandb&quot;, &quot;tensorboard&quot;]]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Log with either &#x2018;wandb&#x2019; or &#x2018;tensorboard&#x2019;, check
<a href="https://huggingface.co/docs/accelerate/usage_guides/tracking" rel="nofollow">https://huggingface.co/docs/accelerate/usage_guides/tracking</a> for more details.`,name:"log_with"},{anchor:"trl.DDPOConfig.tracker_kwargs",description:`<strong>tracker_kwargs</strong> (<code>Dict</code>, <em>optional</em>, defaults to <code>{}</code>) &#x2014;
Keyword arguments for the tracker (e.g. wandb_project).`,name:"tracker_kwargs"},{anchor:"trl.DDPOConfig.accelerator_kwargs",description:`<strong>accelerator_kwargs</strong> (<code>Dict</code>, <em>optional</em>, defaults to <code>{}</code>) &#x2014;
Keyword arguments for the accelerator.`,name:"accelerator_kwargs"},{anchor:"trl.DDPOConfig.project_kwargs",description:`<strong>project_kwargs</strong> (<code>Dict</code>, <em>optional</em>, defaults to <code>{}</code>) &#x2014;
Keyword arguments for the accelerator project config (e.g. <code>logging_dir</code>).`,name:"project_kwargs"},{anchor:"trl.DDPOConfig.tracker_project_name",description:`<strong>tracker_project_name</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;trl&quot;</code>) &#x2014;
Name of project to use for tracking.`,name:"tracker_project_name"},{anchor:"trl.DDPOConfig.logdir",description:`<strong>logdir</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;logs&quot;</code>) &#x2014;
Top-level logging directory for checkpoint saving.`,name:"logdir"},{anchor:"trl.DDPOConfig.num_epochs",description:`<strong>num_epochs</strong> (<code>int</code>, <em>optional</em>, defaults to <code>100</code>) &#x2014;
Number of epochs to train.`,name:"num_epochs"},{anchor:"trl.DDPOConfig.save_freq",description:`<strong>save_freq</strong> (<code>int</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014;
Number of epochs between saving model checkpoints.`,name:"save_freq"},{anchor:"trl.DDPOConfig.num_checkpoint_limit",description:`<strong>num_checkpoint_limit</strong> (<code>int</code>, <em>optional</em>, defaults to <code>5</code>) &#x2014;
Number of checkpoints to keep before overwriting old ones.`,name:"num_checkpoint_limit"},{anchor:"trl.DDPOConfig.mixed_precision",description:`<strong>mixed_precision</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;fp16&quot;</code>) &#x2014;
Mixed precision training.`,name:"mixed_precision"},{anchor:"trl.DDPOConfig.allow_tf32",description:`<strong>allow_tf32</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Allow <code>tf32</code> on Ampere GPUs.`,name:"allow_tf32"},{anchor:"trl.DDPOConfig.resume_from",description:`<strong>resume_from</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
Resume training from a checkpoint.`,name:"resume_from"},{anchor:"trl.DDPOConfig.sample_num_steps",description:`<strong>sample_num_steps</strong> (<code>int</code>, <em>optional</em>, defaults to <code>50</code>) &#x2014;
Number of sampler inference steps.`,name:"sample_num_steps"},{anchor:"trl.DDPOConfig.sample_eta",description:`<strong>sample_eta</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1.0</code>) &#x2014;
Eta parameter for the DDIM sampler.`,name:"sample_eta"},{anchor:"trl.DDPOConfig.sample_guidance_scale",description:`<strong>sample_guidance_scale</strong> (<code>float</code>, <em>optional</em>, defaults to <code>5.0</code>) &#x2014;
Classifier-free guidance weight.`,name:"sample_guidance_scale"},{anchor:"trl.DDPOConfig.sample_batch_size",description:`<strong>sample_batch_size</strong> (<code>int</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014;
Batch size (per GPU) to use for sampling.`,name:"sample_batch_size"},{anchor:"trl.DDPOConfig.sample_num_batches_per_epoch",description:`<strong>sample_num_batches_per_epoch</strong> (<code>int</code>, <em>optional</em>, defaults to <code>2</code>) &#x2014;
Number of batches to sample per epoch.`,name:"sample_num_batches_per_epoch"},{anchor:"trl.DDPOConfig.train_batch_size",description:`<strong>train_batch_size</strong> (<code>int</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014;
Batch size (per GPU) to use for training.`,name:"train_batch_size"},{anchor:"trl.DDPOConfig.train_use_8bit_adam",description:`<strong>train_use_8bit_adam</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Use 8bit Adam optimizer from bitsandbytes.`,name:"train_use_8bit_adam"},{anchor:"trl.DDPOConfig.train_learning_rate",description:`<strong>train_learning_rate</strong> (<code>float</code>, <em>optional</em>, defaults to <code>3e-4</code>) &#x2014;
Learning rate.`,name:"train_learning_rate"},{anchor:"trl.DDPOConfig.train_adam_beta1",description:`<strong>train_adam_beta1</strong> (<code>float</code>, <em>optional</em>, defaults to <code>0.9</code>) &#x2014;
Adam beta1.`,name:"train_adam_beta1"},{anchor:"trl.DDPOConfig.train_adam_beta2",description:`<strong>train_adam_beta2</strong> (<code>float</code>, <em>optional</em>, defaults to <code>0.999</code>) &#x2014;
Adam beta2.`,name:"train_adam_beta2"},{anchor:"trl.DDPOConfig.train_adam_weight_decay",description:`<strong>train_adam_weight_decay</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1e-4</code>) &#x2014;
Adam weight decay.`,name:"train_adam_weight_decay"},{anchor:"trl.DDPOConfig.train_adam_epsilon",description:`<strong>train_adam_epsilon</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1e-8</code>) &#x2014;
Adam epsilon.`,name:"train_adam_epsilon"},{anchor:"trl.DDPOConfig.train_gradient_accumulation_steps",description:`<strong>train_gradient_accumulation_steps</strong> (<code>int</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014;
Number of gradient accumulation steps.`,name:"train_gradient_accumulation_steps"},{anchor:"trl.DDPOConfig.train_max_grad_norm",description:`<strong>train_max_grad_norm</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1.0</code>) &#x2014;
Maximum gradient norm for gradient clipping.`,name:"train_max_grad_norm"},{anchor:"trl.DDPOConfig.train_num_inner_epochs",description:`<strong>train_num_inner_epochs</strong> (<code>int</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014;
Number of inner epochs per outer epoch.`,name:"train_num_inner_epochs"},{anchor:"trl.DDPOConfig.train_cfg",description:`<strong>train_cfg</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether or not to use classifier-free guidance during training.`,name:"train_cfg"},{anchor:"trl.DDPOConfig.train_adv_clip_max",description:`<strong>train_adv_clip_max</strong> (<code>float</code>, <em>optional</em>, defaults to <code>5.0</code>) &#x2014;
Clip advantages to the range.`,name:"train_adv_clip_max"},{anchor:"trl.DDPOConfig.train_clip_range",description:`<strong>train_clip_range</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1e-4</code>) &#x2014;
PPO clip range.`,name:"train_clip_range"},{anchor:"trl.DDPOConfig.train_timestep_fraction",description:`<strong>train_timestep_fraction</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1.0</code>) &#x2014;
Fraction of timesteps to train on.`,name:"train_timestep_fraction"},{anchor:"trl.DDPOConfig.per_prompt_stat_tracking",description:`<strong>per_prompt_stat_tracking</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to track statistics for each prompt separately.`,name:"per_prompt_stat_tracking"},{anchor:"trl.DDPOConfig.per_prompt_stat_tracking_buffer_size",description:`<strong>per_prompt_stat_tracking_buffer_size</strong> (<code>int</code>, <em>optional</em>, defaults to <code>16</code>) &#x2014;
Number of reward values to store in the buffer for each prompt.`,name:"per_prompt_stat_tracking_buffer_size"},{anchor:"trl.DDPOConfig.per_prompt_stat_tracking_min_count",description:`<strong>per_prompt_stat_tracking_min_count</strong> (<code>int</code>, <em>optional</em>, defaults to <code>16</code>) &#x2014;
Minimum number of reward values to store in the buffer.`,name:"per_prompt_stat_tracking_min_count"},{anchor:"trl.DDPOConfig.async_reward_computation",description:`<strong>async_reward_computation</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to compute rewards asynchronously.`,name:"async_reward_computation"},{anchor:"trl.DDPOConfig.max_workers",description:`<strong>max_workers</strong> (<code>int</code>, <em>optional</em>, defaults to <code>2</code>) &#x2014;
Maximum number of workers to use for async reward computation.`,name:"max_workers"},{anchor:"trl.DDPOConfig.negative_prompts",description:`<strong>negative_prompts</strong> (<code>Optional[str]</code>, <em>optional</em>, defaults to <code>&quot;&quot;</code>) &#x2014;
Comma-separated list of prompts to use as negative examples.`,name:"negative_prompts"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_config.py#L11"}}),ht=new F({props:{title:"DDPOTrainer",local:"trl.DDPOTrainer",headingTag:"h2"}}),ft=new f({props:{name:"class trl.DDPOTrainer",anchor:"trl.DDPOTrainer",parameters:[{name:"config",val:": DDPOConfig"},{name:"reward_function",val:": Callable"},{name:"prompt_function",val:": Callable"},{name:"sd_pipeline",val:": DDPOStableDiffusionPipeline"},{name:"image_samples_hook",val:": Optional = None"}],parametersDescription:[{anchor:"trl.DDPOTrainer.*config**",description:`*<strong>*config**</strong> (<code>DDPOConfig</code>) &#x2014; Configuration object for DDPOTrainer. Check the documentation of <code>PPOConfig</code> for more &#x2014;
details.`,name:"*config**"},{anchor:"trl.DDPOTrainer.*reward_function**",description:"*<strong>*reward_function**</strong> (Callable[[torch.Tensor, Tuple[str], Tuple[Any]], torch.Tensor]) &#x2014; Reward function to be used &#x2014;",name:"*reward_function**"},{anchor:"trl.DDPOTrainer.*prompt_function**",description:"*<strong>*prompt_function**</strong> (Callable[[], Tuple[str, Any]]) &#x2014; Function to generate prompts to guide model &#x2014;",name:"*prompt_function**"},{anchor:"trl.DDPOTrainer.*sd_pipeline**",description:"*<strong>*sd_pipeline**</strong> (<code>DDPOStableDiffusionPipeline</code>) &#x2014; Stable Diffusion pipeline to be used for training. &#x2014;",name:"*sd_pipeline**"},{anchor:"trl.DDPOTrainer.*image_samples_hook**",description:"*<strong>*image_samples_hook**</strong> (Optional[Callable[[Any, Any, Any], Any]]) &#x2014; Hook to be called to log images &#x2014;",name:"*image_samples_hook**"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_trainer.py#L55"}}),vt=new f({props:{name:"calculate_loss",anchor:"trl.DDPOTrainer.calculate_loss",parameters:[{name:"latents",val:""},{name:"timesteps",val:""},{name:"next_latents",val:""},{name:"log_probs",val:""},{name:"advantages",val:""},{name:"embeds",val:""}],parametersDescription:[{anchor:"trl.DDPOTrainer.calculate_loss.latents",description:`<strong>latents</strong> (torch.Tensor) &#x2014;
The latents sampled from the diffusion model, shape: [batch_size, num_channels_latents, height, width]`,name:"latents"},{anchor:"trl.DDPOTrainer.calculate_loss.timesteps",description:`<strong>timesteps</strong> (torch.Tensor) &#x2014;
The timesteps sampled from the diffusion model, shape: [batch_size]`,name:"timesteps"},{anchor:"trl.DDPOTrainer.calculate_loss.next_latents",description:`<strong>next_latents</strong> (torch.Tensor) &#x2014;
The next latents sampled from the diffusion model, shape: [batch_size, num_channels_latents, height, width]`,name:"next_latents"},{anchor:"trl.DDPOTrainer.calculate_loss.log_probs",description:`<strong>log_probs</strong> (torch.Tensor) &#x2014;
The log probabilities of the latents, shape: [batch_size]`,name:"log_probs"},{anchor:"trl.DDPOTrainer.calculate_loss.advantages",description:`<strong>advantages</strong> (torch.Tensor) &#x2014;
The advantages of the latents, shape: [batch_size]`,name:"advantages"},{anchor:"trl.DDPOTrainer.calculate_loss.embeds",description:`<strong>embeds</strong> (torch.Tensor) &#x2014;
The embeddings of the prompts, shape: [2*batch_size or batch_size, &#x2026;]
Note: the &#x201C;or&#x201D; is because if train_cfg is True, the expectation is that negative prompts are concatenated to the embeds`,name:"embeds"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_trainer.py#L340",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>loss (torch.Tensor), approx_kl (torch.Tensor), clipfrac (torch.Tensor)
(all of these are of shape (1,))</p>
`}}),bt=new f({props:{name:"create_model_card",anchor:"trl.DDPOTrainer.create_model_card",parameters:[{name:"path",val:": str"},{name:"model_name",val:": Optional = 'TRL DDPO Model'"}],parametersDescription:[{anchor:"trl.DDPOTrainer.create_model_card.path",description:"<strong>path</strong> (<code>str</code>) &#x2014; The path to save the model card to.",name:"path"},{anchor:"trl.DDPOTrainer.create_model_card.model_name",description:"<strong>model_name</strong> (<code>str</code>, <em>optional</em>) &#x2014; The name of the model, defaults to <code>TRL DDPO Model</code>.",name:"model_name"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_trainer.py#L606"}}),Ot=new f({props:{name:"step",anchor:"trl.DDPOTrainer.step",parameters:[{name:"epoch",val:": int"},{name:"global_step",val:": int"}],parametersDescription:[{anchor:"trl.DDPOTrainer.step.epoch",description:"<strong>epoch</strong> (int) &#x2014; The current epoch.",name:"epoch"},{anchor:"trl.DDPOTrainer.step.global_step",description:"<strong>global_step</strong> (int) &#x2014; The current global step.",name:"global_step"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_trainer.py#L234",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>The updated global step.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>global_step (int)</p>
`}}),Tt=new f({props:{name:"train",anchor:"trl.DDPOTrainer.train",parameters:[{name:"epochs",val:": Optional = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ddpo_trainer.py#L596"}}),xt=new F({props:{title:"DPOTrainer",local:"trl.DPOTrainer",headingTag:"h2"}}),$t=new f({props:{name:"class trl.DPOTrainer",anchor:"trl.DPOTrainer",parameters:[{name:"model",val:": Union = None"},{name:"ref_model",val:": Union = None"},{name:"beta",val:": float = 0.1"},{name:"label_smoothing",val:": float = 0"},{name:"loss_type",val:": Optional = None"},{name:"args",val:": Optional = None"},{name:"data_collator",val:": Optional = None"},{name:"label_pad_token_id",val:": int = -100"},{name:"padding_value",val:": Optional = None"},{name:"truncation_mode",val:": str = 'keep_end'"},{name:"train_dataset",val:": Optional = None"},{name:"eval_dataset",val:": Union = None"},{name:"tokenizer",val:": Optional = None"},{name:"model_init",val:": Optional = None"},{name:"callbacks",val:": Optional = None"},{name:"optimizers",val:": Tuple = (None, None)"},{name:"preprocess_logits_for_metrics",val:": Optional = None"},{name:"max_length",val:": Optional = None"},{name:"max_prompt_length",val:": Optional = None"},{name:"max_target_length",val:": Optional = None"},{name:"peft_config",val:": Optional = None"},{name:"is_encoder_decoder",val:": Optional = None"},{name:"disable_dropout",val:": bool = True"},{name:"generate_during_eval",val:": bool = False"},{name:"compute_metrics",val:": Optional = None"},{name:"precompute_ref_log_probs",val:": bool = False"},{name:"dataset_num_proc",val:": Optional = None"},{name:"model_init_kwargs",val:": Optional = None"},{name:"ref_model_init_kwargs",val:": Optional = None"},{name:"model_adapter_name",val:": Optional = None"},{name:"ref_adapter_name",val:": Optional = None"},{name:"reference_free",val:": bool = False"},{name:"force_use_ref_model",val:": bool = False"}],parametersDescription:[{anchor:"trl.DPOTrainer.model",description:`<strong>model</strong> (<code>transformers.PreTrainedModel</code>) &#x2014;
The model to train, preferably an <code>AutoModelForSequenceClassification</code>.`,name:"model"},{anchor:"trl.DPOTrainer.ref_model",description:`<strong>ref_model</strong> (<code>PreTrainedModelWrapper</code>) &#x2014;
Hugging Face transformer model with a casual language modelling head. Used for implicit reward computation and loss. If no
reference model is provided, the trainer will create a reference model with the same architecture as the model to be optimized.`,name:"ref_model"},{anchor:"trl.DPOTrainer.args",description:`<strong>args</strong> (<code>DPOConfig</code>) &#x2014;
The DPO config arguments to use for training.`,name:"args"},{anchor:"trl.DPOTrainer.data_collator",description:`<strong>data_collator</strong> (<code>transformers.DataCollator</code>) &#x2014;
The data collator to use for training. If None is specified, the default data collator (<code>DPODataCollatorWithPadding</code>) will be used
which will pad the sequences to the maximum length of the sequences in the batch, given a dataset of paired sequences.`,name:"data_collator"},{anchor:"trl.DPOTrainer.train_dataset",description:`<strong>train_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for training.`,name:"train_dataset"},{anchor:"trl.DPOTrainer.eval_dataset",description:`<strong>eval_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for evaluation.`,name:"eval_dataset"},{anchor:"trl.DPOTrainer.tokenizer",description:`<strong>tokenizer</strong> (<code>transformers.PreTrainedTokenizerBase</code>) &#x2014;
The tokenizer to use for training. This argument is required if you want to use the default data collator.`,name:"tokenizer"},{anchor:"trl.DPOTrainer.model_init",description:`<strong>model_init</strong> (<code>Callable[[], transformers.PreTrainedModel]</code>) &#x2014;
The model initializer to use for training. If None is specified, the default model initializer will be used.`,name:"model_init"},{anchor:"trl.DPOTrainer.callbacks",description:`<strong>callbacks</strong> (<code>List[transformers.TrainerCallback]</code>) &#x2014;
The callbacks to use for training.`,name:"callbacks"},{anchor:"trl.DPOTrainer.optimizers",description:`<strong>optimizers</strong> (<code>Tuple[torch.optim.Optimizer, torch.optim.lr_scheduler.LambdaLR]</code>) &#x2014;
The optimizer and scheduler to use for training.`,name:"optimizers"},{anchor:"trl.DPOTrainer.preprocess_logits_for_metrics",description:`<strong>preprocess_logits_for_metrics</strong> (<code>Callable[[torch.Tensor, torch.Tensor], torch.Tensor]</code>) &#x2014;
The function to use to preprocess the logits before computing the metrics.`,name:"preprocess_logits_for_metrics"},{anchor:"trl.DPOTrainer.peft_config",description:`<strong>peft_config</strong> (<code>Dict</code>, defaults to <code>None</code>) &#x2014;
The PEFT configuration to use for training. If you pass a PEFT configuration, the model will be wrapped in a PEFT model.`,name:"peft_config"},{anchor:"trl.DPOTrainer.compute_metrics",description:`<strong>compute_metrics</strong> (<code>Callable[[EvalPrediction], Dict]</code>, <em>optional</em>) &#x2014;
The function to use to compute the metrics. Must take a <code>EvalPrediction</code> and return
a dictionary string to metric values.`,name:"compute_metrics"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L354"}}),Pt=new f({props:{name:"compute_reference_log_probs",anchor:"trl.DPOTrainer.compute_reference_log_probs",parameters:[{name:"padded_batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L1032"}}),wt=new f({props:{name:"concatenated_forward",anchor:"trl.DPOTrainer.concatenated_forward",parameters:[{name:"model",val:": Module"},{name:"batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L1340"}}),Ct=new f({props:{name:"concatenated_inputs",anchor:"trl.DPOTrainer.concatenated_inputs",parameters:[{name:"batch",val:": Dict"},{name:"is_encoder_decoder",val:": bool = False"},{name:"is_vision_model",val:": bool = False"},{name:"label_pad_token_id",val:": int = -100"},{name:"padding_value",val:": int = 0"},{name:"device",val:": Optional = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L1050",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A dictionary containing the concatenated inputs under the key ‘concatenated_input_ids’.</p>
`}}),yt=new f({props:{name:"dpo_loss",anchor:"trl.DPOTrainer.dpo_loss",parameters:[{name:"policy_chosen_logps",val:": FloatTensor"},{name:"policy_rejected_logps",val:": FloatTensor"},{name:"reference_chosen_logps",val:": FloatTensor"},{name:"reference_rejected_logps",val:": FloatTensor"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L1124",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>(losses, chosen_rewards, rejected_rewards).
The losses tensor contains the DPO loss for each example in the batch.
The chosen_rewards and rejected_rewards tensors contain the rewards for the chosen and rejected responses, respectively.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tuple of three tensors</p>
`}}),kt=new f({props:{name:"evaluation_loop",anchor:"trl.DPOTrainer.evaluation_loop",parameters:[{name:"dataloader",val:": DataLoader"},{name:"description",val:": str"},{name:"prediction_loss_only",val:": Optional = None"},{name:"ignore_keys",val:": Optional = None"},{name:"metric_key_prefix",val:": str = 'eval'"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L1607"}}),Dt=new f({props:{name:"get_batch_logps",anchor:"trl.DPOTrainer.get_batch_logps",parameters:[{name:"logits",val:": FloatTensor"},{name:"labels",val:": LongTensor"},{name:"label_pad_token_id",val:": int = -100"},{name:"is_encoder_decoder",val:": bool = False"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L1305",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A Tuple of two tensor of shape ((batch_size,), (batch_size,)) containing the sum of log probabilities of the given labels under the given logits in the first tensor and the number of non-masked tokens in the second tensor.</p>
`}}),Nt=new f({props:{name:"get_batch_loss_metrics",anchor:"trl.DPOTrainer.get_batch_loss_metrics",parameters:[{name:"model",val:""},{name:"batch",val:": Dict"},{name:"train_eval",val:": Literal = 'train'"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L1423"}}),Ft=new f({props:{name:"get_batch_samples",anchor:"trl.DPOTrainer.get_batch_samples",parameters:[{name:"model",val:""},{name:"batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L1517"}}),Lt=new f({props:{name:"get_eval_dataloader",anchor:"trl.DPOTrainer.get_eval_dataloader",parameters:[{name:"eval_dataset",val:": Optional = None"}],parametersDescription:[{anchor:"trl.DPOTrainer.get_eval_dataloader.eval_dataset",description:`<strong>eval_dataset</strong> (<code>torch.utils.data.Dataset</code>, <em>optional</em>) &#x2014;
If provided, will override <code>self.eval_dataset</code>. If it is a <a href="https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset" rel="nofollow">Dataset</a>, columns not accepted
by the <code>model.forward()</code> method are automatically removed. It must implement <code>__len__</code>.`,name:"eval_dataset"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L968"}}),zt=new f({props:{name:"get_train_dataloader",anchor:"trl.DPOTrainer.get_train_dataloader",parameters:[],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L921"}}),qt=new f({props:{name:"log",anchor:"trl.DPOTrainer.log",parameters:[{name:"logs",val:": Dict"}],parametersDescription:[{anchor:"trl.DPOTrainer.log.logs",description:`<strong>logs</strong> (<code>Dict[str, float]</code>) &#x2014;
The values to log.`,name:"logs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L1657"}}),Mt=new f({props:{name:"null_ref_context",anchor:"trl.DPOTrainer.null_ref_context",parameters:[],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/dpo_trainer.py#L1020"}}),It=new F({props:{title:"IterativeSFTTrainer",local:"trl.IterativeSFTTrainer",headingTag:"h2"}}),Rt=new f({props:{name:"class trl.IterativeSFTTrainer",anchor:"trl.IterativeSFTTrainer",parameters:[{name:"model",val:": Optional = None"},{name:"args",val:": Optional = None"},{name:"tokenizer",val:": Optional = None"},{name:"optimizers",val:": Tuple = (None, None)"},{name:"data_collator",val:": Optional = None"},{name:"eval_dataset",val:": Union = None"},{name:"max_length",val:": Optional = None"},{name:"truncation_mode",val:": Optional = 'keep_end'"},{name:"preprocess_logits_for_metrics",val:": Optional = None"},{name:"compute_metrics",val:": Optional = None"},{name:"optimize_device_cache",val:": Optional = False"}],parametersDescription:[{anchor:"trl.IterativeSFTTrainer.model",description:`<strong>model</strong> (<code>PreTrainedModel</code>) &#x2014;
Model to be optimized, either an &#x2018;AutoModelForCausalLM&#x2019; or an &#x2018;AutoModelForSeq2SeqLM&#x2019;.
Check the documentation of <code>PreTrainedModel</code> for more details.`,name:"model"},{anchor:"trl.IterativeSFTTrainer.args",description:`<strong>args</strong> (<code>transformers.TrainingArguments</code>) &#x2014;
The arguments to use for training.`,name:"args"},{anchor:"trl.IterativeSFTTrainer.tokenizer",description:`<strong>tokenizer</strong> (<code>PreTrainedTokenizerBase</code>) &#x2014;
Tokenizer to be used for encoding the data. Check the documentation of <code>transformers.PreTrainedTokenizer</code> and
<code>transformers.PreTrainedTokenizerFast</code> for more details.`,name:"tokenizer"},{anchor:"trl.IterativeSFTTrainer.optimizers",description:`<strong>optimizers</strong> (<code>Tuple[torch.optim.Optimizer, torch.optim.lr_scheduler.LambdaLR]</code>) &#x2014;
The optimizer and scheduler to use for training.`,name:"optimizers"},{anchor:"trl.IterativeSFTTrainer.data_collator",description:`<strong>data_collator</strong> (Union[DataCollatorForLanguageModeling, DataCollatorForSeq2Seq], <em>optional</em>) &#x2014;
Data collator to be used for training and passed along the dataloader.`,name:"data_collator"},{anchor:"trl.IterativeSFTTrainer.eval_dataset",description:`<strong>eval_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for evaluation.`,name:"eval_dataset"},{anchor:"trl.IterativeSFTTrainer.max_length",description:`<strong>max_length</strong> (<code>int</code>, defaults to <code>None</code>) &#x2014;
The maximum length of the input.`,name:"max_length"},{anchor:"trl.IterativeSFTTrainer.truncation_mode",description:`<strong>truncation_mode</strong> (<code>str</code>, defaults to <code>keep_end</code>) &#x2014;
The truncation mode to use, either <code>keep_end</code> or <code>keep_start</code>.`,name:"truncation_mode"},{anchor:"trl.IterativeSFTTrainer.preprocess_logits_for_metrics",description:`<strong>preprocess_logits_for_metrics</strong> (<code>Callable[[torch.Tensor, torch.Tensor], torch.Tensor]</code>) &#x2014;
The function to use to preprocess the logits before computing the metrics.`,name:"preprocess_logits_for_metrics"},{anchor:"trl.IterativeSFTTrainer.compute_metrics",description:`<strong>compute_metrics</strong> (<code>Callable[[EvalPrediction], Dict]</code>, <em>optional</em>) &#x2014;
The function to use to compute the metrics. Must take a <code>EvalPrediction</code> and return a dictionary string to metric values.`,name:"compute_metrics"},{anchor:"trl.IterativeSFTTrainer.optimize_device_cache",description:`<strong>optimize_device_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Optimize CUDA cache for slightly more memory-efficient training.`,name:"optimize_device_cache"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/iterative_sft_trainer.py#L41"}}),Et=new f({props:{name:"step",anchor:"trl.IterativeSFTTrainer.step",parameters:[{name:"input_ids",val:": Optional = None"},{name:"attention_mask",val:": Optional = None"},{name:"labels",val:": Optional = None"},{name:"texts",val:": Optional = None"},{name:"texts_labels",val:": Optional = None"}],parametersDescription:[{anchor:"trl.IterativeSFTTrainer.step.input_ids",description:`<strong>input_ids</strong> (List<code>torch.LongTensor</code>) &#x2014;
List of tensors containing the input_ids (if not provided, text will be used)`,name:"input_ids"},{anchor:"trl.IterativeSFTTrainer.step.attention_mask",description:`<strong>attention_mask</strong> (List<code>torch.LongTensor</code>, , <em>optional</em>) &#x2014;
List of tensors containing the attention_mask`,name:"attention_mask"},{anchor:"trl.IterativeSFTTrainer.step.labels",description:`<strong>labels</strong> (List<code>torch.FloatTensor</code>, <em>optional</em>) &#x2014;
List of tensors containing the labels (if set to None, will default to input_ids)`,name:"labels"},{anchor:"trl.IterativeSFTTrainer.step.texts",description:`<strong>texts</strong> (List<code>str</code>, <em>optional</em>) &#x2014;
List of strings containing the text input (if not provided, input_ids will directly be used)`,name:"texts"},{anchor:"trl.IterativeSFTTrainer.step.texts_labels",description:`<strong>texts_labels</strong> (List<code>str</code>, <em>optional</em>) &#x2014;
List of strings containing the text labels (if set to None, will default to text)`,name:"texts_labels"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/iterative_sft_trainer.py#L243",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A summary of the training statistics</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>dict[str, Any]</code></p>
`}}),Ut=new F({props:{title:"KTOConfig",local:"trl.KTOConfig",headingTag:"h2"}}),Ht=new f({props:{name:"class trl.KTOConfig",anchor:"trl.KTOConfig",parameters:[{name:"output_dir",val:": str"},{name:"overwrite_output_dir",val:": bool = False"},{name:"do_train",val:": bool = False"},{name:"do_eval",val:": bool = False"},{name:"do_predict",val:": bool = False"},{name:"eval_strategy",val:": Union = 'no'"},{name:"prediction_loss_only",val:": bool = False"},{name:"per_device_train_batch_size",val:": int = 8"},{name:"per_device_eval_batch_size",val:": int = 8"},{name:"per_gpu_train_batch_size",val:": Optional = None"},{name:"per_gpu_eval_batch_size",val:": Optional = None"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"eval_accumulation_steps",val:": Optional = None"},{name:"eval_delay",val:": Optional = 0"},{name:"torch_empty_cache_steps",val:": Optional = None"},{name:"learning_rate",val:": float = 5e-05"},{name:"weight_decay",val:": float = 0.0"},{name:"adam_beta1",val:": float = 0.9"},{name:"adam_beta2",val:": float = 0.999"},{name:"adam_epsilon",val:": float = 1e-08"},{name:"max_grad_norm",val:": float = 1.0"},{name:"num_train_epochs",val:": float = 3.0"},{name:"max_steps",val:": int = -1"},{name:"lr_scheduler_type",val:": Union = 'linear'"},{name:"lr_scheduler_kwargs",val:": Union = <factory>"},{name:"warmup_ratio",val:": float = 0.0"},{name:"warmup_steps",val:": int = 0"},{name:"log_level",val:": Optional = 'passive'"},{name:"log_level_replica",val:": Optional = 'warning'"},{name:"log_on_each_node",val:": bool = True"},{name:"logging_dir",val:": Optional = None"},{name:"logging_strategy",val:": Union = 'steps'"},{name:"logging_first_step",val:": bool = False"},{name:"logging_steps",val:": float = 500"},{name:"logging_nan_inf_filter",val:": bool = True"},{name:"save_strategy",val:": Union = 'steps'"},{name:"save_steps",val:": float = 500"},{name:"save_total_limit",val:": Optional = None"},{name:"save_safetensors",val:": Optional = True"},{name:"save_on_each_node",val:": bool = False"},{name:"save_only_model",val:": bool = False"},{name:"restore_callback_states_from_checkpoint",val:": bool = False"},{name:"no_cuda",val:": bool = False"},{name:"use_cpu",val:": bool = False"},{name:"use_mps_device",val:": bool = False"},{name:"seed",val:": int = 42"},{name:"data_seed",val:": Optional = None"},{name:"jit_mode_eval",val:": bool = False"},{name:"use_ipex",val:": bool = False"},{name:"bf16",val:": bool = False"},{name:"fp16",val:": bool = False"},{name:"fp16_opt_level",val:": str = 'O1'"},{name:"half_precision_backend",val:": str = 'auto'"},{name:"bf16_full_eval",val:": bool = False"},{name:"fp16_full_eval",val:": bool = False"},{name:"tf32",val:": Optional = None"},{name:"local_rank",val:": int = -1"},{name:"ddp_backend",val:": Optional = None"},{name:"tpu_num_cores",val:": Optional = None"},{name:"tpu_metrics_debug",val:": bool = False"},{name:"debug",val:": Union = ''"},{name:"dataloader_drop_last",val:": bool = False"},{name:"eval_steps",val:": Optional = None"},{name:"dataloader_num_workers",val:": int = 0"},{name:"dataloader_prefetch_factor",val:": Optional = None"},{name:"past_index",val:": int = -1"},{name:"run_name",val:": Optional = None"},{name:"disable_tqdm",val:": Optional = None"},{name:"remove_unused_columns",val:": Optional = True"},{name:"label_names",val:": Optional = None"},{name:"load_best_model_at_end",val:": Optional = False"},{name:"metric_for_best_model",val:": Optional = None"},{name:"greater_is_better",val:": Optional = None"},{name:"ignore_data_skip",val:": bool = False"},{name:"fsdp",val:": Union = ''"},{name:"fsdp_min_num_params",val:": int = 0"},{name:"fsdp_config",val:": Union = None"},{name:"fsdp_transformer_layer_cls_to_wrap",val:": Optional = None"},{name:"accelerator_config",val:": Union = None"},{name:"deepspeed",val:": Union = None"},{name:"label_smoothing_factor",val:": float = 0.0"},{name:"optim",val:": Union = 'adamw_torch'"},{name:"optim_args",val:": Optional = None"},{name:"adafactor",val:": bool = False"},{name:"group_by_length",val:": bool = False"},{name:"length_column_name",val:": Optional = 'length'"},{name:"report_to",val:": Union = None"},{name:"ddp_find_unused_parameters",val:": Optional = None"},{name:"ddp_bucket_cap_mb",val:": Optional = None"},{name:"ddp_broadcast_buffers",val:": Optional = None"},{name:"dataloader_pin_memory",val:": bool = True"},{name:"dataloader_persistent_workers",val:": bool = False"},{name:"skip_memory_metrics",val:": bool = True"},{name:"use_legacy_prediction_loop",val:": bool = False"},{name:"push_to_hub",val:": bool = False"},{name:"resume_from_checkpoint",val:": Optional = None"},{name:"hub_model_id",val:": Optional = None"},{name:"hub_strategy",val:": Union = 'every_save'"},{name:"hub_token",val:": Optional = None"},{name:"hub_private_repo",val:": bool = False"},{name:"hub_always_push",val:": bool = False"},{name:"gradient_checkpointing",val:": bool = False"},{name:"gradient_checkpointing_kwargs",val:": Union = None"},{name:"include_inputs_for_metrics",val:": bool = False"},{name:"eval_do_concat_batches",val:": bool = True"},{name:"fp16_backend",val:": str = 'auto'"},{name:"evaluation_strategy",val:": Union = None"},{name:"push_to_hub_model_id",val:": Optional = None"},{name:"push_to_hub_organization",val:": Optional = None"},{name:"push_to_hub_token",val:": Optional = None"},{name:"mp_parameters",val:": str = ''"},{name:"auto_find_batch_size",val:": bool = False"},{name:"full_determinism",val:": bool = False"},{name:"torchdynamo",val:": Optional = None"},{name:"ray_scope",val:": Optional = 'last'"},{name:"ddp_timeout",val:": Optional = 1800"},{name:"torch_compile",val:": bool = False"},{name:"torch_compile_backend",val:": Optional = None"},{name:"torch_compile_mode",val:": Optional = None"},{name:"dispatch_batches",val:": Optional = None"},{name:"split_batches",val:": Optional = None"},{name:"include_tokens_per_second",val:": Optional = False"},{name:"include_num_input_tokens_seen",val:": Optional = False"},{name:"neftune_noise_alpha",val:": Optional = None"},{name:"optim_target_modules",val:": Union = None"},{name:"batch_eval_metrics",val:": bool = False"},{name:"eval_on_start",val:": bool = False"},{name:"use_liger_kernel",val:": Optional = False"},{name:"eval_use_gather_object",val:": Optional = False"},{name:"max_length",val:": Optional = None"},{name:"max_prompt_length",val:": Optional = None"},{name:"max_completion_length",val:": Optional = None"},{name:"beta",val:": float = 0.1"},{name:"loss_type",val:": Literal = 'kto'"},{name:"desirable_weight",val:": float = 1.0"},{name:"undesirable_weight",val:": float = 1.0"},{name:"label_pad_token_id",val:": int = -100"},{name:"padding_value",val:": Optional = None"},{name:"truncation_mode",val:": str = 'keep_end'"},{name:"generate_during_eval",val:": bool = False"},{name:"is_encoder_decoder",val:": Optional = None"},{name:"precompute_ref_log_probs",val:": bool = False"},{name:"model_init_kwargs",val:": Optional = None"},{name:"ref_model_init_kwargs",val:": Optional = None"},{name:"dataset_num_proc",val:": Optional = None"}],parametersDescription:[{anchor:"trl.KTOConfig.max_length",description:`<strong>max_length</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Maximum length of the sequences (prompt + completion) in the batch. This argument is required if you want
to use the default data collator.`,name:"max_length"},{anchor:"trl.KTOConfig.max_prompt_length",description:`<strong>max_prompt_length</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Maximum length of the prompt. This argument is required if you want to use the default data collator.`,name:"max_prompt_length"},{anchor:"trl.KTOConfig.max_completion_length",description:`<strong>max_completion_length</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Maximum length of the completion. This argument is required if you want to use the default data collator
and your model is an encoder-decoder.`,name:"max_completion_length"},{anchor:"trl.KTOConfig.beta",description:`<strong>beta</strong> (<code>float</code>, <em>optional</em>, defaults to <code>0.1</code>) &#x2014;
Parameter controlling the deviation from the reference model. Higher &#x3B2; means less deviation from the
reference model.`,name:"beta"},{anchor:"trl.KTOConfig.loss_type",description:`<strong>loss_type</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;kto&quot;</code>) &#x2014;
Type of loss to use. Possible values are:</p>
<ul>
<li><code>&quot;kto&quot;</code>: KTO loss from the <a href="https://huggingface.co/papers/2402.01306" rel="nofollow">KTO</a> paper.</li>
<li><code>&quot;apo_zero_unpaired&quot;</code>: Unpaired variant of APO-zero loss from the <a href="https://huggingface.co/papers/2408.06266" rel="nofollow">APO</a> paper.</li>
</ul>`,name:"loss_type"},{anchor:"trl.KTOConfig.desirable_weight",description:`<strong>desirable_weight</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1.0</code>) &#x2014;
Desirable losses are weighed by this factor to counter unequal number of desirable and undesirable paris.`,name:"desirable_weight"},{anchor:"trl.KTOConfig.undesirable_weight",description:`<strong>undesirable_weight</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1.0</code>) &#x2014;
Undesirable losses are weighed by this factor to counter unequal number of desirable and undesirable pairs.`,name:"undesirable_weight"},{anchor:"trl.KTOConfig.label_pad_token_id",description:`<strong>label_pad_token_id</strong> (<code>int</code>, <em>optional</em>, defaults to <code>-100</code>) &#x2014;
Label pad token id. This argument is required if you want to use the default data collator.`,name:"label_pad_token_id"},{anchor:"trl.KTOConfig.padding_value",description:`<strong>padding_value</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Padding value to use. If <code>None</code>, the padding value of the tokenizer is used.`,name:"padding_value"},{anchor:"trl.KTOConfig.truncation_mode",description:`<strong>truncation_mode</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;keep_end&quot;</code>) &#x2014;
Truncation mode to use when the prompt is too long. Possible values are <code>&quot;keep_end&quot;</code> or <code>&quot;keep_start&quot;</code>.
This argument is required if you want to use the default data collator.`,name:"truncation_mode"},{anchor:"trl.KTOConfig.generate_during_eval",description:`<strong>generate_during_eval</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
If <code>True</code>, generates and logs completions from both the model and the reference model to W&amp;B during
evaluation.`,name:"generate_during_eval"},{anchor:"trl.KTOConfig.is_encoder_decoder",description:`<strong>is_encoder_decoder</strong> (<code>Optional[bool]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
When using the <code>model_init</code> argument (callable) to instantiate the model instead of the <code>model</code> argument,
you need to specify if the model returned by the callable is an encoder-decoder model.`,name:"is_encoder_decoder"},{anchor:"trl.KTOConfig.precompute_ref_log_probs",description:`<strong>precompute_ref_log_probs</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to precompute reference model log probabilities for training and evaluation datasets. This is
useful when training without the reference model to reduce the total GPU memory needed.`,name:"precompute_ref_log_probs"},{anchor:"trl.KTOConfig.model_init_kwargs",description:`<strong>model_init_kwargs</strong> (<code>Optional[Dict[str, Any]]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Keyword arguments to pass to <code>AutoModelForCausalLM.from_pretrained</code> when instantiating the model from a
string.`,name:"model_init_kwargs"},{anchor:"trl.KTOConfig.ref_model_init_kwargs",description:`<strong>ref_model_init_kwargs</strong> (<code>Optional[Dict[str, Any]]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Keyword arguments to pass to <code>AutoModelForCausalLM.from_pretrained</code> when instantiating the reference model
from a string.
dataset_num_proc &#x2014; (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>):
Number of processes to use for processing the dataset.`,name:"ref_model_init_kwargs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_config.py#L20"}}),At=new F({props:{title:"KTOTrainer",local:"trl.KTOTrainer",headingTag:"h2"}}),Kt=new f({props:{name:"class trl.KTOTrainer",anchor:"trl.KTOTrainer",parameters:[{name:"model",val:": Union = None"},{name:"ref_model",val:": Union = None"},{name:"args",val:": KTOConfig = None"},{name:"train_dataset",val:": Optional = None"},{name:"eval_dataset",val:": Union = None"},{name:"tokenizer",val:": Optional = None"},{name:"data_collator",val:": Optional = None"},{name:"model_init",val:": Optional = None"},{name:"callbacks",val:": Optional = None"},{name:"optimizers",val:": Tuple = (None, None)"},{name:"preprocess_logits_for_metrics",val:": Optional = None"},{name:"peft_config",val:": Optional = None"},{name:"compute_metrics",val:": Optional = None"},{name:"model_adapter_name",val:": Optional = None"},{name:"ref_adapter_name",val:": Optional = None"}],parametersDescription:[{anchor:"trl.KTOTrainer.model",description:`<strong>model</strong> (<code>transformers.PreTrainedModel</code>) &#x2014;
The model to train, preferably an <code>AutoModelForSequenceClassification</code>.`,name:"model"},{anchor:"trl.KTOTrainer.ref_model",description:`<strong>ref_model</strong> (<code>PreTrainedModelWrapper</code>) &#x2014;
Hugging Face transformer model with a casual language modelling head. Used for implicit reward computation and loss. If no
reference model is provided, the trainer will create a reference model with the same architecture as the model to be optimized.`,name:"ref_model"},{anchor:"trl.KTOTrainer.args",description:`<strong>args</strong> (<code>KTOConfig</code>) &#x2014;
The arguments to use for training.`,name:"args"},{anchor:"trl.KTOTrainer.train_dataset",description:`<strong>train_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for training.`,name:"train_dataset"},{anchor:"trl.KTOTrainer.eval_dataset",description:`<strong>eval_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for evaluation.`,name:"eval_dataset"},{anchor:"trl.KTOTrainer.tokenizer",description:`<strong>tokenizer</strong> (<code>transformers.PreTrainedTokenizerBase</code>) &#x2014;
The tokenizer to use for training. This argument is required if you want to use the default data collator.`,name:"tokenizer"},{anchor:"trl.KTOTrainer.data_collator",description:`<strong>data_collator</strong> (<code>transformers.DataCollator</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
The data collator to use for training. If None is specified, the default data collator (<code>DPODataCollatorWithPadding</code>) will be used
which will pad the sequences to the maximum length of the sequences in the batch, given a dataset of paired sequences.`,name:"data_collator"},{anchor:"trl.KTOTrainer.model_init",description:`<strong>model_init</strong> (<code>Callable[[], transformers.PreTrainedModel]</code>) &#x2014;
The model initializer to use for training. If None is specified, the default model initializer will be used.`,name:"model_init"},{anchor:"trl.KTOTrainer.callbacks",description:`<strong>callbacks</strong> (<code>List[transformers.TrainerCallback]</code>) &#x2014;
The callbacks to use for training.`,name:"callbacks"},{anchor:"trl.KTOTrainer.optimizers",description:`<strong>optimizers</strong> (<code>Tuple[torch.optim.Optimizer, torch.optim.lr_scheduler.LambdaLR]</code>) &#x2014;
The optimizer and scheduler to use for training.`,name:"optimizers"},{anchor:"trl.KTOTrainer.preprocess_logits_for_metrics",description:`<strong>preprocess_logits_for_metrics</strong> (<code>Callable[[torch.Tensor, torch.Tensor], torch.Tensor]</code>) &#x2014;
The function to use to preprocess the logits before computing the metrics.`,name:"preprocess_logits_for_metrics"},{anchor:"trl.KTOTrainer.peft_config",description:`<strong>peft_config</strong> (<code>Dict</code>, defaults to <code>None</code>) &#x2014;
The PEFT configuration to use for training. If you pass a PEFT configuration, the model will be wrapped in a PEFT model.`,name:"peft_config"},{anchor:"trl.KTOTrainer.disable_dropout",description:`<strong>disable_dropout</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Whether or not to disable dropouts in <code>model</code> and <code>ref_model</code>.`,name:"disable_dropout"},{anchor:"trl.KTOTrainer.compute_metrics",description:`<strong>compute_metrics</strong> (<code>Callable[[EvalPrediction], Dict]</code>, <em>optional</em>) &#x2014;
The function to use to compute the metrics. Must take a <code>EvalPrediction</code> and return
a dictionary string to metric values.`,name:"compute_metrics"},{anchor:"trl.KTOTrainer.model_adapter_name",description:`<strong>model_adapter_name</strong> (<code>str</code>, defaults to <code>None</code>) &#x2014;
Name of the train target PEFT adapter, when using LoRA with multiple adapters.`,name:"model_adapter_name"},{anchor:"trl.KTOTrainer.ref_adapter_name",description:`<strong>ref_adapter_name</strong> (<code>str</code>, defaults to <code>None</code>) &#x2014;
Name of the reference PEFT adapter, when using LoRA with multiple adapters.`,name:"ref_adapter_name"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L256"}}),St=new f({props:{name:"compute_reference_log_probs",anchor:"trl.KTOTrainer.compute_reference_log_probs",parameters:[{name:"padded_batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L857"}}),jt=new f({props:{name:"evaluation_loop",anchor:"trl.KTOTrainer.evaluation_loop",parameters:[{name:"dataloader",val:": DataLoader"},{name:"description",val:": str"},{name:"prediction_loss_only",val:": Optional = None"},{name:"ignore_keys",val:": Optional = None"},{name:"metric_key_prefix",val:": str = 'eval'"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L1333"}}),Vt=new f({props:{name:"get_batch_logps",anchor:"trl.KTOTrainer.get_batch_logps",parameters:[{name:"logits",val:": FloatTensor"},{name:"labels",val:": LongTensor"},{name:"average_log_prob",val:": bool = False"},{name:"label_pad_token_id",val:": int = -100"},{name:"is_encoder_decoder",val:": bool = False"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L936",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tensor of shape (batch_size,) containing the average/sum log probabilities of the given labels under the given logits.</p>
`}}),Wt=new f({props:{name:"get_batch_loss_metrics",anchor:"trl.KTOTrainer.get_batch_loss_metrics",parameters:[{name:"model",val:""},{name:"batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L1127"}}),Bt=new f({props:{name:"get_batch_samples",anchor:"trl.KTOTrainer.get_batch_samples",parameters:[{name:"model",val:""},{name:"batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L1247"}}),Gt=new f({props:{name:"get_eval_dataloader",anchor:"trl.KTOTrainer.get_eval_dataloader",parameters:[{name:"eval_dataset",val:": Optional = None"}],parametersDescription:[{anchor:"trl.KTOTrainer.get_eval_dataloader.eval_dataset",description:`<strong>eval_dataset</strong> (<code>torch.utils.data.Dataset</code>, <em>optional</em>) &#x2014;
If provided, will override <code>self.eval_dataset</code>. If it is a <a href="https://huggingface.co/docs/datasets/main/en/package_reference/main_classes#datasets.Dataset" rel="nofollow">Dataset</a>, columns not accepted
by the <code>model.forward()</code> method are automatically removed. It must implement <code>__len__</code>.`,name:"eval_dataset"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L802"}}),Jt=new f({props:{name:"get_train_dataloader",anchor:"trl.KTOTrainer.get_train_dataloader",parameters:[],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L758"}}),Zt=new f({props:{name:"kto_loss",anchor:"trl.KTOTrainer.kto_loss",parameters:[{name:"policy_chosen_logps",val:": FloatTensor"},{name:"policy_rejected_logps",val:": FloatTensor"},{name:"policy_KL_logps",val:": FloatTensor"},{name:"reference_chosen_logps",val:": FloatTensor"},{name:"reference_rejected_logps",val:": FloatTensor"},{name:"reference_KL_logps",val:": FloatTensor"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L1055",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>(losses, chosen_rewards, rejected_rewards, KL).
The losses tensor contains the KTO loss for each example in the batch.
The chosen_rewards and rejected_rewards tensors contain the rewards for the chosen and rejected responses, respectively.
The KL tensor contains the detached KL divergence estimate between the policy and reference models.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tuple of four tensors</p>
`}}),Qt=new f({props:{name:"log",anchor:"trl.KTOTrainer.log",parameters:[{name:"logs",val:": Dict"}],parametersDescription:[{anchor:"trl.KTOTrainer.log.logs",description:`<strong>logs</strong> (<code>Dict[str, float]</code>) &#x2014;
The values to log.`,name:"logs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L1389"}}),Xt=new f({props:{name:"null_ref_context",anchor:"trl.KTOTrainer.null_ref_context",parameters:[],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/kto_trainer.py#L746"}}),Yt=new F({props:{title:"ORPOConfig",local:"trl.ORPOConfig",headingTag:"h2"}}),eo=new f({props:{name:"class trl.ORPOConfig",anchor:"trl.ORPOConfig",parameters:[{name:"output_dir",val:": str"},{name:"overwrite_output_dir",val:": bool = False"},{name:"do_train",val:": bool = False"},{name:"do_eval",val:": bool = False"},{name:"do_predict",val:": bool = False"},{name:"eval_strategy",val:": Union = 'no'"},{name:"prediction_loss_only",val:": bool = False"},{name:"per_device_train_batch_size",val:": int = 8"},{name:"per_device_eval_batch_size",val:": int = 8"},{name:"per_gpu_train_batch_size",val:": Optional = None"},{name:"per_gpu_eval_batch_size",val:": Optional = None"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"eval_accumulation_steps",val:": Optional = None"},{name:"eval_delay",val:": Optional = 0"},{name:"torch_empty_cache_steps",val:": Optional = None"},{name:"learning_rate",val:": float = 5e-05"},{name:"weight_decay",val:": float = 0.0"},{name:"adam_beta1",val:": float = 0.9"},{name:"adam_beta2",val:": float = 0.999"},{name:"adam_epsilon",val:": float = 1e-08"},{name:"max_grad_norm",val:": float = 1.0"},{name:"num_train_epochs",val:": float = 3.0"},{name:"max_steps",val:": int = -1"},{name:"lr_scheduler_type",val:": Union = 'linear'"},{name:"lr_scheduler_kwargs",val:": Union = <factory>"},{name:"warmup_ratio",val:": float = 0.0"},{name:"warmup_steps",val:": int = 0"},{name:"log_level",val:": Optional = 'passive'"},{name:"log_level_replica",val:": Optional = 'warning'"},{name:"log_on_each_node",val:": bool = True"},{name:"logging_dir",val:": Optional = None"},{name:"logging_strategy",val:": Union = 'steps'"},{name:"logging_first_step",val:": bool = False"},{name:"logging_steps",val:": float = 500"},{name:"logging_nan_inf_filter",val:": bool = True"},{name:"save_strategy",val:": Union = 'steps'"},{name:"save_steps",val:": float = 500"},{name:"save_total_limit",val:": Optional = None"},{name:"save_safetensors",val:": Optional = True"},{name:"save_on_each_node",val:": bool = False"},{name:"save_only_model",val:": bool = False"},{name:"restore_callback_states_from_checkpoint",val:": bool = False"},{name:"no_cuda",val:": bool = False"},{name:"use_cpu",val:": bool = False"},{name:"use_mps_device",val:": bool = False"},{name:"seed",val:": int = 42"},{name:"data_seed",val:": Optional = None"},{name:"jit_mode_eval",val:": bool = False"},{name:"use_ipex",val:": bool = False"},{name:"bf16",val:": bool = False"},{name:"fp16",val:": bool = False"},{name:"fp16_opt_level",val:": str = 'O1'"},{name:"half_precision_backend",val:": str = 'auto'"},{name:"bf16_full_eval",val:": bool = False"},{name:"fp16_full_eval",val:": bool = False"},{name:"tf32",val:": Optional = None"},{name:"local_rank",val:": int = -1"},{name:"ddp_backend",val:": Optional = None"},{name:"tpu_num_cores",val:": Optional = None"},{name:"tpu_metrics_debug",val:": bool = False"},{name:"debug",val:": Union = ''"},{name:"dataloader_drop_last",val:": bool = False"},{name:"eval_steps",val:": Optional = None"},{name:"dataloader_num_workers",val:": int = 0"},{name:"dataloader_prefetch_factor",val:": Optional = None"},{name:"past_index",val:": int = -1"},{name:"run_name",val:": Optional = None"},{name:"disable_tqdm",val:": Optional = None"},{name:"remove_unused_columns",val:": Optional = True"},{name:"label_names",val:": Optional = None"},{name:"load_best_model_at_end",val:": Optional = False"},{name:"metric_for_best_model",val:": Optional = None"},{name:"greater_is_better",val:": Optional = None"},{name:"ignore_data_skip",val:": bool = False"},{name:"fsdp",val:": Union = ''"},{name:"fsdp_min_num_params",val:": int = 0"},{name:"fsdp_config",val:": Union = None"},{name:"fsdp_transformer_layer_cls_to_wrap",val:": Optional = None"},{name:"accelerator_config",val:": Union = None"},{name:"deepspeed",val:": Union = None"},{name:"label_smoothing_factor",val:": float = 0.0"},{name:"optim",val:": Union = 'adamw_torch'"},{name:"optim_args",val:": Optional = None"},{name:"adafactor",val:": bool = False"},{name:"group_by_length",val:": bool = False"},{name:"length_column_name",val:": Optional = 'length'"},{name:"report_to",val:": Union = None"},{name:"ddp_find_unused_parameters",val:": Optional = None"},{name:"ddp_bucket_cap_mb",val:": Optional = None"},{name:"ddp_broadcast_buffers",val:": Optional = None"},{name:"dataloader_pin_memory",val:": bool = True"},{name:"dataloader_persistent_workers",val:": bool = False"},{name:"skip_memory_metrics",val:": bool = True"},{name:"use_legacy_prediction_loop",val:": bool = False"},{name:"push_to_hub",val:": bool = False"},{name:"resume_from_checkpoint",val:": Optional = None"},{name:"hub_model_id",val:": Optional = None"},{name:"hub_strategy",val:": Union = 'every_save'"},{name:"hub_token",val:": Optional = None"},{name:"hub_private_repo",val:": bool = False"},{name:"hub_always_push",val:": bool = False"},{name:"gradient_checkpointing",val:": bool = False"},{name:"gradient_checkpointing_kwargs",val:": Union = None"},{name:"include_inputs_for_metrics",val:": bool = False"},{name:"eval_do_concat_batches",val:": bool = True"},{name:"fp16_backend",val:": str = 'auto'"},{name:"evaluation_strategy",val:": Union = None"},{name:"push_to_hub_model_id",val:": Optional = None"},{name:"push_to_hub_organization",val:": Optional = None"},{name:"push_to_hub_token",val:": Optional = None"},{name:"mp_parameters",val:": str = ''"},{name:"auto_find_batch_size",val:": bool = False"},{name:"full_determinism",val:": bool = False"},{name:"torchdynamo",val:": Optional = None"},{name:"ray_scope",val:": Optional = 'last'"},{name:"ddp_timeout",val:": Optional = 1800"},{name:"torch_compile",val:": bool = False"},{name:"torch_compile_backend",val:": Optional = None"},{name:"torch_compile_mode",val:": Optional = None"},{name:"dispatch_batches",val:": Optional = None"},{name:"split_batches",val:": Optional = None"},{name:"include_tokens_per_second",val:": Optional = False"},{name:"include_num_input_tokens_seen",val:": Optional = False"},{name:"neftune_noise_alpha",val:": Optional = None"},{name:"optim_target_modules",val:": Union = None"},{name:"batch_eval_metrics",val:": bool = False"},{name:"eval_on_start",val:": bool = False"},{name:"use_liger_kernel",val:": Optional = False"},{name:"eval_use_gather_object",val:": Optional = False"},{name:"max_length",val:": Optional = None"},{name:"max_prompt_length",val:": Optional = None"},{name:"max_completion_length",val:": Optional = None"},{name:"beta",val:": float = 0.1"},{name:"disable_dropout",val:": bool = True"},{name:"label_pad_token_id",val:": int = -100"},{name:"padding_value",val:": Optional = None"},{name:"truncation_mode",val:": str = 'keep_end'"},{name:"generate_during_eval",val:": bool = False"},{name:"is_encoder_decoder",val:": Optional = None"},{name:"model_init_kwargs",val:": Optional = None"},{name:"dataset_num_proc",val:": Optional = None"}],parametersDescription:[{anchor:"trl.ORPOConfig.max_length",description:`<strong>max_length</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Maximum length of the sequences (prompt + completion) in the batch. This argument is required if you want
to use the default data collator.`,name:"max_length"},{anchor:"trl.ORPOConfig.max_prompt_length",description:`<strong>max_prompt_length</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Maximum length of the prompt. This argument is required if you want to use the default data collator.`,name:"max_prompt_length"},{anchor:"trl.ORPOConfig.max_completion_length",description:`<strong>max_completion_length</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Maximum length of the completion. This argument is required if you want to use the default data collator
and your model is an encoder-decoder.`,name:"max_completion_length"},{anchor:"trl.ORPOConfig.beta",description:`<strong>beta</strong> (<code>float</code>, <em>optional</em>, defaults to <code>0.1</code>) &#x2014;
Parameter controlling the relative ratio loss weight in the ORPO loss. In the <a href="https://huggingface.co/papers/2403.07691" rel="nofollow">paper</a>,
it is denoted by &#x3BB;. In the <a href="https://github.com/xfactlab/orpo" rel="nofollow">code</a>, it is denoted by <code>alpha</code>.`,name:"beta"},{anchor:"trl.ORPOConfig.disable_dropout",description:`<strong>disable_dropout</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Whether to disable dropout in the model.`,name:"disable_dropout"},{anchor:"trl.ORPOConfig.label_pad_token_id",description:`<strong>label_pad_token_id</strong> (<code>int</code>, <em>optional</em>, defaults to <code>-100</code>) &#x2014;
Label pad token id. This argument is required if you want to use the default data collator.`,name:"label_pad_token_id"},{anchor:"trl.ORPOConfig.padding_value",description:`<strong>padding_value</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Padding value to use. If <code>None</code>, the padding value of the tokenizer is used.`,name:"padding_value"},{anchor:"trl.ORPOConfig.truncation_mode",description:`<strong>truncation_mode</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;keep_end&quot;</code>) &#x2014;
Truncation mode to use when the prompt is too long. Possible values are <code>&quot;keep_end&quot;</code> or <code>&quot;keep_start&quot;</code>.
This argument is required if you want to use the default data collator.`,name:"truncation_mode"},{anchor:"trl.ORPOConfig.generate_during_eval",description:`<strong>generate_during_eval</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
If <code>True</code>, generates and logs completions from the model to W&amp;B during evaluation.`,name:"generate_during_eval"},{anchor:"trl.ORPOConfig.is_encoder_decoder",description:`<strong>is_encoder_decoder</strong> (<code>Optional[bool]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
When using the <code>model_init</code> argument (callable) to instantiate the model instead of the <code>model</code> argument,
you need to specify if the model returned by the callable is an encoder-decoder model.`,name:"is_encoder_decoder"},{anchor:"trl.ORPOConfig.model_init_kwargs",description:`<strong>model_init_kwargs</strong> (<code>Optional[Dict[str, Any]]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Keyword arguments to pass to <code>AutoModelForCausalLM.from_pretrained</code> when instantiating the model from a
string.`,name:"model_init_kwargs"},{anchor:"trl.ORPOConfig.dataset_num_proc",description:`<strong>dataset_num_proc</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Number of processes to use for processing the dataset.`,name:"dataset_num_proc"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_config.py#L20"}}),to=new F({props:{title:"ORPOTrainer",local:"trl.ORPOTrainer",headingTag:"h2"}}),oo=new f({props:{name:"class trl.ORPOTrainer",anchor:"trl.ORPOTrainer",parameters:[{name:"model",val:": Union = None"},{name:"args",val:": Optional = None"},{name:"data_collator",val:": Optional = None"},{name:"train_dataset",val:": Optional = None"},{name:"eval_dataset",val:": Union = None"},{name:"tokenizer",val:": Optional = None"},{name:"model_init",val:": Optional = None"},{name:"callbacks",val:": Optional = None"},{name:"optimizers",val:": Tuple = (None, None)"},{name:"preprocess_logits_for_metrics",val:": Optional = None"},{name:"peft_config",val:": Optional = None"},{name:"compute_metrics",val:": Optional = None"}],parametersDescription:[{anchor:"trl.ORPOTrainer.model",description:`<strong>model</strong> (<code>transformers.PreTrainedModel</code>) &#x2014;
The model to train, preferably an <code>AutoModelForSequenceClassification</code>.`,name:"model"},{anchor:"trl.ORPOTrainer.args",description:`<strong>args</strong> (<code>ORPOConfig</code>) &#x2014;
The ORPO config arguments to use for training.`,name:"args"},{anchor:"trl.ORPOTrainer.data_collator",description:`<strong>data_collator</strong> (<code>transformers.DataCollator</code>) &#x2014;
The data collator to use for training. If None is specified, the default data collator (<code>DPODataCollatorWithPadding</code>) will be used
which will pad the sequences to the maximum length of the sequences in the batch, given a dataset of paired sequences.`,name:"data_collator"},{anchor:"trl.ORPOTrainer.train_dataset",description:`<strong>train_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for training.`,name:"train_dataset"},{anchor:"trl.ORPOTrainer.eval_dataset",description:`<strong>eval_dataset</strong> (<code>datasets.Dataset</code>) &#x2014;
The dataset to use for evaluation.`,name:"eval_dataset"},{anchor:"trl.ORPOTrainer.tokenizer",description:`<strong>tokenizer</strong> (<code>transformers.PreTrainedTokenizerBase</code>) &#x2014;
The tokenizer to use for training. This argument is required if you want to use the default data collator.`,name:"tokenizer"},{anchor:"trl.ORPOTrainer.model_init",description:`<strong>model_init</strong> (<code>Callable[[], transformers.PreTrainedModel]</code>) &#x2014;
The model initializer to use for training. If None is specified, the default model initializer will be used.`,name:"model_init"},{anchor:"trl.ORPOTrainer.callbacks",description:`<strong>callbacks</strong> (<code>List[transformers.TrainerCallback]</code>) &#x2014;
The callbacks to use for training.`,name:"callbacks"},{anchor:"trl.ORPOTrainer.optimizers",description:`<strong>optimizers</strong> (<code>Tuple[torch.optim.Optimizer, torch.optim.lr_scheduler.LambdaLR]</code>) &#x2014;
The optimizer and scheduler to use for training.`,name:"optimizers"},{anchor:"trl.ORPOTrainer.preprocess_logits_for_metrics",description:`<strong>preprocess_logits_for_metrics</strong> (<code>Callable[[torch.Tensor, torch.Tensor], torch.Tensor]</code>) &#x2014;
The function to use to preprocess the logits before computing the metrics.`,name:"preprocess_logits_for_metrics"},{anchor:"trl.ORPOTrainer.peft_config",description:`<strong>peft_config</strong> (<code>Dict</code>, defaults to <code>None</code>) &#x2014;
The PEFT configuration to use for training. If you pass a PEFT configuration, the model will be wrapped in a PEFT model.`,name:"peft_config"},{anchor:"trl.ORPOTrainer.compute_metrics",description:`<strong>compute_metrics</strong> (<code>Callable[[EvalPrediction], Dict]</code>, <em>optional</em>) &#x2014;
The function to use to compute the metrics. Must take a <code>EvalPrediction</code> and return
a dictionary string to metric values.`,name:"compute_metrics"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L65"}}),ao=new f({props:{name:"build_tokenized_answer",anchor:"trl.ORPOTrainer.build_tokenized_answer",parameters:[{name:"prompt",val:""},{name:"answer",val:""}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L343"}}),no=new f({props:{name:"concatenated_forward",anchor:"trl.ORPOTrainer.concatenated_forward",parameters:[{name:"model",val:": Module"},{name:"batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L671"}}),ro=new f({props:{name:"concatenated_inputs",anchor:"trl.ORPOTrainer.concatenated_inputs",parameters:[{name:"batch",val:": Dict"},{name:"is_encoder_decoder",val:": bool = False"},{name:"label_pad_token_id",val:": int = -100"},{name:"padding_value",val:": int = 0"},{name:"device",val:": Optional = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L539",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A dictionary containing the concatenated inputs under the key ‘concatenated_input_ids’.</p>
`}}),lo=new f({props:{name:"evaluation_loop",anchor:"trl.ORPOTrainer.evaluation_loop",parameters:[{name:"dataloader",val:": DataLoader"},{name:"description",val:": str"},{name:"prediction_loss_only",val:": Optional = None"},{name:"ignore_keys",val:": Optional = None"},{name:"metric_key_prefix",val:": str = 'eval'"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L886"}}),io=new f({props:{name:"get_batch_logps",anchor:"trl.ORPOTrainer.get_batch_logps",parameters:[{name:"logits",val:": FloatTensor"},{name:"labels",val:": LongTensor"},{name:"average_log_prob",val:": bool = False"},{name:"label_pad_token_id",val:": int = -100"},{name:"is_encoder_decoder",val:": bool = False"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L633",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tensor of shape (batch_size,) containing the average/sum log probabilities of the given labels under the given logits.</p>
`}}),so=new f({props:{name:"get_batch_loss_metrics",anchor:"trl.ORPOTrainer.get_batch_loss_metrics",parameters:[{name:"model",val:""},{name:"batch",val:": Dict"},{name:"train_eval",val:": Literal = 'train'"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L748"}}),co=new f({props:{name:"get_batch_samples",anchor:"trl.ORPOTrainer.get_batch_samples",parameters:[{name:"model",val:""},{name:"batch",val:": Dict"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L821"}}),mo=new f({props:{name:"log",anchor:"trl.ORPOTrainer.log",parameters:[{name:"logs",val:": Dict"}],parametersDescription:[{anchor:"trl.ORPOTrainer.log.logs",description:`<strong>logs</strong> (<code>Dict[str, float]</code>) &#x2014;
The values to log.`,name:"logs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L934"}}),po=new f({props:{name:"odds_ratio_loss",anchor:"trl.ORPOTrainer.odds_ratio_loss",parameters:[{name:"policy_chosen_logps",val:": FloatTensor"},{name:"policy_rejected_logps",val:": FloatTensor"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L601",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>(losses, chosen_rewards, rejected_rewards).
The losses tensor contains the ORPO loss for each example in the batch.
The chosen_rewards and rejected_rewards tensors contain the rewards for the chosen and rejected responses, respectively.
The log odds ratio of the chosen responses over the rejected responses ratio for logging purposes.
The <code>log(sigmoid(log_odds_chosen))</code> for logging purposes.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tuple of three tensors</p>
`}}),go=new f({props:{name:"tokenize_row",anchor:"trl.ORPOTrainer.tokenize_row",parameters:[{name:"feature",val:""},{name:"model",val:": Union = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/orpo_trainer.py#L393"}}),_o=new F({props:{title:"PPOConfig",local:"trl.PPOConfig",headingTag:"h2"}}),uo=new f({props:{name:"class trl.PPOConfig",anchor:"trl.PPOConfig",parameters:[{name:"exp_name",val:": str = 'doc-buil'"},{name:"seed",val:": int = 0"},{name:"log_with",val:": Optional = None"},{name:"task_name",val:": Optional = None"},{name:"model_name",val:": str = 'gpt2'"},{name:"query_dataset",val:": str = 'stanfordnlp/imdb'"},{name:"reward_model",val:": str = 'sentiment-analysis:lvwerra/distilbert-imdb'"},{name:"remove_unused_columns",val:": bool = True"},{name:"tracker_kwargs",val:": Annotated = <factory>"},{name:"accelerator_kwargs",val:": Annotated = <factory>"},{name:"project_kwargs",val:": Annotated = <factory>"},{name:"tracker_project_name",val:": str = 'trl'"},{name:"push_to_hub_if_best_kwargs",val:": Annotated = <factory>"},{name:"steps",val:": int = 20000"},{name:"learning_rate",val:": float = 1.41e-05"},{name:"adap_kl_ctrl",val:": bool = True"},{name:"init_kl_coef",val:": float = 0.2"},{name:"kl_penalty",val:": Literal = 'kl'"},{name:"target",val:": float = 6.0"},{name:"horizon",val:": float = 10000.0"},{name:"gamma",val:": float = 1.0"},{name:"lam",val:": float = 0.95"},{name:"cliprange",val:": float = 0.2"},{name:"cliprange_value",val:": float = 0.2"},{name:"vf_coef",val:": float = 0.1"},{name:"batch_size",val:": int = 128"},{name:"forward_batch_size",val:": Optional = None"},{name:"mini_batch_size",val:": int = 128"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"world_size",val:": Annotated = None"},{name:"ppo_epochs",val:": int = 4"},{name:"max_grad_norm",val:": Optional = None"},{name:"optimize_cuda_cache",val:": Optional = None"},{name:"optimize_device_cache",val:": bool = False"},{name:"early_stopping",val:": bool = False"},{name:"target_kl",val:": float = 1.0"},{name:"compare_steps",val:": int = 1"},{name:"ratio_threshold",val:": float = 10.0"},{name:"use_score_scaling",val:": bool = False"},{name:"use_score_norm",val:": bool = False"},{name:"score_clip",val:": Optional = None"},{name:"whiten_rewards",val:": bool = False"},{name:"gradient_checkpointing",val:": bool = False"},{name:"is_encoder_decoder",val:": Optional = None"},{name:"is_peft_model",val:": Optional = None"},{name:"backward_batch_size",val:": Annotated = None"},{name:"global_backward_batch_size",val:": Optional = None"},{name:"global_batch_size",val:": Annotated = None"},{name:"dataset_num_proc",val:": Optional = None"}],parametersDescription:[{anchor:"trl.PPOConfig.exp_name",description:`<strong>exp_name</strong> (<code>str</code>, <em>optional</em>, defaults to <code>os.path.basename(__file__)[ -- -len(&quot;.py&quot;)]</code>):
Name of this experiment.`,name:"exp_name"},{anchor:"trl.PPOConfig.seed",description:`<strong>seed</strong> (<code>int</code>, <em>optional</em>, defaults to <code>0</code>) &#x2014;
Random seed.`,name:"seed"},{anchor:"trl.PPOConfig.log_with",description:`<strong>log_with</strong> (<code>Optional[Literal[&quot;wandb&quot;, &quot;tensorboard&quot;]]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Log with either <code>&quot;wandb&quot;</code> or <code>&quot;tensorboard&quot;</code>. Check
<a href="https://huggingface.co/docs/accelerate/usage_guides/tracking" rel="nofollow">tracking</a> for more details.`,name:"log_with"},{anchor:"trl.PPOConfig.task_name",description:`<strong>task_name</strong> (<code>Optional[str]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Name of task to use - used only for tracking purposes.`,name:"task_name"},{anchor:"trl.PPOConfig.model_name",description:`<strong>model_name</strong> (<code>Optional[str]</code>, <em>optional</em>, defaults to <code>&quot;gpt2&quot;</code>) &#x2014;
Name of model to use - used only for tracking purposes.`,name:"model_name"},{anchor:"trl.PPOConfig.query_dataset",description:`<strong>query_dataset</strong> (<code>Optional[str]</code>, <em>optional</em>, defaults to <code>&quot;imdb&quot;</code>) &#x2014;
Name of dataset to query - used only for tracking purposes.`,name:"query_dataset"},{anchor:"trl.PPOConfig.reward_model",description:`<strong>reward_model</strong> (<code>Optional[str]</code>, <em>optional</em>, defaults to <code>&quot;sentiment-analysis --lvwerra/distilbert-imdb&quot;</code>):
Reward model to use - used only for tracking purposes.`,name:"reward_model"},{anchor:"trl.PPOConfig.remove_unused_columns",description:`<strong>remove_unused_columns</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Remove unused columns from the dataset.`,name:"remove_unused_columns"},{anchor:"trl.PPOConfig.tracker_kwargs",description:`<strong>tracker_kwargs</strong> (<code>JSONDict</code>, <em>optional</em>, defaults to <code>{}</code>) &#x2014;
Keyword arguments for the tracker (e.g. <code>python ppo.py --tracker_kwargs=&apos;{&quot;wandb&quot;: {&quot;entity&quot;: &quot;my_wandb_entity&quot;, &quot;name&quot;: &quot;my_exp_name&quot;}&#x200C;}&apos;</code>.`,name:"tracker_kwargs"},{anchor:"trl.PPOConfig.accelerator_kwargs",description:`<strong>accelerator_kwargs</strong> (<code>JSONDict</code>, <em>optional</em>, defaults to <code>{}</code>) &#x2014;
Keyword arguments for the accelerator.`,name:"accelerator_kwargs"},{anchor:"trl.PPOConfig.project_kwargs",description:`<strong>project_kwargs</strong> (<code>JSONDict</code>, <em>optional</em>, defaults to <code>{}</code>) &#x2014;
Keyword arguments for the accelerator project config (e.g. <code>logging_dir</code>).`,name:"project_kwargs"},{anchor:"trl.PPOConfig.tracker_project_name",description:`<strong>tracker_project_name</strong> (<code>str</code>, <em>optional</em>, defaults to <code>&quot;trl&quot;</code>) &#x2014;
Name of project to use for tracking.`,name:"tracker_project_name"},{anchor:"trl.PPOConfig.push_to_hub_if_best_kwargs",description:`<strong>push_to_hub_if_best_kwargs</strong> (<code>JSONDict</code>, <em>optional</em>, defaults to <code>{}</code>) &#x2014;
Keyword arguments for pushing model to the hub during training (e.g. repo_id).`,name:"push_to_hub_if_best_kwargs"},{anchor:"trl.PPOConfig.steps",description:`<strong>steps</strong> (<code>int</code>, <em>optional</em>, defaults to <code>20000</code>) &#x2014;
Number of training steps.`,name:"steps"},{anchor:"trl.PPOConfig.learning_rate",description:`<strong>learning_rate</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1.41e-5</code>) &#x2014;
Learning rate for the optimizer.`,name:"learning_rate"},{anchor:"trl.PPOConfig.adap_kl_ctrl",description:`<strong>adap_kl_ctrl</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>True</code>) &#x2014;
Use adaptive KL control, otherwise linear.`,name:"adap_kl_ctrl"},{anchor:"trl.PPOConfig.init_kl_coef",description:`<strong>init_kl_coef</strong> (<code>Optional[float]</code>, <em>optional</em>, defaults to <code>0.2</code>) &#x2014;
Initial KL penalty coefficient (used for adaptive and linear control).`,name:"init_kl_coef"},{anchor:"trl.PPOConfig.kl_penalty",description:`<strong>kl_penalty</strong> (<code>Literal[&quot;kl&quot;, &quot;abs&quot;, &quot;mse&quot;, &quot;full&quot;]</code>, <em>optional</em>, defaults to <code>&quot;kl&quot;</code>) &#x2014;
kl penalty options. Possible values are:</p>
<ul>
<li><code>&quot;kl&quot;</code>: model_logp - ref_logp</li>
<li><code>&quot;abs&quot;</code>: abs(kl)</li>
<li><code>&quot;mse&quot;</code>: mean squared error mse(kl)</li>
<li><code>&quot;full&quot;</code>: the actual kl for all tokens in the distribution.</li>
</ul>`,name:"kl_penalty"},{anchor:"trl.PPOConfig.target",description:`<strong>target</strong> (<code>float</code>, <em>optional</em>, defaults to <code>6.0</code>) &#x2014;
Target KL value for adaptive KL control.`,name:"target"},{anchor:"trl.PPOConfig.horizon",description:`<strong>horizon</strong> (<code>float</code>, <em>optional</em>, defaults to <code>10000.0</code>) &#x2014;
Horizon for adaptive KL control.`,name:"horizon"},{anchor:"trl.PPOConfig.gamma",description:`<strong>gamma</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1.0</code>) &#x2014;
Gamma parameter for advantage calculation.`,name:"gamma"},{anchor:"trl.PPOConfig.lam",description:`<strong>lam</strong> (<code>float</code>, <em>optional</em>, defaults to <code>0.95</code>) &#x2014;
Lambda parameter for advantage calculation.`,name:"lam"},{anchor:"trl.PPOConfig.cliprange",description:`<strong>cliprange</strong> (<code>float</code>, <em>optional</em>, defaults to <code>0.2</code>) &#x2014;
Range for clipping in PPO policy gradient loss.`,name:"cliprange"},{anchor:"trl.PPOConfig.cliprange_value",description:`<strong>cliprange_value</strong> (<code>float</code>, <em>optional</em>, defaults to <code>0.2</code>) &#x2014;
Range for clipping values in loss calculation.`,name:"cliprange_value"},{anchor:"trl.PPOConfig.vf_coef",description:`<strong>vf_coef</strong> (<code>float</code>, <em>optional</em>, defaults to <code>0.1</code>) &#x2014;
Scaling factor for value loss.`,name:"vf_coef"},{anchor:"trl.PPOConfig.batch_size",description:`<strong>batch_size</strong> (<code>int</code>, <em>optional</em>, defaults to <code>128</code>) &#x2014;
Number of samples per optimisation step.`,name:"batch_size"},{anchor:"trl.PPOConfig.forward_batch_size",description:`<strong>forward_batch_size</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
DEPRECATED: use <code>mini_batch_size</code> instead, which does the same thing.`,name:"forward_batch_size"},{anchor:"trl.PPOConfig.mini_batch_size",description:`<strong>mini_batch_size</strong> (<code>int</code>, <em>optional</em>, defaults to <code>128</code>) &#x2014;
Number of samples optimized in each mini batch.`,name:"mini_batch_size"},{anchor:"trl.PPOConfig.gradient_accumulation_steps",description:`<strong>gradient_accumulation_steps</strong> (<code>int</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014;
Number of gradient accumulation steps.`,name:"gradient_accumulation_steps"},{anchor:"trl.PPOConfig.world_size",description:`<strong>world_size</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Number of processes to use for distributed training.`,name:"world_size"},{anchor:"trl.PPOConfig.ppo_epochs",description:`<strong>ppo_epochs</strong> (<code>int</code>, <em>optional</em>, defaults to <code>4</code>) &#x2014;
Number of optimisation epochs per batch of samples.`,name:"ppo_epochs"},{anchor:"trl.PPOConfig.optimize_device_cache",description:`<strong>optimize_device_cache</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Optimize device cache for slightly more memory-efficient training.`,name:"optimize_device_cache"},{anchor:"trl.PPOConfig.early_stopping",description:`<strong>early_stopping</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to stop the PPO optimization loop early is the KL too high.`,name:"early_stopping"},{anchor:"trl.PPOConfig.target_kl",description:`<strong>target_kl</strong> (<code>float</code>, <em>optional</em>, defaults to <code>1.0</code>) &#x2014;
Stop early if we exceed this value by over 50%.`,name:"target_kl"},{anchor:"trl.PPOConfig.compare_steps",description:`<strong>compare_steps</strong> (<code>int</code>, <em>optional</em>, defaults to <code>1</code>) &#x2014;
Compare the current step with the previous <code>compare_steps</code> steps.`,name:"compare_steps"},{anchor:"trl.PPOConfig.ratio_threshold",description:`<strong>ratio_threshold</strong> (<code>float</code>, <em>optional</em>, defaults to <code>10.0</code>) &#x2014;
Skip mini-batches with high PPO ratios that can cause loss spikes.`,name:"ratio_threshold"},{anchor:"trl.PPOConfig.use_score_scaling",description:`<strong>use_score_scaling</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Use score scaling.`,name:"use_score_scaling"},{anchor:"trl.PPOConfig.use_score_norm",description:`<strong>use_score_norm</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Use score normalization. Only applicable if <code>use_score_scaling</code> is True.`,name:"use_score_norm"},{anchor:"trl.PPOConfig.score_clip",description:`<strong>score_clip</strong> (<code>Optional[float]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Score clipping.`,name:"score_clip"},{anchor:"trl.PPOConfig.whiten_rewards",description:`<strong>whiten_rewards</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whiten the rewards before computing advantages.`,name:"whiten_rewards"},{anchor:"trl.PPOConfig.is_encoder_decoder",description:`<strong>is_encoder_decoder</strong> (<code>Optional[bool]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
When using the <code>model_init</code> argument (callable) to instantiate the model instead of the <code>model</code> argument,
you need to specify if the model returned by the callable is an encoder-decoder model.`,name:"is_encoder_decoder"},{anchor:"trl.PPOConfig.is_peft_model",description:`<strong>is_peft_model</strong> (<code>Optional[bool]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Whether the model is a PEFT model.`,name:"is_peft_model"},{anchor:"trl.PPOConfig.backward_batch_size",description:`<strong>backward_batch_size</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Number of samples optimized in an <code>optimizer.step()</code> call.`,name:"backward_batch_size"},{anchor:"trl.PPOConfig.global_backward_batch_size",description:`<strong>global_backward_batch_size</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Effective <code>backward_batch_size</code> across all processes.`,name:"global_backward_batch_size"},{anchor:"trl.PPOConfig.global_batch_size",description:`<strong>global_batch_size</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Effective <code>batch_size</code> across all processes.`,name:"global_batch_size"},{anchor:"trl.PPOConfig.dataset_num_proc",description:`<strong>dataset_num_proc</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Number of processes to use for processing the dataset.`,name:"dataset_num_proc"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_config.py#L34"}}),ho=new F({props:{title:"PPOTrainer",local:"trl.PPOTrainer",headingTag:"h2"}}),fo=new f({props:{name:"class trl.PPOTrainer",anchor:"trl.PPOTrainer",parameters:[{name:"config",val:": Optional = None"},{name:"model",val:": Optional = None"},{name:"ref_model",val:": Optional = None"},{name:"tokenizer",val:": Optional = None"},{name:"dataset",val:": Union = None"},{name:"optimizer",val:": Optional = None"},{name:"data_collator",val:": Optional = None"},{name:"num_shared_layers",val:": Optional = None"},{name:"lr_scheduler",val:": Optional = None"},{name:"training_data_collator",val:": Optional = None"}],parametersDescription:[{anchor:"trl.PPOTrainer.*config**",description:`*<strong>*config**</strong> (<code>PPOConfig</code>) &#x2014; Configuration object for PPOTrainer. Check the documentation of <code>PPOConfig</code> for more &#x2014;
details.`,name:"*config**"},{anchor:"trl.PPOTrainer.*model**",description:`*<strong>*model**</strong> (<code>PreTrainedModelWrapper</code>) &#x2014; Model to be optimized, Hugging Face transformer model with a value head. &#x2014;
Check the documentation of <code>PreTrainedModelWrapper</code> for more details.`,name:"*model**"},{anchor:"trl.PPOTrainer.*ref_model**",description:`*<strong>*ref_model**</strong> (<code>PreTrainedModelWrapper</code>, <em>optional</em>) &#x2014; Reference model to be used for KL penalty, Hugging Face &#x2014;
transformer model with a casual language modelling head. Check the documentation of <code>PreTrainedModelWrapper</code>
for more details. If no reference model is provided, the trainer will create a reference model with the same
architecture as the model to be optimized with shared layers.`,name:"*ref_model**"},{anchor:"trl.PPOTrainer.*tokenizer**",description:`*<strong>*tokenizer**</strong> (<code>PreTrainedTokenizerBase</code>) &#x2014; Tokenizer to be used for encoding the &#x2014;
data. Check the documentation of <code>transformers.PreTrainedTokenizer</code> and
<code>transformers.PreTrainedTokenizerFast</code> for more details.`,name:"*tokenizer**"},{anchor:"trl.PPOTrainer.*dataset**",description:`*<strong>*dataset**</strong> (Union[<code>torch.utils.data.Dataset</code>, <code>datasets.Dataset</code>], <em>optional</em>) &#x2014; PyTorch dataset or Hugging &#x2014;
Face dataset. This is used to create a PyTorch dataloader. If no dataset is provided, the dataloader must be
created outside the trainer users needs to design their own dataloader and make sure the batch
size that is used is the same as the one specified in the configuration object.`,name:"*dataset**"},{anchor:"trl.PPOTrainer.*optimizer**",description:`*<strong>*optimizer**</strong> (<code>torch.optim.Optimizer</code>, <em>optional</em>) &#x2014; Optimizer to be used for training. If no optimizer is &#x2014;
provided, the trainer will create an Adam optimizer with the learning rate specified in the configuration
object.`,name:"*optimizer**"},{anchor:"trl.PPOTrainer.*data_collator**",description:`*<strong>*data_collator**</strong> (DataCollatorForLanguageModeling, <em>optional</em>) &#x2014; Data collator to be used for training and &#x2014;
passed along the dataloader`,name:"*data_collator**"},{anchor:"trl.PPOTrainer.*num_shared_layers**",description:`*<strong>*num_shared_layers**</strong> (int, <em>optional</em>) &#x2014; Number of layers to be shared between the model and the reference &#x2014;
model, if no reference model is passed. If no number is provided, all the layers will be shared.`,name:"*num_shared_layers**"},{anchor:"trl.PPOTrainer.*lr_scheduler**",description:"*<strong>*lr_scheduler**</strong> (<code>torch.optim.lr_scheduler</code>, <em>optional</em>) &#x2014; Learning rate scheduler to be used for training. &#x2014;",name:"*lr_scheduler**"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L115"}}),vo=new f({props:{name:"batched_forward_pass",anchor:"trl.PPOTrainer.batched_forward_pass",parameters:[{name:"model",val:": PreTrainedModelWrapper"},{name:"queries",val:": Tensor"},{name:"responses",val:": Tensor"},{name:"model_inputs",val:": dict"},{name:"return_logits",val:": bool = False"},{name:"response_masks",val:": Optional = None"}],parametersDescription:[{anchor:"trl.PPOTrainer.batched_forward_pass.queries",description:`<strong>queries</strong> (<code>torch.LongTensor</code>) &#x2014;
List of tensors containing the encoded queries, shape (<code>batch_size</code>, <code>query_length</code>)`,name:"queries"},{anchor:"trl.PPOTrainer.batched_forward_pass.responses",description:`<strong>responses</strong> (<code>torch.LongTensor</code>) &#x2014;
List of tensors containing the encoded responses, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"responses"},{anchor:"trl.PPOTrainer.batched_forward_pass.return_logits",description:`<strong>return_logits</strong> (<code>bool</code>, <em>optional</em>, defaults to <code>False</code>) &#x2014;
Whether to return all_logits. Set to <code>False</code> if logits are not needed to reduce memory consumption.`,name:"return_logits"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L976",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<ul>
<li>all_logprobs (<code>torch.FloatTensor</code>): Log probabilities of the responses,
shape (<code>batch_size</code>, <code>response_length</code>)</li>
<li>all_ref_logprobs (<code>torch.FloatTensor</code>): Log probabilities of the responses,
shape (<code>batch_size</code>, <code>response_length</code>)</li>
<li>all_values (<code>torch.FloatTensor</code>): Values of the responses, shape (<code>batch_size</code>, <code>response_length</code>)</li>
</ul>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>(tuple)</p>
`}}),bo=new f({props:{name:"compute_rewards",anchor:"trl.PPOTrainer.compute_rewards",parameters:[{name:"scores",val:": FloatTensor"},{name:"logprobs",val:": FloatTensor"},{name:"ref_logprobs",val:": FloatTensor"},{name:"masks",val:": LongTensor"}],parametersDescription:[{anchor:"trl.PPOTrainer.compute_rewards.scores",description:`<strong>scores</strong> (<code>torch.FloatTensor</code>) &#x2014;
Scores from the reward model, shape (<code>batch_size</code>)`,name:"scores"},{anchor:"trl.PPOTrainer.compute_rewards.logprobs",description:`<strong>logprobs</strong> (<code>torch.FloatTensor</code>) &#x2014;
Log probabilities of the model, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"logprobs"},{anchor:"trl.PPOTrainer.compute_rewards.ref_logprobs",description:`<strong>ref_logprobs</strong> (<code>torch.FloatTensor</code>) &#x2014;
Log probabilities of the reference model, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"ref_logprobs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1110",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>Per token rewards, shape (<code>batch_size</code>, <code>response_length</code>)
<code>torch.FloatTensor</code>: Non score rewards, shape (<code>batch_size</code>, <code>response_length</code>)
<code>torch.FloatTensor</code>: KL penalty, shape (<code>batch_size</code>, <code>response_length</code>)</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.FloatTensor</code></p>
`}}),Oo=new f({props:{name:"create_model_card",anchor:"trl.PPOTrainer.create_model_card",parameters:[{name:"path",val:": str"},{name:"model_name",val:": Optional = 'TRL Model'"}],parametersDescription:[{anchor:"trl.PPOTrainer.create_model_card.path",description:"<strong>path</strong> (<code>str</code>) &#x2014; The path to save the model card to.",name:"path"},{anchor:"trl.PPOTrainer.create_model_card.model_name",description:"<strong>model_name</strong> (<code>str</code>, <em>optional</em>) &#x2014; The name of the model, defaults to <code>TRL Model</code>.",name:"model_name"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1418"}}),To=new f({props:{name:"gather_stats",anchor:"trl.PPOTrainer.gather_stats",parameters:[{name:"stats",val:""}],parametersDescription:[{anchor:"trl.PPOTrainer.gather_stats.stats",description:"<strong>stats</strong> (dict[str, Any]) &#x2014;",name:"stats"},{anchor:"trl.PPOTrainer.gather_stats.a",description:"<strong>a</strong> dictionary of stats to be gathered. The stats should contain torch tensors. &#x2014;",name:"a"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L932",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A dictionary of stats with the tensors gathered.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>dict[str, Any]</code></p>
`}}),xo=new f({props:{name:"generate",anchor:"trl.PPOTrainer.generate",parameters:[{name:"query_tensor",val:": Union"},{name:"length_sampler",val:": Optional = None"},{name:"batch_size",val:": int = 4"},{name:"return_prompt",val:": bool = True"},{name:"generate_ref_response",val:": bool = False"},{name:"**generation_kwargs",val:""}],parametersDescription:[{anchor:"trl.PPOTrainer.generate.query_tensor",description:`<strong>query_tensor</strong> (<code>torch.LongTensor</code>) &#x2014;
A tensor of shape (<code>seq_len</code>) containing query tokens or a list of tensors of shape (<code>seq_len</code>).`,name:"query_tensor"},{anchor:"trl.PPOTrainer.generate.length_sampler",description:`<strong>length_sampler</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
Callable that returns the number of newly generated tokens.`,name:"length_sampler"},{anchor:"trl.PPOTrainer.generate.batch_size",description:`<strong>batch_size</strong> (<code>int</code>, *optional) &#x2014;
Batch size used for generation, defaults to <code>4</code>.`,name:"batch_size"},{anchor:"trl.PPOTrainer.generate.return_prompt",description:`<strong>return_prompt</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>False</code> the prompt is not returned but only the newly generated tokens, defaults to <code>True</code>.`,name:"return_prompt"},{anchor:"trl.PPOTrainer.generate.generate_ref_response",description:`<strong>generate_ref_response</strong> (<code>bool</code>, <em>optional</em>) &#x2014;
If set to <code>True</code> the reference response is also generated, defaults to <code>False</code>.`,name:"generate_ref_response"},{anchor:"trl.PPOTrainer.generate.generation_kwargs",description:`<strong>generation_kwargs</strong> (dict[str, Any]) &#x2014;
Keyword arguments for generation.`,name:"generation_kwargs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L460",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A tensor of shape (<code>batch_size</code>, <code>gen_len</code>) containing response tokens.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.LongTensor</code></p>
`}}),$o=new f({props:{name:"log_stats",anchor:"trl.PPOTrainer.log_stats",parameters:[{name:"stats",val:": dict"},{name:"batch",val:": dict"},{name:"rewards",val:": List"},{name:"columns_to_log",val:": Iterable = ('query', 'response')"}],parametersDescription:[{anchor:"trl.PPOTrainer.log_stats.stats",description:`<strong>stats</strong> (dict[str, Any]) &#x2014;
A dictionary of training stats.`,name:"stats"},{anchor:"trl.PPOTrainer.log_stats.batch",description:`<strong>batch</strong> (dict[str, Any]) &#x2014;
A dictionary of batch data, this contains the queries and responses.`,name:"batch"},{anchor:"trl.PPOTrainer.log_stats.rewards",description:`<strong>rewards</strong> (<code>List[torch.FloatTensor]</code>) &#x2014;
A tensor of rewards.`,name:"rewards"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1345"}}),Po=new f({props:{name:"loss",anchor:"trl.PPOTrainer.loss",parameters:[{name:"old_logprobs",val:": FloatTensor"},{name:"values",val:": FloatTensor"},{name:"logits",val:": FloatTensor"},{name:"vpreds",val:": FloatTensor"},{name:"logprobs",val:": FloatTensor"},{name:"mask",val:": LongTensor"},{name:"advantages",val:": FloatTensor"},{name:"returns",val:": FloatTensor"}],parametersDescription:[{anchor:"trl.PPOTrainer.loss.old_logprobs",description:`<strong>old_logprobs</strong> (<code>torch.FloatTensor</code>) &#x2014;
Log probabilities of the model, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"old_logprobs"},{anchor:"trl.PPOTrainer.loss.values",description:`<strong>values</strong> (<code>torch.FloatTensor</code>) &#x2014;
Values of the value head, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"values"},{anchor:"trl.PPOTrainer.loss.rewards",description:`<strong>rewards</strong> (<code>torch.FloatTensor</code>) &#x2014;
Rewards from the reward model, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"rewards"},{anchor:"trl.PPOTrainer.loss.logits",description:`<strong>logits</strong> (<code>torch.FloatTensor</code>) &#x2014;
Logits of the model, shape (<code>batch_size</code>, <code>response_length</code>, <code>vocab_size</code>)`,name:"logits"},{anchor:"trl.PPOTrainer.loss.v_pred",description:`<strong>v_pred</strong> (<code>torch.FloatTensor</code>) &#x2014;
Values of the value head, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"v_pred"},{anchor:"trl.PPOTrainer.loss.logprobs",description:`<strong>logprobs</strong> (<code>torch.FloatTensor</code>) &#x2014;
Log probabilities of the model, shape (<code>batch_size</code>, <code>response_length</code>)`,name:"logprobs"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1192"}}),wo=new f({props:{name:"prepare_dataloader",anchor:"trl.PPOTrainer.prepare_dataloader",parameters:[{name:"dataset",val:": Union"},{name:"data_collator",val:" = None"}],parametersDescription:[{anchor:"trl.PPOTrainer.prepare_dataloader.dataset",description:`<strong>dataset</strong> (Union[<code>torch.utils.data.Dataset</code>, <code>datasets.Dataset</code>]) &#x2014;
PyTorch dataset or Hugging Face dataset. If a Hugging Face dataset is passed, the dataset
will be preprocessed by removing the columns that are not used by the model.`,name:"dataset"},{anchor:"trl.PPOTrainer.prepare_dataloader.data_collator",description:`<strong>data_collator</strong> (Optional[function]) &#x2014;
Data collator function.`,name:"data_collator"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L405",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>PyTorch dataloader</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.utils.data.DataLoader</code></p>
`}}),Co=new f({props:{name:"record_step_stats",anchor:"trl.PPOTrainer.record_step_stats",parameters:[{name:"kl_coef",val:": float"},{name:"**data",val:""}],parametersDescription:[{anchor:"trl.PPOTrainer.record_step_stats.kl_coef",description:`<strong>kl_coef</strong> (<code>float</code>) &#x2014;
KL coefficient`,name:"kl_coef"},{anchor:"trl.PPOTrainer.record_step_stats.data",description:`<strong>data</strong> (<code>dict</code>) &#x2014;
Dictionary of training step data`,name:"data"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1281",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>Dictionary of training step statistics</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>stats (<code>dict</code>)</p>
`}}),yo=new f({props:{name:"step",anchor:"trl.PPOTrainer.step",parameters:[{name:"queries",val:": List"},{name:"responses",val:": List"},{name:"scores",val:": List"},{name:"response_masks",val:": Optional = None"}],parametersDescription:[{anchor:"trl.PPOTrainer.step.queries",description:`<strong>queries</strong> (List<code>torch.LongTensor</code>) &#x2014;
List of tensors containing the encoded queries of shape (<code>query_length</code>)`,name:"queries"},{anchor:"trl.PPOTrainer.step.responses",description:`<strong>responses</strong> (List<code>torch.LongTensor</code>) &#x2014;
List of tensors containing the encoded responses of shape (<code>response_length</code>)`,name:"responses"},{anchor:"trl.PPOTrainer.step.scores",description:`<strong>scores</strong> (List<code>torch.FloatTensor</code>) &#x2014;
List of tensors containing the scores.`,name:"scores"},{anchor:"trl.PPOTrainer.step.response_masks",description:`<strong>response_masks</strong> (List<code>torch.FloatTensor</code>, <em>optional</em>)) &#x2014;
List of tensors containing masks of the response tokens.`,name:"response_masks"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L652",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A summary of the training statistics</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>dict[str, Any]</code></p>
`}}),ko=new f({props:{name:"train_minibatch",anchor:"trl.PPOTrainer.train_minibatch",parameters:[{name:"old_logprobs",val:": FloatTensor"},{name:"values",val:": FloatTensor"},{name:"logprobs",val:": FloatTensor"},{name:"logits",val:": FloatTensor"},{name:"vpreds",val:": FloatTensor"},{name:"mask",val:": LongTensor"},{name:"advantages",val:": FloatTensor"},{name:"returns",val:": FloatTensor"}],parametersDescription:[{anchor:"trl.PPOTrainer.train_minibatch.logprobs",description:`<strong>logprobs</strong> (<code>torch.FloatTensor</code>) &#x2014;
Log probabilities of the model, shape [mini_batch_size, response_length]`,name:"logprobs"},{anchor:"trl.PPOTrainer.train_minibatch.values",description:`<strong>values</strong> (<code>torch.FloatTensor</code>) &#x2014;
Values of the value head, shape [mini_batch_size, response_length]`,name:"values"},{anchor:"trl.PPOTrainer.train_minibatch.query",description:`<strong>query</strong> (<code>torch.LongTensor</code>) &#x2014;
Encoded queries, shape [mini_batch_size, query_length]`,name:"query"},{anchor:"trl.PPOTrainer.train_minibatch.response",description:`<strong>response</strong> (<code>torch.LongTensor</code>) &#x2014;
Encoded responses, shape [mini_batch_size, response_length]`,name:"response"},{anchor:"trl.PPOTrainer.train_minibatch.model_input",description:`<strong>model_input</strong> (<code>torch.LongTensor</code>) &#x2014;
Concatenated queries and responses, shape [mini_batch_size, query_length+response_length]`,name:"model_input"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/ppo_trainer.py#L1064",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>Dictionary of training statistics</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p>train_stats (dict[str, <code>torch.Tensor</code>])</p>
`}}),Do=new F({props:{title:"RewardConfig",local:"trl.RewardConfig",headingTag:"h2"}}),No=new f({props:{name:"class trl.RewardConfig",anchor:"trl.RewardConfig",parameters:[{name:"output_dir",val:": str"},{name:"overwrite_output_dir",val:": bool = False"},{name:"do_train",val:": bool = False"},{name:"do_eval",val:": bool = False"},{name:"do_predict",val:": bool = False"},{name:"eval_strategy",val:": Union = 'no'"},{name:"prediction_loss_only",val:": bool = False"},{name:"per_device_train_batch_size",val:": int = 8"},{name:"per_device_eval_batch_size",val:": int = 8"},{name:"per_gpu_train_batch_size",val:": Optional = None"},{name:"per_gpu_eval_batch_size",val:": Optional = None"},{name:"gradient_accumulation_steps",val:": int = 1"},{name:"eval_accumulation_steps",val:": Optional = None"},{name:"eval_delay",val:": Optional = 0"},{name:"torch_empty_cache_steps",val:": Optional = None"},{name:"learning_rate",val:": float = 5e-05"},{name:"weight_decay",val:": float = 0.0"},{name:"adam_beta1",val:": float = 0.9"},{name:"adam_beta2",val:": float = 0.999"},{name:"adam_epsilon",val:": float = 1e-08"},{name:"max_grad_norm",val:": float = 1.0"},{name:"num_train_epochs",val:": float = 3.0"},{name:"max_steps",val:": int = -1"},{name:"lr_scheduler_type",val:": Union = 'linear'"},{name:"lr_scheduler_kwargs",val:": Union = <factory>"},{name:"warmup_ratio",val:": float = 0.0"},{name:"warmup_steps",val:": int = 0"},{name:"log_level",val:": Optional = 'passive'"},{name:"log_level_replica",val:": Optional = 'warning'"},{name:"log_on_each_node",val:": bool = True"},{name:"logging_dir",val:": Optional = None"},{name:"logging_strategy",val:": Union = 'steps'"},{name:"logging_first_step",val:": bool = False"},{name:"logging_steps",val:": float = 500"},{name:"logging_nan_inf_filter",val:": bool = True"},{name:"save_strategy",val:": Union = 'steps'"},{name:"save_steps",val:": float = 500"},{name:"save_total_limit",val:": Optional = None"},{name:"save_safetensors",val:": Optional = True"},{name:"save_on_each_node",val:": bool = False"},{name:"save_only_model",val:": bool = False"},{name:"restore_callback_states_from_checkpoint",val:": bool = False"},{name:"no_cuda",val:": bool = False"},{name:"use_cpu",val:": bool = False"},{name:"use_mps_device",val:": bool = False"},{name:"seed",val:": int = 42"},{name:"data_seed",val:": Optional = None"},{name:"jit_mode_eval",val:": bool = False"},{name:"use_ipex",val:": bool = False"},{name:"bf16",val:": bool = False"},{name:"fp16",val:": bool = False"},{name:"fp16_opt_level",val:": str = 'O1'"},{name:"half_precision_backend",val:": str = 'auto'"},{name:"bf16_full_eval",val:": bool = False"},{name:"fp16_full_eval",val:": bool = False"},{name:"tf32",val:": Optional = None"},{name:"local_rank",val:": int = -1"},{name:"ddp_backend",val:": Optional = None"},{name:"tpu_num_cores",val:": Optional = None"},{name:"tpu_metrics_debug",val:": bool = False"},{name:"debug",val:": Union = ''"},{name:"dataloader_drop_last",val:": bool = False"},{name:"eval_steps",val:": Optional = None"},{name:"dataloader_num_workers",val:": int = 0"},{name:"dataloader_prefetch_factor",val:": Optional = None"},{name:"past_index",val:": int = -1"},{name:"run_name",val:": Optional = None"},{name:"disable_tqdm",val:": Optional = None"},{name:"remove_unused_columns",val:": Optional = True"},{name:"label_names",val:": Optional = None"},{name:"load_best_model_at_end",val:": Optional = False"},{name:"metric_for_best_model",val:": Optional = None"},{name:"greater_is_better",val:": Optional = None"},{name:"ignore_data_skip",val:": bool = False"},{name:"fsdp",val:": Union = ''"},{name:"fsdp_min_num_params",val:": int = 0"},{name:"fsdp_config",val:": Union = None"},{name:"fsdp_transformer_layer_cls_to_wrap",val:": Optional = None"},{name:"accelerator_config",val:": Union = None"},{name:"deepspeed",val:": Union = None"},{name:"label_smoothing_factor",val:": float = 0.0"},{name:"optim",val:": Union = 'adamw_torch'"},{name:"optim_args",val:": Optional = None"},{name:"adafactor",val:": bool = False"},{name:"group_by_length",val:": bool = False"},{name:"length_column_name",val:": Optional = 'length'"},{name:"report_to",val:": Union = None"},{name:"ddp_find_unused_parameters",val:": Optional = None"},{name:"ddp_bucket_cap_mb",val:": Optional = None"},{name:"ddp_broadcast_buffers",val:": Optional = None"},{name:"dataloader_pin_memory",val:": bool = True"},{name:"dataloader_persistent_workers",val:": bool = False"},{name:"skip_memory_metrics",val:": bool = True"},{name:"use_legacy_prediction_loop",val:": bool = False"},{name:"push_to_hub",val:": bool = False"},{name:"resume_from_checkpoint",val:": Optional = None"},{name:"hub_model_id",val:": Optional = None"},{name:"hub_strategy",val:": Union = 'every_save'"},{name:"hub_token",val:": Optional = None"},{name:"hub_private_repo",val:": bool = False"},{name:"hub_always_push",val:": bool = False"},{name:"gradient_checkpointing",val:": bool = False"},{name:"gradient_checkpointing_kwargs",val:": Union = None"},{name:"include_inputs_for_metrics",val:": bool = False"},{name:"eval_do_concat_batches",val:": bool = True"},{name:"fp16_backend",val:": str = 'auto'"},{name:"evaluation_strategy",val:": Union = None"},{name:"push_to_hub_model_id",val:": Optional = None"},{name:"push_to_hub_organization",val:": Optional = None"},{name:"push_to_hub_token",val:": Optional = None"},{name:"mp_parameters",val:": str = ''"},{name:"auto_find_batch_size",val:": bool = False"},{name:"full_determinism",val:": bool = False"},{name:"torchdynamo",val:": Optional = None"},{name:"ray_scope",val:": Optional = 'last'"},{name:"ddp_timeout",val:": Optional = 1800"},{name:"torch_compile",val:": bool = False"},{name:"torch_compile_backend",val:": Optional = None"},{name:"torch_compile_mode",val:": Optional = None"},{name:"dispatch_batches",val:": Optional = None"},{name:"split_batches",val:": Optional = None"},{name:"include_tokens_per_second",val:": Optional = False"},{name:"include_num_input_tokens_seen",val:": Optional = False"},{name:"neftune_noise_alpha",val:": Optional = None"},{name:"optim_target_modules",val:": Union = None"},{name:"batch_eval_metrics",val:": bool = False"},{name:"eval_on_start",val:": bool = False"},{name:"use_liger_kernel",val:": Optional = False"},{name:"eval_use_gather_object",val:": Optional = False"},{name:"max_length",val:": Optional = None"},{name:"dataset_num_proc",val:": Optional = None"},{name:"center_rewards_coefficient",val:": Optional = None"}],parametersDescription:[{anchor:"trl.RewardConfig.max_length",description:`<strong>max_length</strong> (<code>Optional[int]</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Maximum length of the sequences (prompt + completion) in the batch. This argument is required if you want
to use the default data collator.`,name:"max_length"},{anchor:"trl.RewardConfig.dataset_num_proc",description:`<strong>dataset_num_proc</strong> (<code>int</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Number of processes to use for processing the dataset.`,name:"dataset_num_proc"},{anchor:"trl.RewardConfig.center_rewards_coefficient",description:`<strong>center_rewards_coefficient</strong> (<code>float</code>, <em>optional</em>, defaults to <code>None</code>) &#x2014;
Coefficient to incentivize the reward model to output mean-zero rewards (proposed by
<a href="https://huggingface.co/papers/2312.09244" rel="nofollow">https://huggingface.co/papers/2312.09244</a>, Eq. 2). Recommended value: <code>0.01</code>.`,name:"center_rewards_coefficient"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/reward_config.py#L21"}}),Fo=new F({props:{title:"RewardTrainer",local:"trl.RewardTrainer",headingTag:"h2"}}),Lo=new f({props:{name:"class trl.RewardTrainer",anchor:"trl.RewardTrainer",parameters:[{name:"model",val:": Union = None"},{name:"args",val:": Optional = None"},{name:"data_collator",val:": Optional = None"},{name:"train_dataset",val:": Optional = None"},{name:"eval_dataset",val:": Union = None"},{name:"tokenizer",val:": Optional = None"},{name:"model_init",val:": Optional = None"},{name:"compute_metrics",val:": Optional = None"},{name:"callbacks",val:": Optional = None"},{name:"optimizers",val:": Tuple = (None, None)"},{name:"preprocess_logits_for_metrics",val:": Optional = None"},{name:"max_length",val:": Optional = None"},{name:"peft_config",val:": Optional = None"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/reward_trainer.py#L46"}}),zo=new f({props:{name:"visualize_samples",anchor:"trl.RewardTrainer.visualize_samples",parameters:[{name:"num_print_samples",val:": int"}],parametersDescription:[{anchor:"trl.RewardTrainer.visualize_samples.num_print_samples",description:`<strong>num_print_samples</strong> (<code>int</code>, defaults to <code>4</code>) &#x2014;
The number of samples to print. Set to <code>-1</code> to print all samples.`,name:"num_print_samples"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/reward_trainer.py#L301"}}),qo=new F({props:{title:"SFTTrainer",local:"trl.SFTTrainer",headingTag:"h2"}}),Mo=new f({props:{name:"class trl.SFTTrainer",anchor:"trl.SFTTrainer",parameters:[{name:"model",val:": Union = None"},{name:"args",val:": Optional = None"},{name:"data_collator",val:": Optional = None"},{name:"train_dataset",val:": Optional = None"},{name:"eval_dataset",val:": Union = None"},{name:"tokenizer",val:": Optional = None"},{name:"model_init",val:": Optional = None"},{name:"compute_metrics",val:": Optional = None"},{name:"callbacks",val:": Optional = None"},{name:"optimizers",val:": Tuple = (None, None)"},{name:"preprocess_logits_for_metrics",val:": Optional = None"},{name:"peft_config",val:": Optional = None"},{name:"dataset_text_field",val:": Optional = None"},{name:"packing",val:": Optional = False"},{name:"formatting_func",val:": Optional = None"},{name:"max_seq_length",val:": Optional = None"},{name:"infinite",val:": Optional = None"},{name:"num_of_sequences",val:": Optional = None"},{name:"chars_per_token",val:": Optional = None"},{name:"dataset_num_proc",val:": Optional = None"},{name:"dataset_batch_size",val:": Optional = None"},{name:"neftune_noise_alpha",val:": Optional = None"},{name:"model_init_kwargs",val:": Optional = None"},{name:"dataset_kwargs",val:": Optional = None"},{name:"eval_packing",val:": Optional = None"}],parametersDescription:[{anchor:"trl.SFTTrainer.model",description:`<strong>model</strong> (Union[<code>transformers.PreTrainedModel</code>, <code>nn.Module</code>, <code>str</code>]) &#x2014;
The model to train, can be a <code>PreTrainedModel</code>, a <code>torch.nn.Module</code> or a string with the model name to
load from cache or download. The model can be also converted to a <code>PeftModel</code> if a <code>PeftConfig</code> object is
passed to the <code>peft_config</code> argument.`,name:"model"},{anchor:"trl.SFTTrainer.args",description:`<strong>args</strong> (<code>Optional[SFTConfig]</code>) &#x2014;
The arguments to tweak for training. Will default to a basic instance of <a href="/docs/trl/main/en/sft_trainer#trl.SFTConfig">SFTConfig</a> with the <code>output_dir</code>
set to a directory named <em>tmp_trainer</em> in the current directory if not provided.`,name:"args"},{anchor:"trl.SFTTrainer.data_collator",description:`<strong>data_collator</strong> (<code>Optional[transformers.DataCollator]</code>) &#x2014;
The data collator to use for training.`,name:"data_collator"},{anchor:"trl.SFTTrainer.train_dataset",description:`<strong>train_dataset</strong> (<code>Optional[datasets.Dataset]</code>) &#x2014;
The dataset to use for training. We recommend users to use <code>trl.trainer.ConstantLengthDataset</code> to create their dataset.`,name:"train_dataset"},{anchor:"trl.SFTTrainer.eval_dataset",description:`<strong>eval_dataset</strong> (Optional[Union[<code>datasets.Dataset</code>, Dict[<code>str</code>, <code>datasets.Dataset</code>]]]) &#x2014;
The dataset to use for evaluation. We recommend users to use <code>trl.trainer.ConstantLengthDataset</code> to create their dataset.`,name:"eval_dataset"},{anchor:"trl.SFTTrainer.tokenizer",description:`<strong>tokenizer</strong> (<code>Optional[transformers.PreTrainedTokenizer]</code>) &#x2014;
The tokenizer to use for training. If not specified, the tokenizer associated to the model will be used.`,name:"tokenizer"},{anchor:"trl.SFTTrainer.model_init",description:`<strong>model_init</strong> (<code>Callable[[], transformers.PreTrainedModel]</code>) &#x2014;
The model initializer to use for training. If None is specified, the default model initializer will be used.`,name:"model_init"},{anchor:"trl.SFTTrainer.compute_metrics",description:`<strong>compute_metrics</strong> (<code>Callable[[transformers.EvalPrediction], Dict]</code>, <em>optional</em> defaults to None) &#x2014;
The function used to compute metrics during evaluation. It should return a dictionary mapping metric names to metric values.
If not specified, only the loss will be computed during evaluation.`,name:"compute_metrics"},{anchor:"trl.SFTTrainer.callbacks",description:`<strong>callbacks</strong> (<code>List[transformers.TrainerCallback]</code>) &#x2014;
The callbacks to use for training.`,name:"callbacks"},{anchor:"trl.SFTTrainer.optimizers",description:`<strong>optimizers</strong> (<code>Tuple[torch.optim.Optimizer, torch.optim.lr_scheduler.LambdaLR]</code>) &#x2014;
The optimizer and scheduler to use for training.`,name:"optimizers"},{anchor:"trl.SFTTrainer.preprocess_logits_for_metrics",description:`<strong>preprocess_logits_for_metrics</strong> (<code>Callable[[torch.Tensor, torch.Tensor], torch.Tensor]</code>) &#x2014;
The function to use to preprocess the logits before computing the metrics.`,name:"preprocess_logits_for_metrics"},{anchor:"trl.SFTTrainer.peft_config",description:`<strong>peft_config</strong> (<code>Optional[PeftConfig]</code>) &#x2014;
The PeftConfig object to use to initialize the PeftModel.`,name:"peft_config"},{anchor:"trl.SFTTrainer.formatting_func",description:`<strong>formatting_func</strong> (<code>Optional[Callable]</code>) &#x2014;
The formatting function to be used for creating the <code>ConstantLengthDataset</code>.`,name:"formatting_func"}],source:"https://github.com/huggingface/trl/blob/main/trl/trainer/sft_trainer.py#L61"}}),Io=new F({props:{title:"set_seed",local:"trl.set_seed",headingTag:"h2"}}),Ro=new f({props:{name:"trl.set_seed",anchor:"trl.set_seed",parameters:[{name:"seed",val:": int"}],parametersDescription:[{anchor:"trl.set_seed.seed",description:"<strong>seed</strong> (<code>int</code>) &#x2014; The seed to set.",name:"seed"}],source:"https://github.com/huggingface/trl/blob/main/trl/core.py#L223"}}),Eo=new Dm({props:{source:"https://github.com/huggingface/trl/blob/main/docs/source/trainer.mdx"}}),{c(){te=n("meta"),Yn=o(),Qn=n("p"),er=o(),s(Xe.$$.fragment),tr=o(),Ye=n("p"),Ye.innerHTML=Dd,or=o(),s(et.$$.fragment),ar=o(),R=n("div"),s(tt.$$.fragment),Nl=o(),Uo=n("p"),Uo.innerHTML=Nd,Fl=o(),Ho=n("p"),Ho.innerHTML=Fd,nr=o(),s(ot.$$.fragment),rr=o(),T=n("div"),s(at.$$.fragment),Ll=o(),Ao=n("p"),Ao.textContent=Ld,zl=o(),ne=n("div"),s(nt.$$.fragment),ql=o(),Ko=n("p"),Ko.innerHTML=zd,Ml=o(),j=n("div"),s(rt.$$.fragment),Il=o(),So=n("p"),So.textContent=qd,Rl=o(),jo=n("p"),jo.textContent=Md,El=o(),re=n("div"),s(lt.$$.fragment),Ul=o(),Vo=n("p"),Vo.textContent=Id,Hl=o(),le=n("div"),s(it.$$.fragment),Al=o(),Wo=n("p"),Wo.textContent=Rd,Kl=o(),V=n("div"),s(st.$$.fragment),Sl=o(),Bo=n("p"),Bo.innerHTML=Ed,jl=o(),Go=n("p"),Go.textContent=Ud,Vl=o(),ie=n("div"),s(dt.$$.fragment),Wl=o(),Jo=n("p"),Jo.textContent=Hd,Bl=o(),se=n("div"),s(ct.$$.fragment),Gl=o(),Zo=n("p"),Zo.textContent=Ad,Jl=o(),de=n("div"),s(mt.$$.fragment),Zl=o(),Qo=n("p"),Qo.textContent=Kd,Ql=o(),ce=n("div"),s(pt.$$.fragment),Xl=o(),Xo=n("p"),Xo.innerHTML=Sd,Yl=o(),L=n("div"),s(gt.$$.fragment),ei=o(),Yo=n("p"),Yo.textContent=jd,ti=o(),ea=n("p"),ea.textContent=Vd,oi=o(),ta=n("p"),ta.textContent=Wd,lr=o(),s(_t.$$.fragment),ir=o(),E=n("div"),s(ut.$$.fragment),ai=o(),oa=n("p"),oa.innerHTML=Bd,ni=o(),aa=n("p"),aa.innerHTML=Gd,sr=o(),s(ht.$$.fragment),dr=o(),D=n("div"),s(ft.$$.fragment),ri=o(),na=n("p"),na.innerHTML=Jd,li=o(),me=n("div"),s(vt.$$.fragment),ii=o(),ra=n("p"),ra.textContent=Zd,si=o(),pe=n("div"),s(bt.$$.fragment),di=o(),la=n("p"),la.textContent=Qd,ci=o(),z=n("div"),s(Ot.$$.fragment),mi=o(),ia=n("p"),ia.textContent=Xd,pi=o(),sa=n("p"),sa.textContent=Yd,gi=o(),da=n("ul"),da.innerHTML=ec,_i=o(),ge=n("div"),s(Tt.$$.fragment),ui=o(),ca=n("p"),ca.textContent=tc,cr=o(),s(xt.$$.fragment),mr=o(),b=n("div"),s($t.$$.fragment),hi=o(),ma=n("p"),ma.textContent=oc,fi=o(),_e=n("div"),s(Pt.$$.fragment),vi=o(),pa=n("p"),pa.textContent=ac,bi=o(),W=n("div"),s(wt.$$.fragment),Oi=o(),ga=n("p"),ga.textContent=nc,Ti=o(),_a=n("p"),_a.textContent=rc,xi=o(),ue=n("div"),s(Ct.$$.fragment),$i=o(),ua=n("p"),ua.textContent=lc,Pi=o(),he=n("div"),s(yt.$$.fragment),wi=o(),ha=n("p"),ha.textContent=ic,Ci=o(),B=n("div"),s(kt.$$.fragment),yi=o(),fa=n("p"),fa.innerHTML=sc,ki=o(),va=n("p"),va.textContent=dc,Di=o(),fe=n("div"),s(Dt.$$.fragment),Ni=o(),ba=n("p"),ba.textContent=cc,Fi=o(),ve=n("div"),s(Nt.$$.fragment),Li=o(),Oa=n("p"),Oa.textContent=mc,zi=o(),be=n("div"),s(Ft.$$.fragment),qi=o(),Ta=n("p"),Ta.textContent=pc,Mi=o(),G=n("div"),s(Lt.$$.fragment),Ii=o(),xa=n("p"),xa.innerHTML=gc,Ri=o(),$a=n("p"),$a.innerHTML=_c,Ei=o(),J=n("div"),s(zt.$$.fragment),Ui=o(),Pa=n("p"),Pa.innerHTML=uc,Hi=o(),wa=n("p"),wa.innerHTML=hc,Ai=o(),Oe=n("div"),s(qt.$$.fragment),Ki=o(),Ca=n("p"),Ca.innerHTML=fc,Si=o(),Te=n("div"),s(Mt.$$.fragment),ji=o(),ya=n("p"),ya.textContent=vc,pr=o(),s(It.$$.fragment),gr=o(),U=n("div"),s(Rt.$$.fragment),Vi=o(),ka=n("p"),ka.textContent=bc,Wi=o(),xe=n("div"),s(Et.$$.fragment),Bi=o(),Da=n("p"),Da.textContent=Oc,_r=o(),s(Ut.$$.fragment),ur=o(),H=n("div"),s(Ht.$$.fragment),Gi=o(),Na=n("p"),Na.innerHTML=Tc,Ji=o(),Fa=n("p"),Fa.innerHTML=xc,hr=o(),s(At.$$.fragment),fr=o(),x=n("div"),s(Kt.$$.fragment),Zi=o(),La=n("p"),La.textContent=$c,Qi=o(),$e=n("div"),s(St.$$.fragment),Xi=o(),za=n("p"),za.textContent=Pc,Yi=o(),Z=n("div"),s(jt.$$.fragment),es=o(),qa=n("p"),qa.innerHTML=wc,ts=o(),Ma=n("p"),Ma.textContent=Cc,os=o(),Pe=n("div"),s(Vt.$$.fragment),as=o(),Ia=n("p"),Ia.textContent=yc,ns=o(),we=n("div"),s(Wt.$$.fragment),rs=o(),Ra=n("p"),Ra.textContent=kc,ls=o(),Ce=n("div"),s(Bt.$$.fragment),is=o(),Ea=n("p"),Ea.textContent=Dc,ss=o(),Q=n("div"),s(Gt.$$.fragment),ds=o(),Ua=n("p"),Ua.innerHTML=Nc,cs=o(),Ha=n("p"),Ha.innerHTML=Fc,ms=o(),X=n("div"),s(Jt.$$.fragment),ps=o(),Aa=n("p"),Aa.innerHTML=Lc,gs=o(),Ka=n("p"),Ka.innerHTML=zc,_s=o(),ye=n("div"),s(Zt.$$.fragment),us=o(),Sa=n("p"),Sa.textContent=qc,hs=o(),ke=n("div"),s(Qt.$$.fragment),fs=o(),ja=n("p"),ja.innerHTML=Mc,vs=o(),De=n("div"),s(Xt.$$.fragment),bs=o(),Va=n("p"),Va.textContent=Ic,vr=o(),s(Yt.$$.fragment),br=o(),A=n("div"),s(eo.$$.fragment),Os=o(),Wa=n("p"),Wa.innerHTML=Rc,Ts=o(),Ba=n("p"),Ba.innerHTML=Ec,Or=o(),s(to.$$.fragment),Tr=o(),$=n("div"),s(oo.$$.fragment),xs=o(),Ga=n("p"),Ga.textContent=Uc,$s=o(),Ne=n("div"),s(ao.$$.fragment),Ps=o(),Ja=n("p"),Ja.innerHTML=Hc,ws=o(),Y=n("div"),s(no.$$.fragment),Cs=o(),Za=n("p"),Za.textContent=Ac,ys=o(),Qa=n("p"),Qa.textContent=Kc,ks=o(),Fe=n("div"),s(ro.$$.fragment),Ds=o(),Xa=n("p"),Xa.textContent=Sc,Ns=o(),ee=n("div"),s(lo.$$.fragment),Fs=o(),Ya=n("p"),Ya.innerHTML=jc,Ls=o(),en=n("p"),en.textContent=Vc,zs=o(),Le=n("div"),s(io.$$.fragment),qs=o(),tn=n("p"),tn.textContent=Wc,Ms=o(),ze=n("div"),s(so.$$.fragment),Is=o(),on=n("p"),on.textContent=Bc,Rs=o(),qe=n("div"),s(co.$$.fragment),Es=o(),an=n("p"),an.textContent=Gc,Us=o(),Me=n("div"),s(mo.$$.fragment),Hs=o(),nn=n("p"),nn.innerHTML=Jc,As=o(),Ie=n("div"),s(po.$$.fragment),Ks=o(),rn=n("p"),rn.textContent=Zc,Ss=o(),q=n("div"),s(go.$$.fragment),js=o(),ln=n("p"),ln.textContent=Qc,Vs=o(),sn=n("p"),sn.textContent=Xc,Ws=o(),dn=n("p"),dn.textContent=Yc,xr=o(),s(_o.$$.fragment),$r=o(),K=n("div"),s(uo.$$.fragment),Bs=o(),cn=n("p"),cn.innerHTML=em,Gs=o(),mn=n("p"),mn.innerHTML=tm,Pr=o(),s(ho.$$.fragment),wr=o(),O=n("div"),s(fo.$$.fragment),Js=o(),pn=n("p"),pn.innerHTML=om,Zs=o(),Re=n("div"),s(vo.$$.fragment),Qs=o(),gn=n("p"),gn.textContent=am,Xs=o(),Ee=n("div"),s(bo.$$.fragment),Ys=o(),_n=n("p"),_n.textContent=nm,ed=o(),Ue=n("div"),s(Oo.$$.fragment),td=o(),un=n("p"),un.textContent=rm,od=o(),He=n("div"),s(To.$$.fragment),ad=o(),hn=n("p"),hn.textContent=lm,nd=o(),Ae=n("div"),s(xo.$$.fragment),rd=o(),fn=n("p"),fn.innerHTML=im,ld=o(),Ke=n("div"),s($o.$$.fragment),id=o(),vn=n("p"),vn.textContent=sm,sd=o(),Se=n("div"),s(Po.$$.fragment),dd=o(),bn=n("p"),bn.textContent=dm,cd=o(),je=n("div"),s(wo.$$.fragment),md=o(),On=n("p"),On.textContent=cm,pd=o(),Ve=n("div"),s(Co.$$.fragment),gd=o(),Tn=n("p"),Tn.textContent=mm,_d=o(),We=n("div"),s(yo.$$.fragment),ud=o(),xn=n("p"),xn.textContent=pm,hd=o(),Be=n("div"),s(ko.$$.fragment),fd=o(),$n=n("p"),$n.textContent=gm,Cr=o(),s(Do.$$.fragment),yr=o(),S=n("div"),s(No.$$.fragment),vd=o(),Pn=n("p"),Pn.innerHTML=_m,bd=o(),wn=n("p"),wn.innerHTML=um,kr=o(),s(Fo.$$.fragment),Dr=o(),N=n("div"),s(Lo.$$.fragment),Od=o(),Cn=n("p"),Cn.innerHTML=hm,Td=o(),yn=n("p"),yn.innerHTML=fm,xd=o(),kn=n("ul"),kn.innerHTML=vm,$d=o(),Dn=n("p"),Dn.innerHTML=bm,Pd=o(),Ge=n("div"),s(zo.$$.fragment),wd=o(),Nn=n("p"),Nn.textContent=Om,Nr=o(),s(qo.$$.fragment),Fr=o(),oe=n("div"),s(Mo.$$.fragment),Cd=o(),Fn=n("p"),Fn.innerHTML=Tm,Lr=o(),s(Io.$$.fragment),zr=o(),ae=n("div"),s(Ro.$$.fragment),yd=o(),Ln=n("p"),Ln.innerHTML=xm,qr=o(),s(Eo.$$.fragment),Mr=o(),Xn=n("p"),this.h()},l(e){const _=km("svelte-u9bgzb",document.head);te=r(_,"META",{name:!0,content:!0}),_.forEach(l),Yn=a(e),Qn=r(e,"P",{}),u(Qn).forEach(l),er=a(e),d(Xe.$$.fragment,e),tr=a(e),Ye=r(e,"P",{"data-svelte-h":!0}),i(Ye)!=="svelte-1y6bgei"&&(Ye.innerHTML=Dd),or=a(e),d(et.$$.fragment,e),ar=a(e),R=r(e,"DIV",{class:!0});var zn=u(R);d(tt.$$.fragment,zn),Nl=a(zn),Uo=r(zn,"P",{"data-svelte-h":!0}),i(Uo)!=="svelte-1eicnve"&&(Uo.innerHTML=Nd),Fl=a(zn),Ho=r(zn,"P",{"data-svelte-h":!0}),i(Ho)!=="svelte-ekuf1t"&&(Ho.innerHTML=Fd),zn.forEach(l),nr=a(e),d(ot.$$.fragment,e),rr=a(e),T=r(e,"DIV",{class:!0});var C=u(T);d(at.$$.fragment,C),Ll=a(C),Ao=r(C,"P",{"data-svelte-h":!0}),i(Ao)!=="svelte-1qqtmoh"&&(Ao.textContent=Ld),zl=a(C),ne=r(C,"DIV",{class:!0});var Rr=u(ne);d(nt.$$.fragment,Rr),ql=a(Rr),Ko=r(Rr,"P",{"data-svelte-h":!0}),i(Ko)!=="svelte-mcz8nm"&&(Ko.innerHTML=zd),Rr.forEach(l),Ml=a(C),j=r(C,"DIV",{class:!0});var qn=u(j);d(rt.$$.fragment,qn),Il=a(qn),So=r(qn,"P",{"data-svelte-h":!0}),i(So)!=="svelte-16i1nac"&&(So.textContent=qd),Rl=a(qn),jo=r(qn,"P",{"data-svelte-h":!0}),i(jo)!=="svelte-tgti68"&&(jo.textContent=Md),qn.forEach(l),El=a(C),re=r(C,"DIV",{class:!0});var Er=u(re);d(lt.$$.fragment,Er),Ul=a(Er),Vo=r(Er,"P",{"data-svelte-h":!0}),i(Vo)!=="svelte-1cvsgkk"&&(Vo.textContent=Id),Er.forEach(l),Hl=a(C),le=r(C,"DIV",{class:!0});var Ur=u(le);d(it.$$.fragment,Ur),Al=a(Ur),Wo=r(Ur,"P",{"data-svelte-h":!0}),i(Wo)!=="svelte-1l2rxe2"&&(Wo.textContent=Rd),Ur.forEach(l),Kl=a(C),V=r(C,"DIV",{class:!0});var Mn=u(V);d(st.$$.fragment,Mn),Sl=a(Mn),Bo=r(Mn,"P",{"data-svelte-h":!0}),i(Bo)!=="svelte-8qlty5"&&(Bo.innerHTML=Ed),jl=a(Mn),Go=r(Mn,"P",{"data-svelte-h":!0}),i(Go)!=="svelte-1tyo99t"&&(Go.textContent=Ud),Mn.forEach(l),Vl=a(C),ie=r(C,"DIV",{class:!0});var Hr=u(ie);d(dt.$$.fragment,Hr),Wl=a(Hr),Jo=r(Hr,"P",{"data-svelte-h":!0}),i(Jo)!=="svelte-4nmimv"&&(Jo.textContent=Hd),Hr.forEach(l),Bl=a(C),se=r(C,"DIV",{class:!0});var Ar=u(se);d(ct.$$.fragment,Ar),Gl=a(Ar),Zo=r(Ar,"P",{"data-svelte-h":!0}),i(Zo)!=="svelte-4kzfyw"&&(Zo.textContent=Ad),Ar.forEach(l),Jl=a(C),de=r(C,"DIV",{class:!0});var Kr=u(de);d(mt.$$.fragment,Kr),Zl=a(Kr),Qo=r(Kr,"P",{"data-svelte-h":!0}),i(Qo)!=="svelte-18uwvbi"&&(Qo.textContent=Kd),Kr.forEach(l),Ql=a(C),ce=r(C,"DIV",{class:!0});var Sr=u(ce);d(pt.$$.fragment,Sr),Xl=a(Sr),Xo=r(Sr,"P",{"data-svelte-h":!0}),i(Xo)!=="svelte-nqksfz"&&(Xo.innerHTML=Sd),Sr.forEach(l),Yl=a(C),L=r(C,"DIV",{class:!0});var Je=u(L);d(gt.$$.fragment,Je),ei=a(Je),Yo=r(Je,"P",{"data-svelte-h":!0}),i(Yo)!=="svelte-1a53vwp"&&(Yo.textContent=jd),ti=a(Je),ea=r(Je,"P",{"data-svelte-h":!0}),i(ea)!=="svelte-1mn1gnw"&&(ea.textContent=Vd),oi=a(Je),ta=r(Je,"P",{"data-svelte-h":!0}),i(ta)!=="svelte-1xvpyih"&&(ta.textContent=Wd),Je.forEach(l),C.forEach(l),lr=a(e),d(_t.$$.fragment,e),ir=a(e),E=r(e,"DIV",{class:!0});var In=u(E);d(ut.$$.fragment,In),ai=a(In),oa=r(In,"P",{"data-svelte-h":!0}),i(oa)!=="svelte-1j2gsmx"&&(oa.innerHTML=Bd),ni=a(In),aa=r(In,"P",{"data-svelte-h":!0}),i(aa)!=="svelte-ekuf1t"&&(aa.innerHTML=Gd),In.forEach(l),sr=a(e),d(ht.$$.fragment,e),dr=a(e),D=r(e,"DIV",{class:!0});var M=u(D);d(ft.$$.fragment,M),ri=a(M),na=r(M,"P",{"data-svelte-h":!0}),i(na)!=="svelte-8q861t"&&(na.innerHTML=Jd),li=a(M),me=r(M,"DIV",{class:!0});var jr=u(me);d(vt.$$.fragment,jr),ii=a(jr),ra=r(jr,"P",{"data-svelte-h":!0}),i(ra)!=="svelte-1ag17u3"&&(ra.textContent=Zd),jr.forEach(l),si=a(M),pe=r(M,"DIV",{class:!0});var Vr=u(pe);d(bt.$$.fragment,Vr),di=a(Vr),la=r(Vr,"P",{"data-svelte-h":!0}),i(la)!=="svelte-3jfrz9"&&(la.textContent=Qd),Vr.forEach(l),ci=a(M),z=r(M,"DIV",{class:!0});var Ze=u(z);d(Ot.$$.fragment,Ze),mi=a(Ze),ia=r(Ze,"P",{"data-svelte-h":!0}),i(ia)!=="svelte-r6y15n"&&(ia.textContent=Xd),pi=a(Ze),sa=r(Ze,"P",{"data-svelte-h":!0}),i(sa)!=="svelte-imqqfp"&&(sa.textContent=Yd),gi=a(Ze),da=r(Ze,"UL",{"data-svelte-h":!0}),i(da)!=="svelte-105j238"&&(da.innerHTML=ec),Ze.forEach(l),_i=a(M),ge=r(M,"DIV",{class:!0});var Wr=u(ge);d(Tt.$$.fragment,Wr),ui=a(Wr),ca=r(Wr,"P",{"data-svelte-h":!0}),i(ca)!=="svelte-1an944l"&&(ca.textContent=tc),Wr.forEach(l),M.forEach(l),cr=a(e),d(xt.$$.fragment,e),mr=a(e),b=r(e,"DIV",{class:!0});var P=u(b);d($t.$$.fragment,P),hi=a(P),ma=r(P,"P",{"data-svelte-h":!0}),i(ma)!=="svelte-n6cc8y"&&(ma.textContent=oc),fi=a(P),_e=r(P,"DIV",{class:!0});var Br=u(_e);d(Pt.$$.fragment,Br),vi=a(Br),pa=r(Br,"P",{"data-svelte-h":!0}),i(pa)!=="svelte-10t1062"&&(pa.textContent=ac),Br.forEach(l),bi=a(P),W=r(P,"DIV",{class:!0});var Rn=u(W);d(wt.$$.fragment,Rn),Oi=a(Rn),ga=r(Rn,"P",{"data-svelte-h":!0}),i(ga)!=="svelte-16i1nac"&&(ga.textContent=nc),Ti=a(Rn),_a=r(Rn,"P",{"data-svelte-h":!0}),i(_a)!=="svelte-tgti68"&&(_a.textContent=rc),Rn.forEach(l),xi=a(P),ue=r(P,"DIV",{class:!0});var Gr=u(ue);d(Ct.$$.fragment,Gr),$i=a(Gr),ua=r(Gr,"P",{"data-svelte-h":!0}),i(ua)!=="svelte-1cvsgkk"&&(ua.textContent=lc),Gr.forEach(l),Pi=a(P),he=r(P,"DIV",{class:!0});var Jr=u(he);d(yt.$$.fragment,Jr),wi=a(Jr),ha=r(Jr,"P",{"data-svelte-h":!0}),i(ha)!=="svelte-ymgxq7"&&(ha.textContent=ic),Jr.forEach(l),Ci=a(P),B=r(P,"DIV",{class:!0});var En=u(B);d(kt.$$.fragment,En),yi=a(En),fa=r(En,"P",{"data-svelte-h":!0}),i(fa)!=="svelte-8qlty5"&&(fa.innerHTML=sc),ki=a(En),va=r(En,"P",{"data-svelte-h":!0}),i(va)!=="svelte-1tyo99t"&&(va.textContent=dc),En.forEach(l),Di=a(P),fe=r(P,"DIV",{class:!0});var Zr=u(fe);d(Dt.$$.fragment,Zr),Ni=a(Zr),ba=r(Zr,"P",{"data-svelte-h":!0}),i(ba)!=="svelte-4nmimv"&&(ba.textContent=cc),Zr.forEach(l),Fi=a(P),ve=r(P,"DIV",{class:!0});var Qr=u(ve);d(Nt.$$.fragment,Qr),Li=a(Qr),Oa=r(Qr,"P",{"data-svelte-h":!0}),i(Oa)!=="svelte-11q8u7l"&&(Oa.textContent=mc),Qr.forEach(l),zi=a(P),be=r(P,"DIV",{class:!0});var Xr=u(be);d(Ft.$$.fragment,Xr),qi=a(Xr),Ta=r(Xr,"P",{"data-svelte-h":!0}),i(Ta)!=="svelte-18uwvbi"&&(Ta.textContent=pc),Xr.forEach(l),Mi=a(P),G=r(P,"DIV",{class:!0});var Un=u(G);d(Lt.$$.fragment,Un),Ii=a(Un),xa=r(Un,"P",{"data-svelte-h":!0}),i(xa)!=="svelte-xesobz"&&(xa.innerHTML=gc),Ri=a(Un),$a=r(Un,"P",{"data-svelte-h":!0}),i($a)!=="svelte-qg43tm"&&($a.innerHTML=_c),Un.forEach(l),Ei=a(P),J=r(P,"DIV",{class:!0});var Hn=u(J);d(zt.$$.fragment,Hn),Ui=a(Hn),Pa=r(Hn,"P",{"data-svelte-h":!0}),i(Pa)!=="svelte-dkae9b"&&(Pa.innerHTML=uc),Hi=a(Hn),wa=r(Hn,"P",{"data-svelte-h":!0}),i(wa)!=="svelte-hmd5cw"&&(wa.innerHTML=hc),Hn.forEach(l),Ai=a(P),Oe=r(P,"DIV",{class:!0});var Yr=u(Oe);d(qt.$$.fragment,Yr),Ki=a(Yr),Ca=r(Yr,"P",{"data-svelte-h":!0}),i(Ca)!=="svelte-nqksfz"&&(Ca.innerHTML=fc),Yr.forEach(l),Si=a(P),Te=r(P,"DIV",{class:!0});var el=u(Te);d(Mt.$$.fragment,el),ji=a(el),ya=r(el,"P",{"data-svelte-h":!0}),i(ya)!=="svelte-17kjsy4"&&(ya.textContent=vc),el.forEach(l),P.forEach(l),pr=a(e),d(It.$$.fragment,e),gr=a(e),U=r(e,"DIV",{class:!0});var An=u(U);d(Rt.$$.fragment,An),Vi=a(An),ka=r(An,"P",{"data-svelte-h":!0}),i(ka)!=="svelte-xqyw6w"&&(ka.textContent=bc),Wi=a(An),xe=r(An,"DIV",{class:!0});var tl=u(xe);d(Et.$$.fragment,tl),Bi=a(tl),Da=r(tl,"P",{"data-svelte-h":!0}),i(Da)!=="svelte-v7dhdf"&&(Da.textContent=Oc),tl.forEach(l),An.forEach(l),_r=a(e),d(Ut.$$.fragment,e),ur=a(e),H=r(e,"DIV",{class:!0});var Kn=u(H);d(Ht.$$.fragment,Kn),Gi=a(Kn),Na=r(Kn,"P",{"data-svelte-h":!0}),i(Na)!=="svelte-okkyan"&&(Na.innerHTML=Tc),Ji=a(Kn),Fa=r(Kn,"P",{"data-svelte-h":!0}),i(Fa)!=="svelte-ekuf1t"&&(Fa.innerHTML=xc),Kn.forEach(l),hr=a(e),d(At.$$.fragment,e),fr=a(e),x=r(e,"DIV",{class:!0});var y=u(x);d(Kt.$$.fragment,y),Zi=a(y),La=r(y,"P",{"data-svelte-h":!0}),i(La)!=="svelte-hyhzxp"&&(La.textContent=$c),Qi=a(y),$e=r(y,"DIV",{class:!0});var ol=u($e);d(St.$$.fragment,ol),Xi=a(ol),za=r(ol,"P",{"data-svelte-h":!0}),i(za)!=="svelte-pt6g01"&&(za.textContent=Pc),ol.forEach(l),Yi=a(y),Z=r(y,"DIV",{class:!0});var Sn=u(Z);d(jt.$$.fragment,Sn),es=a(Sn),qa=r(Sn,"P",{"data-svelte-h":!0}),i(qa)!=="svelte-8qlty5"&&(qa.innerHTML=wc),ts=a(Sn),Ma=r(Sn,"P",{"data-svelte-h":!0}),i(Ma)!=="svelte-1tyo99t"&&(Ma.textContent=Cc),Sn.forEach(l),os=a(y),Pe=r(y,"DIV",{class:!0});var al=u(Pe);d(Vt.$$.fragment,al),as=a(al),Ia=r(al,"P",{"data-svelte-h":!0}),i(Ia)!=="svelte-4nmimv"&&(Ia.textContent=yc),al.forEach(l),ns=a(y),we=r(y,"DIV",{class:!0});var nl=u(we);d(Wt.$$.fragment,nl),rs=a(nl),Ra=r(nl,"P",{"data-svelte-h":!0}),i(Ra)!=="svelte-db7iek"&&(Ra.textContent=kc),nl.forEach(l),ls=a(y),Ce=r(y,"DIV",{class:!0});var rl=u(Ce);d(Bt.$$.fragment,rl),is=a(rl),Ea=r(rl,"P",{"data-svelte-h":!0}),i(Ea)!=="svelte-18uwvbi"&&(Ea.textContent=Dc),rl.forEach(l),ss=a(y),Q=r(y,"DIV",{class:!0});var jn=u(Q);d(Gt.$$.fragment,jn),ds=a(jn),Ua=r(jn,"P",{"data-svelte-h":!0}),i(Ua)!=="svelte-xesobz"&&(Ua.innerHTML=Nc),cs=a(jn),Ha=r(jn,"P",{"data-svelte-h":!0}),i(Ha)!=="svelte-qg43tm"&&(Ha.innerHTML=Fc),jn.forEach(l),ms=a(y),X=r(y,"DIV",{class:!0});var Vn=u(X);d(Jt.$$.fragment,Vn),ps=a(Vn),Aa=r(Vn,"P",{"data-svelte-h":!0}),i(Aa)!=="svelte-dkae9b"&&(Aa.innerHTML=Lc),gs=a(Vn),Ka=r(Vn,"P",{"data-svelte-h":!0}),i(Ka)!=="svelte-hmd5cw"&&(Ka.innerHTML=zc),Vn.forEach(l),_s=a(y),ye=r(y,"DIV",{class:!0});var ll=u(ye);d(Zt.$$.fragment,ll),us=a(ll),Sa=r(ll,"P",{"data-svelte-h":!0}),i(Sa)!=="svelte-svckwe"&&(Sa.textContent=qc),ll.forEach(l),hs=a(y),ke=r(y,"DIV",{class:!0});var il=u(ke);d(Qt.$$.fragment,il),fs=a(il),ja=r(il,"P",{"data-svelte-h":!0}),i(ja)!=="svelte-nqksfz"&&(ja.innerHTML=Mc),il.forEach(l),vs=a(y),De=r(y,"DIV",{class:!0});var sl=u(De);d(Xt.$$.fragment,sl),bs=a(sl),Va=r(sl,"P",{"data-svelte-h":!0}),i(Va)!=="svelte-17kjsy4"&&(Va.textContent=Ic),sl.forEach(l),y.forEach(l),vr=a(e),d(Yt.$$.fragment,e),br=a(e),A=r(e,"DIV",{class:!0});var Wn=u(A);d(eo.$$.fragment,Wn),Os=a(Wn),Wa=r(Wn,"P",{"data-svelte-h":!0}),i(Wa)!=="svelte-nvpljd"&&(Wa.innerHTML=Rc),Ts=a(Wn),Ba=r(Wn,"P",{"data-svelte-h":!0}),i(Ba)!=="svelte-ekuf1t"&&(Ba.innerHTML=Ec),Wn.forEach(l),Or=a(e),d(to.$$.fragment,e),Tr=a(e),$=r(e,"DIV",{class:!0});var k=u($);d(oo.$$.fragment,k),xs=a(k),Ga=r(k,"P",{"data-svelte-h":!0}),i(Ga)!=="svelte-1ggwo37"&&(Ga.textContent=Uc),$s=a(k),Ne=r(k,"DIV",{class:!0});var dl=u(Ne);d(ao.$$.fragment,dl),Ps=a(dl),Ja=r(dl,"P",{"data-svelte-h":!0}),i(Ja)!=="svelte-mcz8nm"&&(Ja.innerHTML=Hc),dl.forEach(l),ws=a(k),Y=r(k,"DIV",{class:!0});var Bn=u(Y);d(no.$$.fragment,Bn),Cs=a(Bn),Za=r(Bn,"P",{"data-svelte-h":!0}),i(Za)!=="svelte-16i1nac"&&(Za.textContent=Ac),ys=a(Bn),Qa=r(Bn,"P",{"data-svelte-h":!0}),i(Qa)!=="svelte-tgti68"&&(Qa.textContent=Kc),Bn.forEach(l),ks=a(k),Fe=r(k,"DIV",{class:!0});var cl=u(Fe);d(ro.$$.fragment,cl),Ds=a(cl),Xa=r(cl,"P",{"data-svelte-h":!0}),i(Xa)!=="svelte-1cvsgkk"&&(Xa.textContent=Sc),cl.forEach(l),Ns=a(k),ee=r(k,"DIV",{class:!0});var Gn=u(ee);d(lo.$$.fragment,Gn),Fs=a(Gn),Ya=r(Gn,"P",{"data-svelte-h":!0}),i(Ya)!=="svelte-8qlty5"&&(Ya.innerHTML=jc),Ls=a(Gn),en=r(Gn,"P",{"data-svelte-h":!0}),i(en)!=="svelte-1tyo99t"&&(en.textContent=Vc),Gn.forEach(l),zs=a(k),Le=r(k,"DIV",{class:!0});var ml=u(Le);d(io.$$.fragment,ml),qs=a(ml),tn=r(ml,"P",{"data-svelte-h":!0}),i(tn)!=="svelte-4nmimv"&&(tn.textContent=Wc),ml.forEach(l),Ms=a(k),ze=r(k,"DIV",{class:!0});var pl=u(ze);d(so.$$.fragment,pl),Is=a(pl),on=r(pl,"P",{"data-svelte-h":!0}),i(on)!=="svelte-ndgk7s"&&(on.textContent=Bc),pl.forEach(l),Rs=a(k),qe=r(k,"DIV",{class:!0});var gl=u(qe);d(co.$$.fragment,gl),Es=a(gl),an=r(gl,"P",{"data-svelte-h":!0}),i(an)!=="svelte-18uwvbi"&&(an.textContent=Gc),gl.forEach(l),Us=a(k),Me=r(k,"DIV",{class:!0});var _l=u(Me);d(mo.$$.fragment,_l),Hs=a(_l),nn=r(_l,"P",{"data-svelte-h":!0}),i(nn)!=="svelte-nqksfz"&&(nn.innerHTML=Jc),_l.forEach(l),As=a(k),Ie=r(k,"DIV",{class:!0});var ul=u(Ie);d(po.$$.fragment,ul),Ks=a(ul),rn=r(ul,"P",{"data-svelte-h":!0}),i(rn)!=="svelte-y2dr0o"&&(rn.textContent=Zc),ul.forEach(l),Ss=a(k),q=r(k,"DIV",{class:!0});var Qe=u(q);d(go.$$.fragment,Qe),js=a(Qe),ln=r(Qe,"P",{"data-svelte-h":!0}),i(ln)!=="svelte-xlsvih"&&(ln.textContent=Qc),Vs=a(Qe),sn=r(Qe,"P",{"data-svelte-h":!0}),i(sn)!=="svelte-1mn1gnw"&&(sn.textContent=Xc),Ws=a(Qe),dn=r(Qe,"P",{"data-svelte-h":!0}),i(dn)!=="svelte-1xvpyih"&&(dn.textContent=Yc),Qe.forEach(l),k.forEach(l),xr=a(e),d(_o.$$.fragment,e),$r=a(e),K=r(e,"DIV",{class:!0});var Jn=u(K);d(uo.$$.fragment,Jn),Bs=a(Jn),cn=r(Jn,"P",{"data-svelte-h":!0}),i(cn)!=="svelte-1s1x0if"&&(cn.innerHTML=em),Gs=a(Jn),mn=r(Jn,"P",{"data-svelte-h":!0}),i(mn)!=="svelte-ekuf1t"&&(mn.innerHTML=tm),Jn.forEach(l),Pr=a(e),d(ho.$$.fragment,e),wr=a(e),O=r(e,"DIV",{class:!0});var w=u(O);d(fo.$$.fragment,w),Js=a(w),pn=r(w,"P",{"data-svelte-h":!0}),i(pn)!=="svelte-hys9rl"&&(pn.innerHTML=om),Zs=a(w),Re=r(w,"DIV",{class:!0});var hl=u(Re);d(vo.$$.fragment,hl),Qs=a(hl),gn=r(hl,"P",{"data-svelte-h":!0}),i(gn)!=="svelte-185nst0"&&(gn.textContent=am),hl.forEach(l),Xs=a(w),Ee=r(w,"DIV",{class:!0});var fl=u(Ee);d(bo.$$.fragment,fl),Ys=a(fl),_n=r(fl,"P",{"data-svelte-h":!0}),i(_n)!=="svelte-3nt516"&&(_n.textContent=nm),fl.forEach(l),ed=a(w),Ue=r(w,"DIV",{class:!0});var vl=u(Ue);d(Oo.$$.fragment,vl),td=a(vl),un=r(vl,"P",{"data-svelte-h":!0}),i(un)!=="svelte-3jfrz9"&&(un.textContent=rm),vl.forEach(l),od=a(w),He=r(w,"DIV",{class:!0});var bl=u(He);d(To.$$.fragment,bl),ad=a(bl),hn=r(bl,"P",{"data-svelte-h":!0}),i(hn)!=="svelte-lcc1u3"&&(hn.textContent=lm),bl.forEach(l),nd=a(w),Ae=r(w,"DIV",{class:!0});var Ol=u(Ae);d(xo.$$.fragment,Ol),rd=a(Ol),fn=r(Ol,"P",{"data-svelte-h":!0}),i(fn)!=="svelte-1gqqzmu"&&(fn.innerHTML=im),Ol.forEach(l),ld=a(w),Ke=r(w,"DIV",{class:!0});var Tl=u(Ke);d($o.$$.fragment,Tl),id=a(Tl),vn=r(Tl,"P",{"data-svelte-h":!0}),i(vn)!=="svelte-ffqz5"&&(vn.textContent=sm),Tl.forEach(l),sd=a(w),Se=r(w,"DIV",{class:!0});var xl=u(Se);d(Po.$$.fragment,xl),dd=a(xl),bn=r(xl,"P",{"data-svelte-h":!0}),i(bn)!=="svelte-febvhf"&&(bn.textContent=dm),xl.forEach(l),cd=a(w),je=r(w,"DIV",{class:!0});var $l=u(je);d(wo.$$.fragment,$l),md=a($l),On=r($l,"P",{"data-svelte-h":!0}),i(On)!=="svelte-1hbodkw"&&(On.textContent=cm),$l.forEach(l),pd=a(w),Ve=r(w,"DIV",{class:!0});var Pl=u(Ve);d(Co.$$.fragment,Pl),gd=a(Pl),Tn=r(Pl,"P",{"data-svelte-h":!0}),i(Tn)!=="svelte-1hfgx92"&&(Tn.textContent=mm),Pl.forEach(l),_d=a(w),We=r(w,"DIV",{class:!0});var wl=u(We);d(yo.$$.fragment,wl),ud=a(wl),xn=r(wl,"P",{"data-svelte-h":!0}),i(xn)!=="svelte-yrsdu6"&&(xn.textContent=pm),wl.forEach(l),hd=a(w),Be=r(w,"DIV",{class:!0});var Cl=u(Be);d(ko.$$.fragment,Cl),fd=a(Cl),$n=r(Cl,"P",{"data-svelte-h":!0}),i($n)!=="svelte-3k7k5e"&&($n.textContent=gm),Cl.forEach(l),w.forEach(l),Cr=a(e),d(Do.$$.fragment,e),yr=a(e),S=r(e,"DIV",{class:!0});var Zn=u(S);d(No.$$.fragment,Zn),vd=a(Zn),Pn=r(Zn,"P",{"data-svelte-h":!0}),i(Pn)!=="svelte-10v0iz9"&&(Pn.innerHTML=_m),bd=a(Zn),wn=r(Zn,"P",{"data-svelte-h":!0}),i(wn)!=="svelte-ekuf1t"&&(wn.innerHTML=um),Zn.forEach(l),kr=a(e),d(Fo.$$.fragment,e),Dr=a(e),N=r(e,"DIV",{class:!0});var I=u(N);d(Lo.$$.fragment,I),Od=a(I),Cn=r(I,"P",{"data-svelte-h":!0}),i(Cn)!=="svelte-qafafj"&&(Cn.innerHTML=hm),Td=a(I),yn=r(I,"P",{"data-svelte-h":!0}),i(yn)!=="svelte-bkmbwh"&&(yn.innerHTML=fm),xd=a(I),kn=r(I,"UL",{"data-svelte-h":!0}),i(kn)!=="svelte-1ytuxgw"&&(kn.innerHTML=vm),$d=a(I),Dn=r(I,"P",{"data-svelte-h":!0}),i(Dn)!=="svelte-18tbp4c"&&(Dn.innerHTML=bm),Pd=a(I),Ge=r(I,"DIV",{class:!0});var yl=u(Ge);d(zo.$$.fragment,yl),wd=a(yl),Nn=r(yl,"P",{"data-svelte-h":!0}),i(Nn)!=="svelte-1g38ldc"&&(Nn.textContent=Om),yl.forEach(l),I.forEach(l),Nr=a(e),d(qo.$$.fragment,e),Fr=a(e),oe=r(e,"DIV",{class:!0});var kl=u(oe);d(Mo.$$.fragment,kl),Cd=a(kl),Fn=r(kl,"P",{"data-svelte-h":!0}),i(Fn)!=="svelte-14oyph8"&&(Fn.innerHTML=Tm),kl.forEach(l),Lr=a(e),d(Io.$$.fragment,e),zr=a(e),ae=r(e,"DIV",{class:!0});var Dl=u(ae);d(Ro.$$.fragment,Dl),yd=a(Dl),Ln=r(Dl,"P",{"data-svelte-h":!0}),i(Ln)!=="svelte-1aeuhep"&&(Ln.innerHTML=xm),Dl.forEach(l),qr=a(e),d(Eo.$$.fragment,e),Mr=a(e),Xn=r(e,"P",{}),u(Xn).forEach(l),this.h()},h(){h(te,"name","hf:doc:metadata"),h(te,"content",Fm),h(R,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(j,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(de,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(L,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(T,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(E,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(D,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(_e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(he,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(G,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(J,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Te,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(xe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h($e,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Pe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(we,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ce,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(X,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ye,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(De,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ne,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Fe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Le,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ze,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(qe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Me,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ie,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(K,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Re,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ee,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ue,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(He,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ke,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Se,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(je,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ve,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(We,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Be,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(O,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(S,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(Ge,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(oe,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),h(ae,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,_){t(document.head,te),v(e,Yn,_),v(e,Qn,_),v(e,er,_),c(Xe,e,_),v(e,tr,_),v(e,Ye,_),v(e,or,_),c(et,e,_),v(e,ar,_),v(e,R,_),c(tt,R,null),t(R,Nl),t(R,Uo),t(R,Fl),t(R,Ho),v(e,nr,_),c(ot,e,_),v(e,rr,_),v(e,T,_),c(at,T,null),t(T,Ll),t(T,Ao),t(T,zl),t(T,ne),c(nt,ne,null),t(ne,ql),t(ne,Ko),t(T,Ml),t(T,j),c(rt,j,null),t(j,Il),t(j,So),t(j,Rl),t(j,jo),t(T,El),t(T,re),c(lt,re,null),t(re,Ul),t(re,Vo),t(T,Hl),t(T,le),c(it,le,null),t(le,Al),t(le,Wo),t(T,Kl),t(T,V),c(st,V,null),t(V,Sl),t(V,Bo),t(V,jl),t(V,Go),t(T,Vl),t(T,ie),c(dt,ie,null),t(ie,Wl),t(ie,Jo),t(T,Bl),t(T,se),c(ct,se,null),t(se,Gl),t(se,Zo),t(T,Jl),t(T,de),c(mt,de,null),t(de,Zl),t(de,Qo),t(T,Ql),t(T,ce),c(pt,ce,null),t(ce,Xl),t(ce,Xo),t(T,Yl),t(T,L),c(gt,L,null),t(L,ei),t(L,Yo),t(L,ti),t(L,ea),t(L,oi),t(L,ta),v(e,lr,_),c(_t,e,_),v(e,ir,_),v(e,E,_),c(ut,E,null),t(E,ai),t(E,oa),t(E,ni),t(E,aa),v(e,sr,_),c(ht,e,_),v(e,dr,_),v(e,D,_),c(ft,D,null),t(D,ri),t(D,na),t(D,li),t(D,me),c(vt,me,null),t(me,ii),t(me,ra),t(D,si),t(D,pe),c(bt,pe,null),t(pe,di),t(pe,la),t(D,ci),t(D,z),c(Ot,z,null),t(z,mi),t(z,ia),t(z,pi),t(z,sa),t(z,gi),t(z,da),t(D,_i),t(D,ge),c(Tt,ge,null),t(ge,ui),t(ge,ca),v(e,cr,_),c(xt,e,_),v(e,mr,_),v(e,b,_),c($t,b,null),t(b,hi),t(b,ma),t(b,fi),t(b,_e),c(Pt,_e,null),t(_e,vi),t(_e,pa),t(b,bi),t(b,W),c(wt,W,null),t(W,Oi),t(W,ga),t(W,Ti),t(W,_a),t(b,xi),t(b,ue),c(Ct,ue,null),t(ue,$i),t(ue,ua),t(b,Pi),t(b,he),c(yt,he,null),t(he,wi),t(he,ha),t(b,Ci),t(b,B),c(kt,B,null),t(B,yi),t(B,fa),t(B,ki),t(B,va),t(b,Di),t(b,fe),c(Dt,fe,null),t(fe,Ni),t(fe,ba),t(b,Fi),t(b,ve),c(Nt,ve,null),t(ve,Li),t(ve,Oa),t(b,zi),t(b,be),c(Ft,be,null),t(be,qi),t(be,Ta),t(b,Mi),t(b,G),c(Lt,G,null),t(G,Ii),t(G,xa),t(G,Ri),t(G,$a),t(b,Ei),t(b,J),c(zt,J,null),t(J,Ui),t(J,Pa),t(J,Hi),t(J,wa),t(b,Ai),t(b,Oe),c(qt,Oe,null),t(Oe,Ki),t(Oe,Ca),t(b,Si),t(b,Te),c(Mt,Te,null),t(Te,ji),t(Te,ya),v(e,pr,_),c(It,e,_),v(e,gr,_),v(e,U,_),c(Rt,U,null),t(U,Vi),t(U,ka),t(U,Wi),t(U,xe),c(Et,xe,null),t(xe,Bi),t(xe,Da),v(e,_r,_),c(Ut,e,_),v(e,ur,_),v(e,H,_),c(Ht,H,null),t(H,Gi),t(H,Na),t(H,Ji),t(H,Fa),v(e,hr,_),c(At,e,_),v(e,fr,_),v(e,x,_),c(Kt,x,null),t(x,Zi),t(x,La),t(x,Qi),t(x,$e),c(St,$e,null),t($e,Xi),t($e,za),t(x,Yi),t(x,Z),c(jt,Z,null),t(Z,es),t(Z,qa),t(Z,ts),t(Z,Ma),t(x,os),t(x,Pe),c(Vt,Pe,null),t(Pe,as),t(Pe,Ia),t(x,ns),t(x,we),c(Wt,we,null),t(we,rs),t(we,Ra),t(x,ls),t(x,Ce),c(Bt,Ce,null),t(Ce,is),t(Ce,Ea),t(x,ss),t(x,Q),c(Gt,Q,null),t(Q,ds),t(Q,Ua),t(Q,cs),t(Q,Ha),t(x,ms),t(x,X),c(Jt,X,null),t(X,ps),t(X,Aa),t(X,gs),t(X,Ka),t(x,_s),t(x,ye),c(Zt,ye,null),t(ye,us),t(ye,Sa),t(x,hs),t(x,ke),c(Qt,ke,null),t(ke,fs),t(ke,ja),t(x,vs),t(x,De),c(Xt,De,null),t(De,bs),t(De,Va),v(e,vr,_),c(Yt,e,_),v(e,br,_),v(e,A,_),c(eo,A,null),t(A,Os),t(A,Wa),t(A,Ts),t(A,Ba),v(e,Or,_),c(to,e,_),v(e,Tr,_),v(e,$,_),c(oo,$,null),t($,xs),t($,Ga),t($,$s),t($,Ne),c(ao,Ne,null),t(Ne,Ps),t(Ne,Ja),t($,ws),t($,Y),c(no,Y,null),t(Y,Cs),t(Y,Za),t(Y,ys),t(Y,Qa),t($,ks),t($,Fe),c(ro,Fe,null),t(Fe,Ds),t(Fe,Xa),t($,Ns),t($,ee),c(lo,ee,null),t(ee,Fs),t(ee,Ya),t(ee,Ls),t(ee,en),t($,zs),t($,Le),c(io,Le,null),t(Le,qs),t(Le,tn),t($,Ms),t($,ze),c(so,ze,null),t(ze,Is),t(ze,on),t($,Rs),t($,qe),c(co,qe,null),t(qe,Es),t(qe,an),t($,Us),t($,Me),c(mo,Me,null),t(Me,Hs),t(Me,nn),t($,As),t($,Ie),c(po,Ie,null),t(Ie,Ks),t(Ie,rn),t($,Ss),t($,q),c(go,q,null),t(q,js),t(q,ln),t(q,Vs),t(q,sn),t(q,Ws),t(q,dn),v(e,xr,_),c(_o,e,_),v(e,$r,_),v(e,K,_),c(uo,K,null),t(K,Bs),t(K,cn),t(K,Gs),t(K,mn),v(e,Pr,_),c(ho,e,_),v(e,wr,_),v(e,O,_),c(fo,O,null),t(O,Js),t(O,pn),t(O,Zs),t(O,Re),c(vo,Re,null),t(Re,Qs),t(Re,gn),t(O,Xs),t(O,Ee),c(bo,Ee,null),t(Ee,Ys),t(Ee,_n),t(O,ed),t(O,Ue),c(Oo,Ue,null),t(Ue,td),t(Ue,un),t(O,od),t(O,He),c(To,He,null),t(He,ad),t(He,hn),t(O,nd),t(O,Ae),c(xo,Ae,null),t(Ae,rd),t(Ae,fn),t(O,ld),t(O,Ke),c($o,Ke,null),t(Ke,id),t(Ke,vn),t(O,sd),t(O,Se),c(Po,Se,null),t(Se,dd),t(Se,bn),t(O,cd),t(O,je),c(wo,je,null),t(je,md),t(je,On),t(O,pd),t(O,Ve),c(Co,Ve,null),t(Ve,gd),t(Ve,Tn),t(O,_d),t(O,We),c(yo,We,null),t(We,ud),t(We,xn),t(O,hd),t(O,Be),c(ko,Be,null),t(Be,fd),t(Be,$n),v(e,Cr,_),c(Do,e,_),v(e,yr,_),v(e,S,_),c(No,S,null),t(S,vd),t(S,Pn),t(S,bd),t(S,wn),v(e,kr,_),c(Fo,e,_),v(e,Dr,_),v(e,N,_),c(Lo,N,null),t(N,Od),t(N,Cn),t(N,Td),t(N,yn),t(N,xd),t(N,kn),t(N,$d),t(N,Dn),t(N,Pd),t(N,Ge),c(zo,Ge,null),t(Ge,wd),t(Ge,Nn),v(e,Nr,_),c(qo,e,_),v(e,Fr,_),v(e,oe,_),c(Mo,oe,null),t(oe,Cd),t(oe,Fn),v(e,Lr,_),c(Io,e,_),v(e,zr,_),v(e,ae,_),c(Ro,ae,null),t(ae,yd),t(ae,Ln),v(e,qr,_),c(Eo,e,_),v(e,Mr,_),v(e,Xn,_),Ir=!0},p:Pm,i(e){Ir||(m(Xe.$$.fragment,e),m(et.$$.fragment,e),m(tt.$$.fragment,e),m(ot.$$.fragment,e),m(at.$$.fragment,e),m(nt.$$.fragment,e),m(rt.$$.fragment,e),m(lt.$$.fragment,e),m(it.$$.fragment,e),m(st.$$.fragment,e),m(dt.$$.fragment,e),m(ct.$$.fragment,e),m(mt.$$.fragment,e),m(pt.$$.fragment,e),m(gt.$$.fragment,e),m(_t.$$.fragment,e),m(ut.$$.fragment,e),m(ht.$$.fragment,e),m(ft.$$.fragment,e),m(vt.$$.fragment,e),m(bt.$$.fragment,e),m(Ot.$$.fragment,e),m(Tt.$$.fragment,e),m(xt.$$.fragment,e),m($t.$$.fragment,e),m(Pt.$$.fragment,e),m(wt.$$.fragment,e),m(Ct.$$.fragment,e),m(yt.$$.fragment,e),m(kt.$$.fragment,e),m(Dt.$$.fragment,e),m(Nt.$$.fragment,e),m(Ft.$$.fragment,e),m(Lt.$$.fragment,e),m(zt.$$.fragment,e),m(qt.$$.fragment,e),m(Mt.$$.fragment,e),m(It.$$.fragment,e),m(Rt.$$.fragment,e),m(Et.$$.fragment,e),m(Ut.$$.fragment,e),m(Ht.$$.fragment,e),m(At.$$.fragment,e),m(Kt.$$.fragment,e),m(St.$$.fragment,e),m(jt.$$.fragment,e),m(Vt.$$.fragment,e),m(Wt.$$.fragment,e),m(Bt.$$.fragment,e),m(Gt.$$.fragment,e),m(Jt.$$.fragment,e),m(Zt.$$.fragment,e),m(Qt.$$.fragment,e),m(Xt.$$.fragment,e),m(Yt.$$.fragment,e),m(eo.$$.fragment,e),m(to.$$.fragment,e),m(oo.$$.fragment,e),m(ao.$$.fragment,e),m(no.$$.fragment,e),m(ro.$$.fragment,e),m(lo.$$.fragment,e),m(io.$$.fragment,e),m(so.$$.fragment,e),m(co.$$.fragment,e),m(mo.$$.fragment,e),m(po.$$.fragment,e),m(go.$$.fragment,e),m(_o.$$.fragment,e),m(uo.$$.fragment,e),m(ho.$$.fragment,e),m(fo.$$.fragment,e),m(vo.$$.fragment,e),m(bo.$$.fragment,e),m(Oo.$$.fragment,e),m(To.$$.fragment,e),m(xo.$$.fragment,e),m($o.$$.fragment,e),m(Po.$$.fragment,e),m(wo.$$.fragment,e),m(Co.$$.fragment,e),m(yo.$$.fragment,e),m(ko.$$.fragment,e),m(Do.$$.fragment,e),m(No.$$.fragment,e),m(Fo.$$.fragment,e),m(Lo.$$.fragment,e),m(zo.$$.fragment,e),m(qo.$$.fragment,e),m(Mo.$$.fragment,e),m(Io.$$.fragment,e),m(Ro.$$.fragment,e),m(Eo.$$.fragment,e),Ir=!0)},o(e){p(Xe.$$.fragment,e),p(et.$$.fragment,e),p(tt.$$.fragment,e),p(ot.$$.fragment,e),p(at.$$.fragment,e),p(nt.$$.fragment,e),p(rt.$$.fragment,e),p(lt.$$.fragment,e),p(it.$$.fragment,e),p(st.$$.fragment,e),p(dt.$$.fragment,e),p(ct.$$.fragment,e),p(mt.$$.fragment,e),p(pt.$$.fragment,e),p(gt.$$.fragment,e),p(_t.$$.fragment,e),p(ut.$$.fragment,e),p(ht.$$.fragment,e),p(ft.$$.fragment,e),p(vt.$$.fragment,e),p(bt.$$.fragment,e),p(Ot.$$.fragment,e),p(Tt.$$.fragment,e),p(xt.$$.fragment,e),p($t.$$.fragment,e),p(Pt.$$.fragment,e),p(wt.$$.fragment,e),p(Ct.$$.fragment,e),p(yt.$$.fragment,e),p(kt.$$.fragment,e),p(Dt.$$.fragment,e),p(Nt.$$.fragment,e),p(Ft.$$.fragment,e),p(Lt.$$.fragment,e),p(zt.$$.fragment,e),p(qt.$$.fragment,e),p(Mt.$$.fragment,e),p(It.$$.fragment,e),p(Rt.$$.fragment,e),p(Et.$$.fragment,e),p(Ut.$$.fragment,e),p(Ht.$$.fragment,e),p(At.$$.fragment,e),p(Kt.$$.fragment,e),p(St.$$.fragment,e),p(jt.$$.fragment,e),p(Vt.$$.fragment,e),p(Wt.$$.fragment,e),p(Bt.$$.fragment,e),p(Gt.$$.fragment,e),p(Jt.$$.fragment,e),p(Zt.$$.fragment,e),p(Qt.$$.fragment,e),p(Xt.$$.fragment,e),p(Yt.$$.fragment,e),p(eo.$$.fragment,e),p(to.$$.fragment,e),p(oo.$$.fragment,e),p(ao.$$.fragment,e),p(no.$$.fragment,e),p(ro.$$.fragment,e),p(lo.$$.fragment,e),p(io.$$.fragment,e),p(so.$$.fragment,e),p(co.$$.fragment,e),p(mo.$$.fragment,e),p(po.$$.fragment,e),p(go.$$.fragment,e),p(_o.$$.fragment,e),p(uo.$$.fragment,e),p(ho.$$.fragment,e),p(fo.$$.fragment,e),p(vo.$$.fragment,e),p(bo.$$.fragment,e),p(Oo.$$.fragment,e),p(To.$$.fragment,e),p(xo.$$.fragment,e),p($o.$$.fragment,e),p(Po.$$.fragment,e),p(wo.$$.fragment,e),p(Co.$$.fragment,e),p(yo.$$.fragment,e),p(ko.$$.fragment,e),p(Do.$$.fragment,e),p(No.$$.fragment,e),p(Fo.$$.fragment,e),p(Lo.$$.fragment,e),p(zo.$$.fragment,e),p(qo.$$.fragment,e),p(Mo.$$.fragment,e),p(Io.$$.fragment,e),p(Ro.$$.fragment,e),p(Eo.$$.fragment,e),Ir=!1},d(e){e&&(l(Yn),l(Qn),l(er),l(tr),l(Ye),l(or),l(ar),l(R),l(nr),l(rr),l(T),l(lr),l(ir),l(E),l(sr),l(dr),l(D),l(cr),l(mr),l(b),l(pr),l(gr),l(U),l(_r),l(ur),l(H),l(hr),l(fr),l(x),l(vr),l(br),l(A),l(Or),l(Tr),l($),l(xr),l($r),l(K),l(Pr),l(wr),l(O),l(Cr),l(yr),l(S),l(kr),l(Dr),l(N),l(Nr),l(Fr),l(oe),l(Lr),l(zr),l(ae),l(qr),l(Mr),l(Xn)),l(te),g(Xe,e),g(et,e),g(tt),g(ot,e),g(at),g(nt),g(rt),g(lt),g(it),g(st),g(dt),g(ct),g(mt),g(pt),g(gt),g(_t,e),g(ut),g(ht,e),g(ft),g(vt),g(bt),g(Ot),g(Tt),g(xt,e),g($t),g(Pt),g(wt),g(Ct),g(yt),g(kt),g(Dt),g(Nt),g(Ft),g(Lt),g(zt),g(qt),g(Mt),g(It,e),g(Rt),g(Et),g(Ut,e),g(Ht),g(At,e),g(Kt),g(St),g(jt),g(Vt),g(Wt),g(Bt),g(Gt),g(Jt),g(Zt),g(Qt),g(Xt),g(Yt,e),g(eo),g(to,e),g(oo),g(ao),g(no),g(ro),g(lo),g(io),g(so),g(co),g(mo),g(po),g(go),g(_o,e),g(uo),g(ho,e),g(fo),g(vo),g(bo),g(Oo),g(To),g(xo),g($o),g(Po),g(wo),g(Co),g(yo),g(ko),g(Do,e),g(No),g(Fo,e),g(Lo),g(zo),g(qo,e),g(Mo),g(Io,e),g(Ro),g(Eo,e)}}}const Fm='{"title":"Trainer","local":"trainer","sections":[{"title":"CPOConfig","local":"trl.CPOConfig","sections":[],"depth":2},{"title":"CPOTrainer","local":"trl.CPOTrainer","sections":[],"depth":2},{"title":"DDPOConfig","local":"trl.DDPOConfig","sections":[],"depth":2},{"title":"DDPOTrainer","local":"trl.DDPOTrainer","sections":[],"depth":2},{"title":"DPOTrainer","local":"trl.DPOTrainer","sections":[],"depth":2},{"title":"IterativeSFTTrainer","local":"trl.IterativeSFTTrainer","sections":[],"depth":2},{"title":"KTOConfig","local":"trl.KTOConfig","sections":[],"depth":2},{"title":"KTOTrainer","local":"trl.KTOTrainer","sections":[],"depth":2},{"title":"ORPOConfig","local":"trl.ORPOConfig","sections":[],"depth":2},{"title":"ORPOTrainer","local":"trl.ORPOTrainer","sections":[],"depth":2},{"title":"PPOConfig","local":"trl.PPOConfig","sections":[],"depth":2},{"title":"PPOTrainer","local":"trl.PPOTrainer","sections":[],"depth":2},{"title":"RewardConfig","local":"trl.RewardConfig","sections":[],"depth":2},{"title":"RewardTrainer","local":"trl.RewardTrainer","sections":[],"depth":2},{"title":"SFTTrainer","local":"trl.SFTTrainer","sections":[],"depth":2},{"title":"set_seed","local":"trl.set_seed","sections":[],"depth":2}],"depth":1}';function Lm(kd){return wm(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Rm extends Cm{constructor(te){super(),ym(this,te,Lm,Nm,$m,{})}}export{Rm as component};
